require "behaviours/runaway"
require "behaviours/wander"
require "behaviours/doaction"
require "behaviours/findflower"
require "behaviours/panic"
require "behaviours/follow"
require "behaviours/wander"

local RUN_AWAY_DIST = 5
local STOP_RUN_AWAY_DIST = 10
local POLLINATE_FLOWER_DIST = 10
local SEE_FLOWER_DIST = 30
local MAX_WANDER_DIST = 20
local MIN_FOLLOW = 4
local MAX_FOLLOW = 11
local MED_FOLLOW = 6
local MAX_CHASE_TIME = 6

local FriendlyButterflyBrain = Class(Brain, function(self, inst)
    Brain._ctor(self, inst)
end)

function FriendlyButterflyBrain:OnStart()
    
    local root =
        PriorityNode(
        {
		    Follow(self.inst, function() return self.inst.components.follower.leader end, MIN_FOLLOW, MED_FOLLOW, MAX_FOLLOW, true),
            WhileNode( function() return self.inst.components.health.takingfiredamage end, "OnFire", Panic(self.inst)),
            RunAway(self.inst, "monster", RUN_AWAY_DIST, STOP_RUN_AWAY_DIST),
            FindFlower(self.inst)           
        },1)
    
    self.bt = BT(self.inst, root)
    
end

return FriendlyButterflyBrain