require "behaviours/chaseandattack"
require "behaviours/runaway"
require "behaviours/wander"
require "behaviours/doaction"
require "behaviours/panic"

local MAX_CHASE_DIST = 999
local MAX_CHASE_TIME = 999

local MayBeeBeeBrain = Class(Brain, function(self, inst)
    Brain._ctor(self, inst)
end)

function MayBeeBeeBrain:OnStart()
    local root = PriorityNode(
    {
        WhileNode( function() return self.inst.persists and (self.inst.components.combat.target == nil or not self.inst.components.combat:InCooldown()) end, "AttackMomentarily", ChaseAndAttack(self.inst, MAX_CHASE_TIME, MAX_CHASE_DIST) ),
    }, 1)

    self.bt = BT(self.inst, root)
end

return MayBeeBeeBrain
