local AutoShadowAbsorber = Class(function(self, inst)
	self.inst = inst
	self.cooldowntime = 0 
end)

function AutoShadowAbsorber:OnSave()
    return 
	{
		enabled = self.enabled,
	}
end 

function AutoShadowAbsorber:OnLoad(data)
    if data ~= nil then
	    if data.enabled then
		    self:Enable(true)
		else
		    self:Enable(false)
		end 
	end
end

function AutoShadowAbsorber:Enable(enable)
	if enable then
	    self.enabled = true
		self.inst:StartUpdatingComponent(self)
	else
	    self.enabled = false
		self.inst:StopUpdatingComponent(self)
	end
end

function AutoShadowAbsorber:CheckIfCanEnable()
    if self.inst:HasTag("shadow_form_on") and self.inst.shadowmanipulation then
	    self:Enable(true) 
	else
	    self:Enable(false) 
	end
end 

function AutoShadowAbsorber:OnUpdate(dt)
    if self.cooldowntime > 0 then
	    self.cooldowntime = self.cooldowntime - dt
		return
	end 
	local x, y, z = self.inst.Transform:GetWorldPosition() 
	local shadows = TheSim:FindEntities(x, y, z, 4, {"darkitem"}, {"FX", "NOCLICK", "INLIMBO", "INTERIOR_LIMBO", "notarget"})
	for k,v in pairs(shadows) do
	    if v ~= nil 
		    and v.prefab ~= nil 
			and v.prefab ~= "" 
			and v:IsValid() 
			and v.entity:IsVisible() 
			and v.components.inventoryitem ~= nil 
			and self.inst.components.inventory ~= nil 
			and not self.inst.components.inventory:IsFull() 
		then 
		    self.inst.components.inventory:GiveItem(v, nil, Vector3(TheSim:GetScreenPos(v.Transform:GetWorldPosition()))) 
			self.cooldowntime = 3
		end
	end
end

return AutoShadowAbsorber 