--WARNING: FAULTINESS--
local AutoTerraformer = Class(function(self, inst)
    assert(inst.components.container ~= nil, "AutoTerraformer requires the Container component")
    self.inst = inst

    self.repeat_tile_delay = TUNING.AUTOTERRAFORMER_REPEAT_DELAY

    --self.onfinishterraformingfn = nil

    self.container = inst.components.container
end)

local GROUND_TURFS_VANILLA =
{
	[GROUND.ROCKY]		= "turf_rocky",
	[GROUND.ROAD]		= "turf_road",
	[GROUND.DIRT]		= "turf_dirt",
	[GROUND.SAVANNA]	= "turf_savanna",
	[GROUND.GRASS]		= "turf_grass",
	[GROUND.FOREST]		= "turf_forest",
	[GROUND.MARSH]		= "turf_marsh",
	[GROUND.WOODFLOOR]	= "turf_woodfloor",
	[GROUND.CARPET]		= "turf_carpetfloor",
	[GROUND.CHECKER]	= "turf_checkerfloor",
	
	[GROUND.CAVE]		= "turf_cave",
	[GROUND.FUNGUS]		= "turf_fungus",
	[GROUND.FUNGUSRED]	= "turf_fungus_red",
	[GROUND.FUNGUSGREEN]= "turf_fungus_green",
	
	[GROUND.SINKHOLE]	= "turf_sinkhole",
	[GROUND.UNDERROCK]	= "turf_underrock",
	[GROUND.MUD]		= "turf_mud",

	webbing				= "turf_webbing",
}

local GROUND_TURFS_WITH_ROG =
{
	[GROUND.ROCKY]		= "turf_rocky",
	[GROUND.ROAD]		= "turf_road",
	[GROUND.DIRT]		= "turf_dirt",
	[GROUND.SAVANNA]	= "turf_savanna",
	[GROUND.GRASS]		= "turf_grass",
	[GROUND.FOREST]		= "turf_forest",
	[GROUND.MARSH]		= "turf_marsh",
	[GROUND.WOODFLOOR]	= "turf_woodfloor",
	[GROUND.CARPET]		= "turf_carpetfloor",
	[GROUND.CHECKER]	= "turf_checkerfloor",
	
	[GROUND.CAVE]		= "turf_cave",
	[GROUND.FUNGUS]		= "turf_fungus",
	[GROUND.FUNGUSRED]	= "turf_fungus_red",
	[GROUND.FUNGUSGREEN]= "turf_fungus_green",
	
	[GROUND.SINKHOLE]	= "turf_sinkhole",
	[GROUND.UNDERROCK]	= "turf_underrock",
	[GROUND.MUD]		= "turf_mud",

	[GROUND.DESERT_DIRT]= "turf_desertdirt",
	[GROUND.DECIDUOUS]	= "turf_deciduous",

	webbing				= "turf_webbing",
}

local GROUND_TURFS_WITH_SW =
{
	[GROUND.ROCKY]		= "turf_rocky",
	[GROUND.ROAD]		= "turf_road",
	[GROUND.DIRT]		= "turf_dirt",
	[GROUND.SAVANNA]	= "turf_savanna",
	[GROUND.GRASS]		= "turf_grass",
	[GROUND.FOREST]		= "turf_forest",
	[GROUND.MARSH]		= "turf_marsh",
	[GROUND.WOODFLOOR]	= "turf_woodfloor",
	[GROUND.CARPET]		= "turf_carpetfloor",
	[GROUND.CHECKER]	= "turf_checkerfloor",
	
	[GROUND.CAVE]		= "turf_cave",
	[GROUND.FUNGUS]		= "turf_fungus",
	[GROUND.FUNGUSRED]	= "turf_fungus_red",
	[GROUND.FUNGUSGREEN]= "turf_fungus_green",
	
	[GROUND.SINKHOLE]	= "turf_sinkhole",
	[GROUND.UNDERROCK]	= "turf_underrock",
	[GROUND.MUD]		= "turf_mud",

	[GROUND.DESERT_DIRT]= "turf_desertdirt",
	[GROUND.DECIDUOUS]	= "turf_deciduous",

	[GROUND.BEACH]		= "turf_beach",
	[GROUND.JUNGLE]		= "turf_jungle",
	[GROUND.SWAMP]		= "turf_swamp",

	[GROUND.MAGMAFIELD] = "turf_magmafield",
	[GROUND.TIDALMARSH] = "turf_tidalmarsh",
	[GROUND.MEADOW]		= "turf_meadow",
	[GROUND.VOLCANO]	= "turf_volcano",
	[GROUND.ASH]		= "turf_ash",
	[GROUND.SNAKESKIN]  = "turf_snakeskinfloor",
	webbing				= "turf_webbing",
}

local GROUND_TURFS_WITH_HAM =
{
	[GROUND.ROCKY]		= "turf_rocky",
	[GROUND.ROAD]		= "turf_road",
	[GROUND.DIRT]		= "turf_dirt",
	[GROUND.SAVANNA]	= "turf_savanna",
	[GROUND.GRASS]		= "turf_grass",
	[GROUND.FOREST]		= "turf_forest",
	[GROUND.MARSH]		= "turf_marsh",
	[GROUND.WOODFLOOR]	= "turf_woodfloor",
	[GROUND.CARPET]		= "turf_carpetfloor",
	[GROUND.CHECKER]	= "turf_checkerfloor",
	
	[GROUND.CAVE]		= "turf_cave",
	[GROUND.FUNGUS]		= "turf_fungus",
	[GROUND.FUNGUSRED]	= "turf_fungus_red",
	[GROUND.FUNGUSGREEN]= "turf_fungus_green",
	
	[GROUND.SINKHOLE]	= "turf_sinkhole",
	[GROUND.UNDERROCK]	= "turf_underrock",
	[GROUND.MUD]		= "turf_mud",

	[GROUND.DESERT_DIRT]= "turf_desertdirt",
	[GROUND.DECIDUOUS]	= "turf_deciduous",

	[GROUND.BEACH]		= "turf_beach",
	[GROUND.JUNGLE]		= "turf_jungle",
	[GROUND.SWAMP]		= "turf_swamp",

	[GROUND.MAGMAFIELD] = "turf_magmafield",
	[GROUND.TIDALMARSH] = "turf_tidalmarsh",
	[GROUND.MEADOW]		= "turf_meadow",
	[GROUND.VOLCANO]	= "turf_volcano",
	[GROUND.ASH]		= "turf_ash",
	[GROUND.SNAKESKIN]  = "turf_snakeskinfloor",
	
	[GROUND.PIGRUINS]	= "cutstone",
	[GROUND.PIGRUINS_NOCANOPY]	= "cutstone",
	[GROUND.RAINFOREST]	= "turf_rainforest",
	[GROUND.DEEPRAINFOREST]	= "turf_deeprainforest",
	[GROUND.GASJUNGLE]	= "turf_gasjungle",
	[GROUND.SUBURB]	= "turf_moss",

	[GROUND.FIELDS]	= "turf_fields",
	[GROUND.FOUNDATION]	= "turf_foundation",
	[GROUND.COBBLEROAD]	= "turf_cobbleroad",	
	[GROUND.LAWN]	= "turf_lawn",	
	[GROUND.BEARDRUG]	= "turf_beard_hair",

	[GROUND.PLAINS]	= "turf_plains",	
	[GROUND.PAINTED]	= "turf_painted",		
	
	[GROUND.DEEPRAINFOREST_NOCANOPY]	= "turf_deeprainforest_nocanopy",
	
	webbing				= "turf_webbing",
}

function AutoTerraformer:CanPlaceTurfAtPoint(x, y, z)
    if GetWorld() and GetWorld().Map then
		local tile = GetWorld().Map:GetTileAtPoint(x, y, z)
		return tile == GROUND.DIRT
	end
	return false
end

function AutoTerraformer:CanTerraformAtPoint(x, y, z)
    if GetWorld() and GetWorld().Map then
		local tile = GetWorld().Map:GetTileAtPoint(x, y, z)
		local HasSWorHAM = IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC)		
		return tile ~= GROUND.IMPASSIBLE 
		        and tile ~= GROUND.DIRT 
				and tile < GROUND.UNDERGROUND 
				and not (HasSWorHAM and GetWorld().Map:IsWater(tile)) 
				and not (IsDLCEnabled(PORKLAND_DLC) and (tile == GROUND.DEEPRAINFOREST or tile == GROUND.GASJUNGLE))
	end
	return false
end

function AutoTerraformer:FinishTerraforming(x, y, z)
	self.inst:PushEvent("onterraform")

    if self.inst.components.finiteuses then
        self.inst.components.finiteuses:Use()
    end

    if self.onfinishterraformingfn then
        self.onfinishterraformingfn(self.inst, x, y, z)
    end
end

local function SpawnTurf( turf, x, y, z )
	if turf then
		local loot = SpawnPrefab(turf)
		loot.Transform:SetPosition(x, y, z)
		if loot.Physics then
			local angle = math.random()*2*math.pi
			loot.Physics:SetVel(2*math.cos(angle), 10, 2*math.sin(angle))
		end
	end
end

function AutoTerraformer:DoTerraform(px, py, pz, x, y)
    local px, py, pz = GetPlayer().Transform:GetWorldPosition()
    --local x, y = (IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC)) and GetWorld().Map:GetTileXYAtPoint(px, py, pz) or GetWorld().Map:GetTileCoordsAtPoint(px, py, pz)

    local map = GetWorld().Map

    local item_tile = nil
    local item = self.container:GetItemInSlot(1)
    if item and item.data and item.data.tile and item.data.tile ~= nil then
        item_tile = item.data.tile
    end
	--local original_tile_type = nil
    --if GetWorld() and GetWorld().Map and GetWorld().Map.GetTileAtPoint then
    --    original_tile_type = GetWorld().Map:GetTileAtPoint(px, py, pz) --Here will cause an assert...
	--end
	local x, y = GetWorld().Map:GetTileCoordsAtPoint(px, py, pz)
	local original_tile_type = map:GetTile(x, y) --Here will cause an assert...
    if item_tile == original_tile_type then
        return
    end

    --place our turf if we can do that
    if item_tile ~= nil and self:CanPlaceTurfAtPoint(px, py, pz) then
        self.container:RemoveItem(item, false):Remove()
        map:SetTile(x, y, item_tile)
        self:FinishTerraforming(px, py, pz)
        return
    end

	if not self:CanTerraformAtPoint(px, py, pz) then
        return
    end

    --local underneath_tile = GetWorld().components.undertile:GetTileUnderneath(x, y)
    --if underneath_tile then
    --    map:SetTile(x, y, underneath_tile)
    --else
    if item_tile then
        self.container:RemoveItem(item, false):Remove()
    end
    map:SetTile(x, y, item_tile or GROUND.DIRT)
   -- end
	map:RebuildLayer( original_tile_type, x, y )
	map:RebuildLayer( GROUND.DIRT, x, y )
	
	local minimap = TheSim:FindFirstEntityWithTag("minimap")
	if minimap then
		minimap.MiniMap:RebuildLayer( original_tile_type, x, y )
		minimap.MiniMap:RebuildLayer( GROUND.DIRT, x, y )
	end
	
	local GROUND_TURFS = GROUND_TURFS_VANILLA
	if IsDLCEnabled(REIGN_OF_GIANTS) then
	    GROUND_TURFS = GROUND_TURFS_WITH_ROG
	elseif IsDLCEnabled(CAPY_DLC) then
	    GROUND_TURFS = GROUND_TURFS_WITH_SW
	elseif IsDLCEnabled(PORKLAND_DLC) then
	    GROUND_TURFS = GROUND_TURFS_WITH_HAM
	end
	SpawnTurf( GROUND_TURFS[original_tile_type], px, py, pz )
	
    --HandleDugGround(original_tile_type, px, py, pz)

    --for _, ent in ipairs(GetWorld().Map:GetEntitiesOnTileAtPoint(px, py, pz)) do
    --    if ent:HasTag("soil") then
    --        ent:PushEvent("collapsesoil")
    --    end
    --end

    self:FinishTerraforming(px, py, pz)

    return true
    --return underneath_tile ~= nil
end

function AutoTerraformer:StartTerraforming()
    self.last_x, self.last_y, self.repeat_delay = nil, nil, nil
    self.inst:StartUpdatingComponent(self)
end

function AutoTerraformer:StopTerraforming()
    self.inst:StopUpdatingComponent(self)
end

function AutoTerraformer:OnUpdate(dt)
    local px, py, pz = self.inst.Transform:GetWorldPosition()
    --local x, y = (IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC)) and GetWorld().Map:GetTileXYAtPoint(px, py, pz) or GetWorld().Map:GetTileAtPoint(px, py, pz)
    local x, y = GetWorld().Map:GetTileCoordsAtPoint(px, py, pz)
    if self.repeat_delay ~= nil then
        self.repeat_delay = math.max(self.repeat_delay - dt, 0)
    end

    if (self.last_x == nil and self.last_y == nil) or
    (self.last_x ~= x or self.last_y ~= y) or
    (self.last_x == x and self.last_y == y and self.repeat_delay == 0) then
        self.repeat_delay = nil
        local repeat_tile = self:DoTerraform(px, py, pz, x, y)

        self.last_x, self.last_y = x, y
        if repeat_tile then
            self.repeat_delay = self.repeat_tile_delay
        end
    end
end

return AutoTerraformer
--WARNING: FAULTINESS--