local Butternearbymobs = Class(function(self, inst)
    self.inst = inst
end)

function Butternearbymobs:OnEntitySleep()
    self.inst:StopUpdatingComponent(self)
end

function Butternearbymobs:OnEntityWake()
    self.inst:StartUpdatingComponent(self)
end

local BUTTER_MUST_TAGS = { "locomotor" }
local BUTTER_CANT_TAGS = { "FX", "NOCLICK", "INLIMBO", "INTERIOR_LIMBO", "flying", "ghost", "shadow", "notarget", "plant_mob", "buttercup" }

function Butternearbymobs:OnUpdate(dt)
    local x, y, z = self.inst.Transform:GetWorldPosition()
    for i, v in pairs(TheSim:FindEntities(x, y, z, 2.5, BUTTER_MUST_TAGS, BUTTER_CANT_TAGS)) do
        if v ~= nil
		    and v:IsValid() 
		    and v.entity:IsVisible() 
			and v.components.locomotor ~= nil 
			and self.inst.components.combat:CanTarget(v) 
			and (v.components.freezable == nil or not v.components.freezable:IsFrozen())
			and self.inst.persists
		then
		    self.inst.SoundEmitter:PlaySound("dontstarve/common/butterfly_trap")	
            self.inst:ButterPuddleDisappear()
            if v.components.combat ~= nil then	
			    v.components.combat:GetAttacked(self.inst, (self.inst.from_plant_food and (self.inst.damage_pf or TUNING.BUTTERCUP_DAMAGE_PF)) or (self.inst.damage or TUNING.BUTTERCUP_DAMAGE))
			end
			if v.components.freezable ~= nil then
			    v.components.freezable:Freeze((self.inst.from_plant_food and (self.inst.stun_pf or TUNING.BUTTERCUP_STUN_DURATION_PF)) or (self.inst.stun or TUNING.BUTTERCUP_STUN_DURATION))
			end
			self.inst:StopUpdatingComponent(self)
		end
    end
end

return Butternearbymobs