local Caneflowerfxspawner = Class(function(self, inst)
    self.inst = inst      
    self.water = false   
    self.range = 1 
    self.max = 5
    self.enabled = false
    self.rate = 1
    self.tags = {}
    self.notags = {}
end)

function Caneflowerfxspawner:SetPrefab(prefab)
    self.prefab = prefab
end

function Caneflowerfxspawner:SetRange(range)
    self.range = range
end

function Caneflowerfxspawner:SetMax(max)
    self.max = max
end

function Caneflowerfxspawner:SetRate(rate)
    self.rate = rate
end

function Caneflowerfxspawner:SetNotTiles(notiles)
    self.notiles = notiles
end

function Caneflowerfxspawner:Process()
    local x, y, z = self.inst.Transform:GetWorldPosition()
    local ents = TheSim:FindEntities(x, y, z, self.range, self.tags, self.notags)

    if #ents < self.max then
        local dist = math.random() * self.range
        local angle = math.random() * 2 * math.pi

        local offset = Vector3(dist * math.cos( angle ), 0, -dist * math.sin( angle ))

        local newpt = Vector3(x+offset.x, y+offset.y, z+offset.z)

        if self.notiles then 
            local tile = GetWorld().Map:GetTileAtPoint(newpt.x, newpt.y, newpt.z)
            if not self.water and self.inst.IsPosSurroundedByLand ~= nil and not self.inst:IsPosSurroundedByLand(newpt.x, newpt.y, newpt.z, 1) then
                return
            end
            for i,testtile in ipairs(self.notiles) do
                if tile == testtile then
                    --print("ABORT")
                    return
                end
            end
        end

        local paint = SpawnPrefab(self.prefab)
        paint.Transform:SetPosition(newpt.x, newpt.y, newpt.z)
    end
end

function Caneflowerfxspawner:Enable(val)
    if self.enabled ~= val then
        self.enabled = val
        if self.enabled then        
            self.task = self.inst:DoPeriodicTask(self.rate, function() self:Process() end)
        else
            if self.task then
                self.task:Cancel()
                self.task = nil
            end
        end
    end
end

return Caneflowerfxspawner