local CharlieAreaFireDamage = Class(function(self, inst)
    self.inst = inst
end)

function CharlieAreaFireDamage:OnEntitySleep()
    self.inst:StopUpdatingComponent(self)
end

function CharlieAreaFireDamage:OnEntityWake()
    self.inst:StartUpdatingComponent(self)
end

function CharlieAreaFireDamage:OnUpdate(dt)
    local x, y, z = self.inst.Transform:GetWorldPosition()
    for i, v in pairs(TheSim:FindEntities(x, y, z, 3, {"hascombatcomponent"}, {"NOCLICK", "FX", "INLIMBO", "INTERIOR_LIMBO", "player", "charliecritter", "companion", "wall", "structure", "notarget"})) do
        if v ~= nil	and v:IsValid() and v.entity:IsVisible() then
		    SpawnPrefab("explode_small").Transform:SetPosition(self.inst.Transform:GetWorldPosition())
			if self.inst.SoundEmitter ~= nil then 
		        self.inst.SoundEmitter:PlaySound("dontstarve/common/fireOut")	
			end
		    if v.components.health ~= nil then
			    v.components.health:DoFireDamage(15, self.inst, true)
			end		
			self.inst:StopUpdatingComponent(self)
            self.inst:Remove()
		end
    end
end

return CharlieAreaFireDamage