local CharlieCoffeeMaker = Class(function(self, inst)
    self.inst = inst
end)

function CharlieCoffeeMaker:GetIngredient()
    if self.custome_ingredient_fn ~= nil then
	    return self.custome_ingredient_fn(self.inst)
	end 
    return type(self.inst.taffy_inside) == "number" and self.inst.taffy_inside > 0 and "taffy"..self.inst.taffy_inside or nil, 
	    type(self.inst.honey_inside) == "number" and self.inst.honey_inside > 0 and "honey"..self.inst.honey_inside or nil
end

function CharlieCoffeeMaker:ExtractIngredient(doer)
    if self.custome_extract_fn ~= nil then
        self.custome_extract_fn(self.inst, doer)
    else
        local ingredient1, ingredient2 = self:GetIngredient() 
	    if ((type(ingredient1) == "string" and ingredient1:sub(1, 5) == "taffy")
		    or (type(ingredient2) == "string" and ingredient2:sub(1, 5) == "honey"))
	        and self.inst.components.inventory ~= nil
        then
		    self.inst.components.inventory:DropEverything()
	    	self.inst.taffy_inside = 0
	     	self.inst.honey_inside = 0
	    elseif doer ~= nil and doer.components.talker ~= nil then
	        doer.components.talker:Say(STRINGS.CHARLIE_EXTRACT_FAIL or "")
	    end
    end
end

function CharlieCoffeeMaker:TryToMakeCoffee(doer)
    if self.custome_try_to_make_coffee_fn ~= nil then
        self.custome_try_to_make_coffee_fn(self.inst, doer)
	else
        local ingredient1, ingredient2 = self:GetIngredient() 
	    if ingredient1 == "taffy1" and ingredient2 == "honey3" then
	        --Do nothing
	    elseif doer ~= nil and doer.components.talker ~= nil then
	        doer.components.talker:Say(STRINGS.CHARLIE_MAKE_COFFEE_FAIL or "")
			if doer.sg ~= nil then
			    doer.sg:GoToState("idle")
			end
	    end
    end
end

function CharlieCoffeeMaker:MakeCoffee(doer)
    if self.custome_make_coffee_fn ~= nil then
        self.custome_make_coffee_fn(self.inst, doer)
	else
        local ingredient1, ingredient2 = self:GetIngredient() 
	    if ingredient1 == "taffy1" and ingredient2 == "honey3" then
	        local coffee_spoilage = 1
			local spoilage_total = 0
			local spoilage_n = 0
			
			if self.inst.components.inventory ~= nil then
			    for k,v in pairs(self.inst.components.inventory.itemslots) do
				    if v.components.perishable ~= nil then
					    spoilage_n = spoilage_n + 1
					    spoilage_total = spoilage_total + v.components.perishable:GetPercent()
						local item = self.inst.components.inventory:RemoveItem(v, true)
						if item ~= nil then
						    item:Remove()
	    	                self.inst.taffy_inside = 0
	     	                self.inst.honey_inside = 0							
						end
				    end
			    end
			    if spoilage_total > 0 then
				    coffee_spoilage = spoilage_total / spoilage_n
				    coffee_spoilage = 1 - (1 - coffee_spoilage)*0.5
			    end				
			end
			
			if self.inst.components.lootdropper ~= nil then
			    local coffee = self.inst.components.lootdropper:SpawnLootPrefab("charlie_coffee")
			    if coffee ~= nil then
				    if coffee.components.perishable ~= nil then
					    coffee.components.perishable:SetPercent(coffee_spoilage)
					end 
					if coffee.components.stackable ~= nil and math.random() < 0.1 then
					    coffee.components.stackable:SetStackSize(2)
					end
				end 
			end
			
	    elseif doer ~= nil and doer.components.talker ~= nil then
	        doer.components.talker:Say(STRINGS.CHARLIE_MAKE_COFFEE_FAIL or "")
	    end
    end
end

function CharlieCoffeeMaker:CollectSceneActions(doer, actions, right)
	if right 
	    and doer ~= nil
		and doer:HasTag("charlie") 
	    and type(self.inst.level) == "number"
		and self.inst.level == 3
		and not TheInput:IsKeyDown(KEY_CTRL)
	then 
		table.insert(actions, ACTIONS.MAKECHARLIECOFFEE)
	end
	
	if right 
	    and doer ~= nil
		and doer:HasTag("charlie") 
	    and type(self.inst.level) == "number"
		and self.inst.level == 3
		and TheInput:IsKeyDown(KEY_CTRL)
	then 
		table.insert(actions, ACTIONS.EXTRACTINGREDIENT)
	end
end

return CharlieCoffeeMaker