
CHARLIEREFRESHMOD_GLOBAL_MASTERY_LEVEL_REQUIREMENTS_DATA = 
{
    {
        1, 5, 10, 15, 20, 25, 30, 35, 40, 45,
		50, 55, 60, 65, 70, 75, 80, 85, 90, 95,
		100, 105, 110, 115, 120, 125, 130, 135, 140, 145,
		150, 155, 160, 165, 170, 175, 180, 185, 190, 195,
		200, 1, 5, 10, 15, 20, 25, 30, 35, 40, 
		45, 50, 55, 60, 65, 70, 75, 80, 85, 90,
		95, 100, 105, 110, 115, 120, 125, 130, 135, 140,
		145, 150, 155, 160, 165, 170, 175, 180, 185, 190,
		195, 200, 1, 5, 10, 15, 20, 25, 30, 35,
		40, 45, 50, 55, 60, 65, 70, 75, 80, 85,
		90, 95, 100, 105, 110, 115, 120, 125, 130, 135,
		140, 145, 150, 155, 160, 165, 170, 175, 180, 185,
		190, 195, 200, 1, 5, 10, 15, 20, 25, 30,
		35, 40, 45, 50, 55, 60, 65, 70, 75, 80,
		85, 90, 95, 100, 105, 110, 115, 120, 125, 130,
		135, 140, 145, 150, 155, 160, 165, 170, 175, 180,
		185, 190, 195, 200, 1, 5, 10, 15, 20, 25,
		30, 35, 40, 45, 50, 55, 60, 65, 70, 75,
		80, 85, 90, 95, 100, 105, 110, 115, 120, 125,
		130, 135, 140, 145, 150, 155, 160, 165, 170, 175,
    },
}

local CharlieRefreshModLevel = Class(function(self, inst)
    self.inst = inst
	self.current_level = 1
	self.max_level = 10
	self.current_exp = 0
end)

function CharlieRefreshModLevel:OnSave()
    return 
	{
		current_level = self.current_level,
		current_mastery_level = self.current_mastery_level,
		current_exp = self.current_exp,
	}
end

function CharlieRefreshModLevel:OnLoad(data)
    if data ~= nil then
	    if data.current_level then
		    self.current_level = data.current_level
			self:UpdateData()
		end
	    if data.current_mastery_level then
		    self.current_mastery_level = data.current_mastery_level
			self:UpdateData()
		end	
		if data.current_exp then
		    self.current_exp = data.current_exp
		end
	end
end


function CharlieRefreshModLevel:SetLevelData(data)
    self.level_data = data
end

function CharlieRefreshModLevel:SetMaxLevel(v)
    self.max_level = v
end

function CharlieRefreshModLevel:SetLevel(v)
    self.current_level = v
end

function CharlieRefreshModLevel:GetLevel()
    return self.current_level
end

function CharlieRefreshModLevel:GetExp()
    return self.current_exp
end

function CharlieRefreshModLevel:GetLevelData()
    return self.level_data
end

function CharlieRefreshModLevel:EnableMastery(v)
    self.HasMastery = v
    self.max_mastery_level = v and 200 or nil
end

function CharlieRefreshModLevel:SetRequiredConsumables(v)
    self.RequiredConsumables = v
end

function CharlieRefreshModLevel:LevelUp()
    self.current_level = math.min(self.current_level + 1, self.max_level)
end

function CharlieRefreshModLevel:MasteryLevelUp()
    self.current_mastery_level = math.min(self.current_mastery_level + 1, self.max_mastery_level)
end

function CharlieRefreshModLevel:SetAdditionalUpdateFn(v)
    self.additional_update_fn = v
end

function CharlieRefreshModLevel:UpdateData()
    if self.level_data ~= nil then
	    local PREFIX = string.upper(self.inst.prefab)
	    if self.inst.components.health ~= nil 
		    and self.level_data[PREFIX.."_LEVEL_DATA"] ~= nil 
			and self.level_data[PREFIX.."_LEVEL_DATA"]["HEALTH"] ~= nil 
		then
            if not self.inst:HasTag("shadow_form_on") then
			    self.inst.components.health.maxhealth = self.level_data[PREFIX.."_LEVEL_DATA"]["HEALTH"][self.current_level] --do not use SetMaxHealth as it will override currenthealth
				self.inst.components.health:DoDelta(0)  --to update hud
			elseif self.level_data[PREFIX.."_LEVEL_DATA"]["HEALTH_SHADOW"] ~= nil then
			    self.inst.components.health.maxhealth = self.level_data[PREFIX.."_LEVEL_DATA"]["HEALTH_SHADOW"][self.current_level] 
				self.inst.components.health:DoDelta(0)  		
			end
		end

	    if self.inst.components.hunger ~= nil 
		    and self.level_data[PREFIX.."_LEVEL_DATA"] ~= nil 
			and self.level_data[PREFIX.."_LEVEL_DATA"]["HUNGER"] ~= nil 
		then
		    self.inst.components.hunger.max = self.level_data[PREFIX.."_LEVEL_DATA"]["HUNGER"][self.current_level] 
			self.inst.components.hunger:DoDelta(0)  
		end		
		
	    if self.inst.components.sanity ~= nil 
		    and self.level_data[PREFIX.."_LEVEL_DATA"] ~= nil 
			and self.level_data[PREFIX.."_LEVEL_DATA"]["SANITY"] ~= nil 
		then
		    self.inst.components.sanity.max = self.level_data[PREFIX.."_LEVEL_DATA"]["SANITY"][self.current_level] 
			self.inst.components.sanity:DoDelta(0)  
		end	
		
		if self.level_data[PREFIX.."_LEVEL_DATA"] ~= nil 
		    and self.level_data[PREFIX.."_LEVEL_DATA"]["DAMAGE"] ~= nil 
		then
		    if self.inst.components.combat ~= nil then
			    self.inst.components.combat:SetDefaultDamage(self.level_data[PREFIX.."_LEVEL_DATA"]["DAMAGE"][self.current_level])
			end
		    if self.inst.components.inventory ~= nil 
			    and self.inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) ~= nil
				and self.inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS).components.weapon ~= nil
			then
			    self.inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS).components.weapon:SetDamage(self.level_data[PREFIX.."_LEVEL_DATA"]["DAMAGE"][self.current_level])
			end
			if self.inst.SetNomralDamage ~= nil then
			    self.inst:SetNomralDamage(self.level_data[PREFIX.."_LEVEL_DATA"]["DAMAGE"][self.current_level])
			end
		end
		
		if self.inst.SetPlantFoodDamage ~= nil
	        and self.level_data[PREFIX.."_LEVEL_DATA"] ~= nil 
		    and self.level_data[PREFIX.."_LEVEL_DATA"]["DAMAGE_PF"] ~= nil 	
		then
		    self.inst:SetPlantFoodDamage(self.level_data[PREFIX.."_LEVEL_DATA"]["DAMAGE_PF"][self.current_level])
		end
		
		if self.inst.SetDamageMult ~= nil
		    and self.level_data[PREFIX.."_LEVEL_DATA"] ~= nil 
			and self.level_data[PREFIX.."_LEVEL_DATA"]["DAMAGE_MULT"] ~= nil 	
		then	
		    self.inst:SetDamageMult(self.level_data[PREFIX.."_LEVEL_DATA"]["DAMAGE_MULT"][self.current_level])
		end

		if self.inst.SetDamageMultShadow ~= nil
		    and self.level_data[PREFIX.."_LEVEL_DATA"] ~= nil 
			and self.level_data[PREFIX.."_LEVEL_DATA"]["DAMAGE_MULT_SHADOW"] ~= nil 	
		then	
		    self.inst:SetDamageMultShadow(self.level_data[PREFIX.."_LEVEL_DATA"]["DAMAGE_MULT_SHADOW"][self.current_level])
		end
		
	    if self.level_data[PREFIX.."_LEVEL_DATA"] ~= nil 
			and self.level_data[PREFIX.."_LEVEL_DATA"]["DAMAGE_REDUCTION"] ~= nil 
		then
		    self.inst.DAMAGE_REDUCTION = self.level_data[PREFIX.."_LEVEL_DATA"]["DAMAGE_REDUCTION"][self.current_level] 
		end		
		
	    if self.level_data[PREFIX.."_LEVEL_DATA"] ~= nil 
			and self.level_data[PREFIX.."_LEVEL_DATA"]["DAMAGE_REDUCTION_SHADOW"] ~= nil 
		then
	        self.inst.DAMAGE_REDUCTION_SHADOW = self.level_data[PREFIX.."_LEVEL_DATA"]["DAMAGE_REDUCTION_SHADOW"][self.current_level] 
		end			

		if self.inst.SetUnarmedDamageShadow ~= nil
		    and self.level_data[PREFIX.."_LEVEL_DATA"] ~= nil 
			and self.level_data[PREFIX.."_LEVEL_DATA"]["SHADOW_FORM_UNARMED_DAMAGE"] ~= nil 	
		then	
		    self.inst:SetUnarmedDamageShadow(self.level_data[PREFIX.."_LEVEL_DATA"]["SHADOW_FORM_UNARMED_DAMAGE"][self.current_level])
		end

		if self.inst.Stun ~= nil
		    and self.level_data[PREFIX.."_LEVEL_DATA"] ~= nil 
			and self.level_data[PREFIX.."_LEVEL_DATA"]["STUN_DURATION"] ~= nil 	
		then	
		    self.inst.Stun = self.level_data[PREFIX.."_LEVEL_DATA"]["STUN_DURATION"][self.current_level]
		end		

		if self.inst.StunPF ~= nil
		    and self.level_data[PREFIX.."_LEVEL_DATA"] ~= nil 
			and self.level_data[PREFIX.."_LEVEL_DATA"]["STUN_DURATION_PF"] ~= nil 	
		then	
		    self.inst.StunPF = self.level_data[PREFIX.."_LEVEL_DATA"]["STUN_DURATION_PF"][self.current_level]
		end
		
		if self.additional_update_fn ~= nil then
		    self.additional_update_fn(self.inst)
		end
		
	end
end

function CharlieRefreshModLevel:AddExp(v)
    if self.level_data ~= nil and self.RequiredConsumables ~= nil then
	    local PREFIX = string.upper(self.inst.prefab)
	    if self.level_data[PREFIX.."_LEVEL_REQUIREMENTS_DATA"] ~= nil 
		    and self.level_data[PREFIX.."_LEVEL_REQUIREMENTS_DATA"][self.RequiredConsumables] ~= nil
		then
            self.current_exp = self.current_exp + v 
			if self.current_exp >= self.level_data[PREFIX.."_LEVEL_REQUIREMENTS_DATA"][self.RequiredConsumables][self.current_level+1] then
			    self.current_exp = self.current_exp - self.level_data[PREFIX.."_LEVEL_REQUIREMENTS_DATA"][self.RequiredConsumables][self.current_level+1]
				self:LevelUp()
				self:UpdateData()
			end
		end
	end
end

return CharlieRefreshModLevel