
local Dsskins = Class(function(self,inst)
    self.inst = inst
	self.skins = nil
    self.skin = nil
	self.build = nil
	self.fx = nil
	self.remembered_skin = nil
    self.inst:AddTag("dsskins")
end)

function Dsskins:OnSave()
	return 
	{
	    skin = self.skin,
	    build = self.build,
	    fx = self.fx,
	    remembered_skin = self.remembered_skin,
		shadowform = self.shadowform,
	}
end

local function fly_do_trail(inst)
    local owner = inst.components.inventoryitem:GetGrandOwner() or inst
    if not owner.entity:IsVisible() then
        return
    end

    local x, y, z = owner.Transform:GetWorldPosition()
    if owner.sg ~= nil and owner.sg:HasStateTag("moving") then
        local theta = -owner.Transform:GetRotation() * DEGREES
        local speed = owner.components.locomotor:GetRunSpeed() * .1
        x = x + speed * math.cos(theta)
        z = z + speed * math.sin(theta)
    end
	local mounted = owner.components.rider ~= nil and owner.components.rider:IsRiding()
	local map = GetWorld().Map
    local offset = FindValidPositionByFan(
        math.random() * 2 * PI,
        (mounted and 1 or .5) + math.random() * .5,
        4,
        function(offset)
            local pt = Vector3(x + offset.x, 0, z + offset.z)
            return map:GetTileAtPoint(pt:Get())	~= GROUND.IMPASSABLE
			    and ( inst.IsPosSurroundedByLand == nil or inst:IsPosSurroundedByLand(pt.x, 0, pt.z, 2) )
                and #TheSim:FindEntities(pt.x, 0, pt.z, .7, { "shadowtrail" }) <= 0 
        end
    )
    if offset ~= nil then
		SpawnPrefab("cane_ancient_fx").Transform:SetPosition(x + offset.x, 0, z + offset.z)
    end
end

local function cane_equipped(inst, fx, owner)
	if fx == "cane_ancient_fx" then
		if inst._trailtask == nil then
			inst._trailtask = inst:DoPeriodicTask(6 * FRAMES, fly_do_trail, 2 * FRAMES)
		end
	elseif fx == "cane_victorian_fx" then
        if inst.victorian_fx == nil then
            inst.victorian_fx = SpawnPrefab(fx)
            inst.victorian_fx.entity:AddFollower()
        end
        inst.victorian_fx.Follower:FollowSymbol(owner.GUID, "swap_object", 0, -110, 0)	
	else
	    if inst.fire ~= nil then
			inst.fire:Remove()
			inst.fire = nil
		end
        inst.fire = SpawnPrefab( fx )
        inst.fire:AddTag("INTERIOR_LIMBO_IMMUNE")
        local follower = inst.fire.entity:AddFollower()
        follower:FollowSymbol( owner.GUID, "swap_object", 0, -110, 0 )			
	end
end

local function cane_unequipped(inst)
    if inst._trailtask ~= nil then
        inst._trailtask:Cancel()
        inst._trailtask = nil
    end
    if inst.victorian_fx ~= nil then
        inst.victorian_fx:Remove()
        inst.victorian_fx = nil
    end
    if inst.fire ~= nil  then
        inst.fire:Remove()
        inst.fire = nil
    end
end


function Dsskins:Changeskin(is_shadow_form)
	if self.skin ~= nil then
		if self.inst:HasTag("player") then
			if is_shadow_form then	
                if self.skin ~= "charlie_shadow" and not self.remembered_skin then		
				    self.remembered_skin = self.skin 
				end
				self.skin = "charlie_shadow"
				self.shadowform = true
			else
			    if self.remembered_skin then
			        self.skin = self.remembered_skin 
			        self.remembered_skin = nil
				end
				self.shadowform = nil
			end			
			self.inst.AnimState:SetBuild(self.skin)
			self.inst.AnimState:OverrideSymbol("torso", self.skin, "torso")	
			self.inst.AnimState:OverrideSymbol("torso_pelvis", self.skin, "torso_pelvis")
		else
		    if self.skin ~= "eyebrellahat" then
			    self.inst.AnimState:SetBuild(self.skin)
			else
			    self.inst.AnimState:SetBuild("hat_eyebrella")
			end
			if self.inst.components.inventoryitem ~= nil then	
				if self.inst.prefab == "armorwood" or self.inst.prefab == "armorgrass" or self.inst.prefab == "armormarble" or self.inst.prefab == "armordragonfly" or self.inst.prefab == "armulet" then
					self.inst.AnimState:SetBank(self.skin)
					self.inst.AnimState:PlayAnimation("anim")
				end
				if self.inst.prefab == "krampus_sack" or self.inst.prefab == "icepack" or self.inst.prefab == "seasack" or self.inst.prefab == "piggyback" then
					self.inst.AnimState:SetBank("backpack1")
				end
				if self.skin == "backcub" then
					self.inst.AnimState:SetBank(self.skin)
					if self.inst.GetIsOnWater and self.inst:GetIsOnWater() then
                        if self.inst.components.floatable then
						    self.inst.components.floatable:OnHitWater(true)
						end					
					else
					    self.inst.AnimState:PlayAnimation("anim", true)
					end
                elseif self.inst.prefab == "backpack" or self.inst.prefab == "piggyback" then
				    if self.skin == "piggyback" then
					    self.inst.AnimState:SetBank("piggyback")
					else
				        self.inst.AnimState:SetBank("backpack1")
					end
					self.inst.AnimState:PlayAnimation("anim")
                    if self.inst.GetIsOnWater and self.inst:GetIsOnWater() then
                        if self.inst.components.floatable then
						    self.inst.components.floatable:OnHitWater(true)
						end
                    end					
				end		

				if self.skin ~= self.inst.prefab then
				    self.inst.components.inventoryitem.imagename = self.skin
				    self.inst.components.inventoryitem.atlasname = "images/inventoryimages/"..self.skin..".xml"
				else
				    self.inst.components.inventoryitem.imagename = self.inst.prefab
				    self.inst.components.inventoryitem.atlasname = GetInventoryItemAtlas(self.inst.prefab..".tex")
				end
				if self.skin == "armor_wood" or self.skin == "armor_grass" or self.skin == "armor_marble" or self.skin == "armor_dragonfly" 
					or self.skin == "hat_top" or self.skin == "hat_miner" or self.skin == "hat_straw" or self.skin == "hat_rain"
				    or self.skin == "hat_flower" or self.skin == "hat_ruins" or self.skin == "hat_winter" or self.skin == "hat_football"
					or self.skin == "hat_catcoon" or self.skin == "hat_feather" or self.skin == "hat_beefalo" or self.skin == "hat_wathgrithr"
					or self.skin == "ham_bat" or self.skin == "staffs" or self.skin == "swap_bedroll_furry" or self.skin == "swap_icepack"
					or self.skin == "swap_seasack" or self.skin == "amulets" or self.skin == "parasol" or self.skin == "books" 
					--[[or self.skin == "heat_rock"]] or self.skin == "bee_mine" or self.skin == "nightmaresword"
				then 
				    self.inst.components.inventoryitem.imagename = self.inst.prefab 
				    self.inst.components.inventoryitem.atlasname = GetInventoryItemAtlas(self.inst.prefab..".tex") 
				end		
				
				if self.inst.prefab == "heatrock" then
				    self.inst.components.inventoryitem.imagename = self.skin..tostring(self.inst.currentTempRange) --Don't use ChangeImageName bucause it will push the event "imagechange"
				    if self.skin == "heatrock_fire" then  	  
				        self.inst.components.inventoryitem.atlasname = "images/inventoryimages/"..self.skin..tostring(self.inst.currentTempRange)..".xml"					
					elseif self.skin == "heat_rock" then 
				        self.inst.components.inventoryitem.atlasname = GetInventoryItemAtlas(self.inst.prefab..".tex")					
					end
				end
				
				if self.inst.prefab == "lantern" then
				    if self.inst.components.machine and self.inst.components.machine.ison then
					    self.inst.components.inventoryitem.imagename = self.skin.."_lit"
						if self.skin ~= "lantern" then
						    self.inst.components.inventoryitem.atlasname = "images/inventoryimages/"..self.skin.."_lit.xml"
						else
						    self.inst.components.inventoryitem.atlasname = GetInventoryItemAtlas(self.inst.prefab..".tex")
						end
					else
					    self.inst.components.inventoryitem.imagename = self.skin
						if self.skin ~= "lantern" then
						    self.inst.components.inventoryitem.atlasname = "images/inventoryimages/"..self.skin..".xml"
						else
						    self.inst.components.inventoryitem.atlasname = GetInventoryItemAtlas(self.inst.prefab..".tex")
						end
					end
				end
				
				if self.inst.components.equippable ~= nil then
					self.inst:ListenForEvent("equipped", function(inst, data)
						if data.owner ~= nil then
							if inst.components.equippable.equipslot == EQUIPSLOTS.HANDS then
								if self.build ~= nil then
									data.owner.AnimState:OverrideSymbol("swap_object", "swap_"..self.skin, self.build)
								end
								if self.fx ~= nil then
									cane_equipped(inst, self.fx, data.owner)
									inst:ListenForEvent("unequipped", cane_unequipped)
								end
							end
							if inst.components.equippable.equipslot == EQUIPSLOTS.BACK  then   --for other mods
								data.owner.AnimState:OverrideSymbol("swap_body", self.skin, "swap_body")
							end
							if inst.components.equippable.equipslot == EQUIPSLOTS.BODY  then
							    if self.skin ~= "backpack" and self.skin ~= "piggyback" and self.skin ~= "krampus_sack" 
								    and self.skin ~= "icepack" and self.skin ~= "seasack"					
								then
								    data.owner.AnimState:OverrideSymbol("swap_body", self.skin, "swap_body")
								else
								    data.owner.AnimState:OverrideSymbol("swap_body", "swap_"..self.skin, "swap_body")
								end
							end
							if inst.components.equippable.equipslot == EQUIPSLOTS.PACK then
								data.owner.AnimState:OverrideSymbol("swap_body", self.skin, "swap_body")
							end
                            if inst.components.equippable.equipslot == EQUIPSLOTS.NECK then
								data.owner.AnimState:OverrideSymbol("swap_body", self.skin, "swap_body") 
							end
							if inst.components.equippable.equipslot == EQUIPSLOTS.HEAD then
								if inst.prefab == "minerhat" then 
									return
								end		
                                if self.skin ~= "eyebrellahat" then
			                        data.owner.AnimState:OverrideSymbol("swap_hat", self.skin, "swap_hat")
			                    else	
                                    data.owner.AnimState:OverrideSymbol("swap_hat", "hat_eyebrella", "swap_hat")
                                end														    
							end
						end
					end)
				end
			end
			--if self.inst.MiniMapEntity then
			--	self.inst.MiniMapEntity:SetIcon(self.skin..".tex")
			--end
		end
    end
end

function Dsskins:OnLoad(data)
	if data.skin ~= nil then
        self.skin = data.skin
		self.remembered_skin = data.remembered_skin
		if data.build ~= nil then
		    self.build = data.build
		end
		if data.fx ~= nil then
		    self.fx = data.fx
		end
		if data.shadowform ~= nil then
		    self.shadowform = data.shadowform
		end		
		self:Changeskin(data.shadowform)
	end
end

return Dsskins