local Endothermicmachine = Class(function(self, inst)
    self.inst = inst
    self.inst:StartUpdatingComponent(self)
end)

local FIRE_ONEOF_TAGS = {"fire", "smolder"}
local COOL_MUST_TAGS = {"freezable"}
local COOL_CANT_TAGS = {"FX", "NOCLICK", "INLIMBO", "INTERIOR_LIMBO", "fountain_obsidian", "immune_to_be_cooled"}

function Endothermicmachine:OnUpdate(dt)
    local x, y, z = self.inst.Transform:GetWorldPosition()

    for k, j in pairs(TheSim:FindEntities(x, y, z, 10, nil, {"FX", "NOCLICK", "INLIMBO", "INTERIOR_LIMBO"}, FIRE_ONEOF_TAGS)) do
        if j ~= nil
		    and j:IsValid() 
		    and j.entity:IsVisible() 
		then
            if j.components.burnable ~= nil and j.components.fueled == nil then
                j.components.burnable:Extinguish()
            end
		end
    end	
	
    for _, f in pairs(TheSim:FindEntities(x, y, z, 4, COOL_MUST_TAGS, COOL_CANT_TAGS)) do
        if f ~= nil
		    and f:IsValid() 
		    and f.entity:IsVisible() 
			and f.components.freezable ~= nil 
		then
		    if f.components.freezable.coldness < (f.components.freezable.resistance - 1) then
                f.components.freezable:AddColdness(1)
			end
		end
    end	
end

return Endothermicmachine