local Floatfxspawner = Class(function(self, inst)
    self.inst = inst
    self.range = 2.5
end)

function Floatfxspawner:spawnripple(inst)
    if inst.HasChildPrefab ~= nil and not inst:HasChildPrefab("float_fx_front") and not inst:HasChildPrefab("float_fx_back") then
        local ripple_front = SpawnPrefab("float_fx_front")
	    local ripple_back = SpawnPrefab("float_fx_back")
    
        inst:AddChild(ripple_front)
	    ripple_front.AnimState:PlayAnimation("idle_front_small", true)
		
	    inst:AddChild(ripple_back)
	    ripple_back.AnimState:PlayAnimation("idle_back_small", true)
	
	    if inst:HasTag("wall") or inst:HasTag("hound") then
            ripple_front.AnimState:PlayAnimation("idle_front_med", true)
		    ripple_back.AnimState:PlayAnimation("idle_back_med", true)		
        elseif inst:HasTag("largecreature") then
            ripple_front.AnimState:PlayAnimation("idle_front_large", true)
		    ripple_back.AnimState:PlayAnimation("idle_back_large", true)
        end
		ripple_front.AnimState:SetLayer(LAYER_WORLD)
		ripple_front.AnimState:SetSortOrder(0)
		if not inst:HasTag("wall") then
	        ripple_front.Transform:SetPosition(0, 0.2, 0)
		    ripple_back.Transform:SetPosition(0, 0.2, 0)
		end
	end
	
	if inst.HasChildPrefab == nil then
	    local HasChildPrefabFloatFxFront = false
		local HasChildPrefabFloatFxBack = false
		
		if inst.children then
            for k,child in pairs(inst.children) do
                if k.prefab == "float_fx_front" then
                    HasChildPrefabFloatFxFront = true
                end
				if k.prefab == "float_fx_back" then
				    HasChildPrefabFloatFxBack = true
				end
            end			
		end	
		
	    if not HasChildPrefabFloatFxFront and not HasChildPrefabFloatFxBack then
            local ripple_front = SpawnPrefab("float_fx_front")
	        local ripple_back = SpawnPrefab("float_fx_back")
    
            inst:AddChild(ripple_front)
	        ripple_front.AnimState:PlayAnimation("idle_front_small", true)
	
	        inst:AddChild(ripple_back)
	        ripple_back.AnimState:PlayAnimation("idle_back_small", true)

	        if inst:HasTag("wall") or inst:HasTag("hound") or inst:HasTag("dragoon") then
                ripple_front.AnimState:PlayAnimation("idle_front_med", true)
		        ripple_back.AnimState:PlayAnimation("idle_back_med", true)		
            elseif inst:HasTag("largecreature") then
                ripple_front.AnimState:PlayAnimation("idle_front_large", true)
		        ripple_back.AnimState:PlayAnimation("idle_back_large", true)
            end	
            ripple_front.AnimState:SetLayer(LAYER_WORLD)
			ripple_front.AnimState:SetSortOrder(0)
			if not inst:HasTag("wall") then
		        ripple_front.Transform:SetPosition(0, 0.2, 0)
		        ripple_back.Transform:SetPosition(0, 0.2, 0)	
            end				
		end
	end
end

function Floatfxspawner:checkifnearpuddle(inst)
    if inst:HasTag("INLIMBO") or (inst.components.driver ~= nil and inst.components.driver:GetIsDriving()) then
        if inst.children then
            for k,child in pairs(inst.children) do
                if k.prefab == "float_fx_front" or k.prefab == "float_fx_back" then
                    k:Remove()
					if inst.floatfxspawner_component_task ~= nil then
					    inst.floatfxspawner_component_task:Cancel()
						inst.floatfxspawner_component_task = nil
					end
                end
            end
        end
		return
    end
    local x, y, z = inst.Transform:GetWorldPosition()
    local puddle = TheSim:FindEntities(x, y, z, self.range, {"puddle"}, {"puddle_disappear"})
	local lilypad = TheSim:FindEntities(x, y, z, self.range, {"LilyPadForPuddle"})
    if #puddle > 0 and #lilypad <= 0 then
	    --Do nothing
	else
	    if inst:HasTag("aquatic") and not inst:HasTag("player") and inst.components.tiletracker == nil then
		    if inst.components.workable ~= nil then
			    inst.components.workable:Destroy(self.inst)
			elseif inst.components.health ~= nil then
			    inst.components.health:SetVal(0)
			else
			    inst:Remove()
			end	
	    end	
        if inst.children then
            for k,child in pairs(inst.children) do
                if k.prefab == "float_fx_front" or k.prefab == "float_fx_back" then
                    k:Remove()
					if inst.floatfxspawner_component_task ~= nil then
					    inst.floatfxspawner_component_task:Cancel()
						inst.floatfxspawner_component_task = nil
					end
                end
            end
        end				
	end
	if inst:IsValid() and inst:HasTag("aquatic") and #lilypad > 0 and not inst:HasTag("player") and inst.components.tiletracker == nil then
		if inst.components.workable ~= nil then
	        inst.components.workable:Destroy(self.inst)
		elseif inst.components.health ~= nil then
		    inst.components.health:SetVal(0)
		else
		    inst:Remove()
		end		
	end

end

function Floatfxspawner:OnEntitySleep()
	self.inst:StopUpdatingComponent(self)
end

function Floatfxspawner:OnEntityWake()
	self.inst:StartUpdatingComponent(self)
end

function Floatfxspawner:OnUpdate(dt)
    local x, y, z = self.inst.Transform:GetWorldPosition()

    local LilyPad = TheSim:FindEntities(x, y, z, 0.5, {"LilyPadForPuddle"})

    local ents = {}
	local ents_to_remove = {}
    
    if self.range > 0 then
        ents = TheSim:FindEntities(x, y, z, self.range, nil, {"flying", "ghost", "shadow", "fishfarm", "buoy", "autofixer", "no_float_fx_spawn_on_puddle", "isinventoryitem", "campfire", "pugalisk", "level2", "ancient_hanging_lamp", "bird", "eyeplant", "INLIMBO"}, {"monster", "animal", "character", "smallcreature", "seacreature", "structure", "wall"})
	    if not IsDLCEnabled(CAPY_DLC) and not IsDLCEnabled(PORKLAND_DLC) then
	        ents = TheSim:FindEntities(x, y, z, self.range, nil, {"flying", "ghost", "shadow", "no_float_fx_spawn_on_puddle", "ancient_hanging_lamp", "bird", "eyeplant", "INLIMBO"}, {"monster", "animal", "character", "smallcreature", "structure", "wall", "isinventoryitem"})
	    end
		ents_to_remove = TheSim:FindEntities(x, y, z, self.range+1, nil, {"INLIMBO", "aquatic", "seagull"}, {"bird", "eyeplant"})
    end

    for i, ent in pairs(ents) do
	    if not ent:HasTag("aquatic") and (ent.components.tiletracker == nil or ent.components.tiletracker.onwaterchangefn == nil) and #LilyPad <= 0 then
		    self:spawnripple(ent)
		end
		if ent.floatfxspawner_component_task == nil and (ent:HasTag("aquatic") or #LilyPad <= 0) then
            ent.floatfxspawner_component_task = ent:DoPeriodicTask(0.4, function(ent) self:checkifnearpuddle(ent) end)
		end
    end
	
	for _, thingtoremove in pairs(ents_to_remove) do
		if thingtoremove.persists and thingtoremove ~= GetPlayer()  then 
		    thingtoremove.persists = false
		    thingtoremove:DoTaskInTime(0.75, function()    
                if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
                    local fx = SpawnPrefab("splash_water_sink")
			        local x2, y2, z2 = thingtoremove.Transform:GetWorldPosition()
                    fx.Transform:SetPosition(x2, 0, z2)
                    if thingtoremove.SoundEmitter then
                        thingtoremove.SoundEmitter:PlaySound("dontstarve_DLC002/common/item_sink")
                    end			
                end					
			    thingtoremove:Remove()
			end) 
		end 	
	end 
	
end

function Floatfxspawner:SetRange(newrange)
    self.range = newrange
end

return Floatfxspawner
