local DISAPPEAR_ENG = {"Look around! Nothing around!", "Rabbit has magically disappeared!", "Rabbit was transformed into nothingness!"}
local DISAPPEAR_CN = {"看看周围！什么都没有吧！", "兔子现在已经奇迹般地不见了！", "兔子转换成虚无了！"}

local MAGIC_SUCCESS_ENG = {"It's a success this time!", "Show all of you wonders!", "Fluffy assistant cooperated well!"}
local MAGIC_SUCCESS_CN = {"这次成功了！", "给你们所有人看看奇迹！", "毛绒助手配合得很好！"}
local MAGIC_FAIL_ENG = {"Ah, maybe next time!", "I have to practice more.", "Magic failed this time."}
local MAGIC_FAIL_CN = {"啊，也许下一次！", "我得多多练习下。", "这次的魔法失效了。"}

local CONJURE_ENG = {"Look at these beautiful flowers!", "Show all of you wonders!", "Conjured flowers successfully!"}
local CONJURE_CN = {"看看这些美丽的花朵！", "给你们所有人看看奇迹！", "成功变出花朵！"}
--TO DO. <CODE> HAM INTERIOR SPAWN

local function IsPointOutsideInteriorWall(x, y, z, radius)  --Should we make it a global variable?
    if TheCamera.interior then
        local interiorSpawner = GetWorld().components.interiorspawner 
        if GetWorld() and interiorSpawner and interiorSpawner.current_interior then
            local originpt = interiorSpawner:getSpawnOrigin()
            local width = interiorSpawner.current_interior.width
            local depth = interiorSpawner.current_interior.depth        
            local dMax = originpt.x + depth/2
            local dMin = originpt.x - depth/2
            local wMax = originpt.z + width/2
            local wMin = originpt.z - width/2        
            local dist = radius or 0.5
            if x < dMin+dist or x > dMax-dist or z < wMin+dist or z > wMax-dist then
                return true
            end
        end
    end
    return false
end

local Magician = Class(function(self, inst)
    self.inst = inst

    inst:AddTag("_magician")
	
	self.common_required_tag = ""
	self.makedisappear_tag = ""
	self.enchant_required_tag = ""
	self.enchant_tag = ""
	self.enchant_exclude_tag = ""
	self.magicrabbithole_check_radius = 1
	self.magicrabbit_check_radius = 1
	self.magicflower_check_radius = 1
	self.magicpetals_check_radius = 1
	self.makedisappear_hunger_cost = 0
	self.makedisappear_rabbithole_spawn_chance = 0
	self.makedisappear_gold_spawn_chance = 0
	self.magic_tricks_success_chance = 0
	self.magic_tricks_success_sanity_gain = 0
	self.magic_tricks_fail_sanity_lose = 0
	self.conjure_flowers_sanity_cost = 0
	self.conjure_flowers_grogginess = 0
	self.conjure_flowers_chance = 0
	self.enchant_sanity_cost = 0
	self.summon_sanity_cost = 30
end)

function Magician:SetCommonRequiredTag(tag)
    self.common_required_tag = tag
end

function Magician:SetMakeDisappearTag(tag)
    self.makedisappear_tag = tag
end

function Magician:SetEnchantRequiredTag(tag)
    self.enchant_required_tag = tag
end

function Magician:SetEnchantTag(tag)
    self.enchant_tag = tag
end

function Magician:SetEnchantExcludeTag(tag)
    self.enchant_exclude_tag = tag
end

function Magician:SetMagicRabbitHoleCheckRadius(value)
    self.magicrabbithole_check_radius = value
end

function Magician:SetMagicRabbitCheckRadius(value)
    self.magicrabbit_check_radius = value
end

function Magician:SetMagicFlowerCheckRadius(value)
    self.magicflower_check_radius = value
end

function Magician:SetMagicPetalsCheckRadius(value)
    self.magicpetals_check_radius = value
end

function Magician:SetMakeDisappearHungerCost(value)
    self.makedisappear_hunger_cost = value
end

function Magician:SetMakeDisappearRabbitHoleSpawnChance(value)
    self.makedisappear_rabbithole_spawn_chance = value
end

function Magician:SetMakeDisappearGoldSpawnChance(value)
    self.makedisappear_gold_spawn_chance = value
end

function Magician:SetMagicTricksSuccessChance(value)
    self.magic_tricks_success_chance = value
end

function Magician:SetMagicTricksSuccessSanityGain(value)
    self.magic_tricks_success_sanity_gain = value
end

function Magician:SetMagicTricksFailSanityLose(value)
    self.magic_tricks_fail_sanity_lose = value
end

function Magician:SetConjureFlowersSanityCost(value)
    self.conjure_flowers_sanity_cost = value
end

function Magician:SetConjureFlowersGrogginess(value)
    self.conjure_flowers_grogginess = value
end

function Magician:SetConjureFlowersChance(value)
    self.conjure_flowers_chance = value
end

function Magician:SetEnchantSanityCost(value)
    self.enchant_sanity_cost = value
end

local MAGIC_CANT_TAGS = {"fire", "burnt", "smolder", "FX", "NOCLICK", "INLIMBO", "DECOR", "INTERIOR_LIMBO"}
local MAGIC_RABBIT_HOLE_MUST = {"magicrabbithole"}
function Magician:MakeSomethingDisappear(doer, target)
    if doer == nil or target == nil then
	    return false
	end
    if self.inst:HasTag(self.common_required_tag) then
        if doer.components.hunger ~= nil and doer.components.hunger:IsStarving() then
		    return false
	    end
        if target:HasTag(self.makedisappear_tag) then
		    local fx = SpawnPrefab("small_puff")
		    fx.Transform:SetPosition(target.Transform:GetWorldPosition())
			if doer:HasTag("bonusrabbitdoer") and doer:HasTag("superbonusrabbitdoer") then
			    local rabbit2 = SpawnPrefab("rabbit")
				local rabbit3 = SpawnPrefab("rabbit")
                rabbit2.Physics:Teleport(doer.Transform:GetWorldPosition())
                rabbit3.Physics:Teleport(doer.Transform:GetWorldPosition())					
                rabbit2:AddTag("magicrabbit")
                rabbit3:AddTag("magicrabbit")					
                SpawnPrefab("small_puff").Transform:SetPosition(rabbit2.Transform:GetWorldPosition())	
                SpawnPrefab("small_puff").Transform:SetPosition(rabbit3.Transform:GetWorldPosition())				
			elseif doer:HasTag("bonusrabbitdoer") then 
			    local _rabbit = SpawnPrefab("rabbit")
                _rabbit.Physics:Teleport(doer.Transform:GetWorldPosition())				
                _rabbit:AddTag("magicrabbit")					
                SpawnPrefab("small_puff").Transform:SetPosition(_rabbit.Transform:GetWorldPosition())			
			else
	            if doer.components.talker ~= nil then
		            if TUNING.LANGUAGE == true then
	                    doer.components.talker:Say(DISAPPEAR_ENG[math.random(#DISAPPEAR_ENG)])					    
		            elseif TUNING.LANGUAGE == false then
		      	        doer.components.talker:Say(DISAPPEAR_CN[math.random(#DISAPPEAR_CN)])	
		            end
	            end
			    target:Remove()
			end
			if doer.components.hunger ~= nil then
				doer.components.hunger:DoDelta(-self.makedisappear_hunger_cost)
			end
			
			local chance = self.makedisappear_rabbithole_spawn_chance	
            local chance2 = self.makedisappear_gold_spawn_chance
	        local find_shadow_knowledge_classic = false
	        if self.inst.components.inventory ~= nil then
	            find_shadow_knowledge_classic = self.inst.components.inventory:FindItem(
                function(item)
                    return item:HasTag("shadow_knowledge_classic")
                end)
	        end
			
			if find_shadow_knowledge_classic then
			    chance = 1
				chance2 = 1
			end
			
			if math.random() < chance then
                local pt = doer:GetPosition()
		        local pos = Vector3(doer.Transform:GetWorldPosition())
                local range = 5 + math.random()*10
                local angle =  math.random()*2*PI
                local offset = doer.GetIsOnLand ~= nil and FindGroundOffset(pt, angle, range, 10, true, false) or FindWalkableOffset(pt, angle, range, 10, true, false)
                local x, y, z = doer.Transform:GetWorldPosition()
                local magicrabbithole = TheSim:FindEntities(pos.x, pos.y, pos.z, self.magicrabbithole_check_radius, MAGIC_RABBIT_HOLE_MUST, MAGIC_CANT_TAGS)
			    local HAMint = IsDLCEnabled(PORKLAND_DLC) and TheCamera.interior
                if offset and #magicrabbithole < 6 and not HAMint then
                    local newpoint = pt+offset
                    range = math.random()*8
                    angle = math.random()*2*PI
                    local suboffset = doer.GetIsOnLand ~= nil and FindGroundOffset(pt, angle, range, 10, true, false) or FindWalkableOffset(newpoint, angle, range, 10, true, false)
					local fx = SpawnPrefab("small_puff")
                    local rabbithole = SpawnPrefab("rabbithole")
                    local spawnpt = newpoint + suboffset
                    rabbithole.Transform:SetPosition(spawnpt.x, spawnpt.y, spawnpt.z)
                    rabbithole:AddTag("magicrabbithole")
                    fx.Transform:SetPosition(rabbithole.Transform:GetWorldPosition())
				    if not rabbithole:IsOnValidGround() then
				        rabbithole:Remove()
				    end						
					if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
						if rabbithole:GetIsOnWater() then
							rabbithole:Remove()
					    end
				    end							
                end				    
			end
	        if math.random() < chance2 then
		        if doer.components.inventory ~= nil then
				    doer.components.inventory:GiveItem(SpawnPrefab("goldnugget"), nil, Vector3(TheSim:GetScreenPos(doer.Transform:GetWorldPosition())))
			    else
				    SpawnPrefab("goldnugget").Transform:SetPosition(doer.Transform:GetWorldPosition())
				    SpawnPrefab("small_puff").Transform:SetPosition(doer.Transform:GetWorldPosition())
			    end
	        end	
            if self.onmakedisappear ~= nil then
                self.onmakedisappear(self.inst, doer, target)
            end
	        return true
		end
	end
end

local MAGIC_RABBIT_MUST = {"magicrabbit"}
function Magician:PlayMagicTricks(doer)
    if doer == nil then
	    return false
	end
	if self.inst:HasTag(self.common_required_tag) then

	    local chance = self.magic_tricks_success_chance			
	    local find_shadow_knowledge_classic = false
	    if self.inst.components.inventory ~= nil then
	        find_shadow_knowledge_classic = self.inst.components.inventory:FindItem(
            function(item)
                return item:HasTag("shadow_knowledge_classic")
            end)
	    end
			
		if find_shadow_knowledge_classic then
		    chance = 1
		end

        if math.random() < chance then
            local x, y, z = doer.Transform:GetWorldPosition()
            local magicrabbit = TheSim:FindEntities(x, y, z, self.magicrabbit_check_radius, MAGIC_RABBIT_MUST, MAGIC_CANT_TAGS)		
            if #magicrabbit < 6 and not IsPointOutsideInteriorWall(x, y, z) and not doer:HasTag("aquatic") then
			    local fx = SpawnPrefab("small_puff")
                local rabbit = SpawnPrefab("rabbit")
                rabbit.Physics:Teleport(doer.Transform:GetWorldPosition())
                rabbit:AddTag("magicrabbit")
                fx.Transform:SetPosition(rabbit.Transform:GetWorldPosition())
				if doer:HasTag("bonusrabbitdoer") and doer:HasTag("superbonusrabbitdoer") then
				    local rabbit2 = SpawnPrefab("rabbit")
					local rabbit3 = SpawnPrefab("rabbit")
                    rabbit2.Physics:Teleport(doer.Transform:GetWorldPosition())
                    rabbit3.Physics:Teleport(doer.Transform:GetWorldPosition())					
                    rabbit2:AddTag("magicrabbit")
                    rabbit3:AddTag("magicrabbit")					
                    SpawnPrefab("small_puff").Transform:SetPosition(rabbit2.Transform:GetWorldPosition())	
                    SpawnPrefab("small_puff").Transform:SetPosition(rabbit3.Transform:GetWorldPosition())					
				elseif doer:HasTag("bonusrabbitdoer") then
				    local _rabbit = SpawnPrefab("rabbit")
                    _rabbit.Physics:Teleport(doer.Transform:GetWorldPosition())				
                    _rabbit:AddTag("magicrabbit")					
                    SpawnPrefab("small_puff").Transform:SetPosition(_rabbit.Transform:GetWorldPosition())						
				end
				if not rabbit:IsOnValidGround() then
				    rabbit:Remove()
				end	
			    if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
					if rabbit:GetIsOnWater() then
						rabbit:Remove()
					end
				end					
            end
            if doer.components.sanity ~= nil then
                doer.components.sanity:DoDelta(self.magic_tricks_success_sanity_gain)
            end
			if doer.components.talker ~= nil then
				if TUNING.LANGUAGE == true then
	                doer.components.talker:Say(MAGIC_SUCCESS_ENG[math.random(#MAGIC_SUCCESS_ENG)])					    
				elseif TUNING.LANGUAGE == false then
					doer.components.talker:Say(MAGIC_SUCCESS_CN[math.random(#MAGIC_SUCCESS_CN)])	
				end
			end
            return true					
		else		
            if doer.components.sanity ~= nil then
                doer.components.sanity:DoDelta(-self.magic_tricks_fail_sanity_lose)
            end
		    if doer.components.talker ~= nil then
				if TUNING.LANGUAGE == true then
	                doer.components.talker:Say(MAGIC_FAIL_ENG[math.random(#MAGIC_FAIL_ENG)])					    
				elseif TUNING.LANGUAGE == false then
					doer.components.talker:Say(MAGIC_FAIL_CN[math.random(#MAGIC_FAIL_CN)])	
				end
			end				
			return true	
		end
        if self.onplaymagictricks ~= nil then
            self.onplaymagictricks(self.inst, doer)
        end
		return true	
	end
end

local MAGIC_FLOWER_MUST = {"magicflower"}
local MAGIC_PETALS_MUST = {"magicpetals"}
function Magician:ConjureFlowers(doer)
    if doer == nil then
	    return false
	end
	if self.inst:HasTag(self.common_required_tag) then
		if not IsDLCEnabled(PORKLAND_DLC) then
            if doer.components.sanity ~= nil then
                doer.components.sanity:DoDelta(-self.conjure_flowers_sanity_cost)
            end
		else
            if doer.components.grogginess ~= nil then
			    if doer.components.grogginess.grog_amount ~= nil then
                    doer.components.grogginess:AddGrogginess(self.conjure_flowers_grogginess)
				else
		            doer.components.grogginess.grog_amount = 0
                    doer.components.grogginess:AddGrogginess(self.conjure_flowers_grogginess)					
			    end
            end
        end			
	    if doer.components.talker ~= nil then
			if TUNING.LANGUAGE == true then
	            doer.components.talker:Say(CONJURE_ENG[math.random(#CONJURE_ENG)])					    
			elseif TUNING.LANGUAGE == false then
				doer.components.talker:Say(CONJURE_CN[math.random(#CONJURE_CN)])	
			end
		end			
        if math.random() < self.conjure_flowers_chance then
            local pt = doer:GetPosition()
		    local pos = Vector3(doer.Transform:GetWorldPosition())
            local range = 5 + math.random()*10
            local angle = math.random()*2*PI
            local offset = doer.GetIsOnLand ~= nil and FindGroundOffset(pt, angle, range, 10, true, false) or FindWalkableOffset(pt, angle, range, 10, true, false)
            local x, y, z = doer.Transform:GetWorldPosition()
            local magicflower = TheSim:FindEntities(pos.x, pos.y, pos.z, self.magicflower_check_radius, MAGIC_FLOWER_MUST, MAGIC_CANT_TAGS)	
			local HAMint = IsDLCEnabled(PORKLAND_DLC) and TheCamera.interior
            if offset and #magicflower < 20 and not HAMint then
				for i=1, math.random(3,4) do
					local newpoint = pt+offset
                    range = math.random()*8
                    angle = math.random()*2*PI
                    local suboffset = doer.GetIsOnLand ~= nil and FindGroundOffset(pt, angle, range, 10, true, false) or FindWalkableOffset(newpoint, angle, range, 10, true, false)
                    local spawnpt = newpoint + suboffset
					if doer.IsPosSurroundedByLand ~= nil and not doer:IsPosSurroundedByLand(spawnpt.x, spawnpt.y, spawnpt.z, 1.5) then
					    return
					end					
					local fx = SpawnPrefab("small_puff")
                    local flower = SpawnPrefab("flower")
                    flower.Transform:SetPosition(spawnpt.x, spawnpt.y, spawnpt.z)
                    flower:AddTag("magicflower")
                    fx.Transform:SetPosition(flower.Transform:GetWorldPosition())
				    if not flower:IsOnValidGround() then
				        flower:Remove()
				    end	
					if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
						if flower:GetIsOnWater() then
							flower:Remove()
						end
					end
                end					
            end
            return true					
		else		
            local pt = doer:GetPosition()
		    local pos = Vector3(doer.Transform:GetWorldPosition())
            local offset_two = FindWalkableOffset(pt, math.random()*2*PI, 5 + math.random()*10, 10)
            local x, y, z = doer.Transform:GetWorldPosition()
            local magicpetals = TheSim:FindEntities(pos.x, pos.y, pos.z, self.magicpetals_check_radius, MAGIC_PETALS_MUST, MAGIC_CANT_TAGS)
            if offset_two and #magicpetals < 40 then
				for i=1, math.random(5,12) do
					local newpoint_two = pt+offset_two
                    local suboffset_two = FindWalkableOffset(newpoint_two, math.random()*2*PI, math.random()*8, 10)
                    local spawnpt = newpoint_two + suboffset_two
					if IsPointOutsideInteriorWall(spawnpt.x, spawnpt.y, spawnpt.z) then
					    return
					end					
					local fx = SpawnPrefab("small_puff")
                    local petals = math.random() < 0.01 and SpawnPrefab("rose_inv") or SpawnPrefab("petals")					
                    petals.Transform:SetPosition(spawnpt.x, spawnpt.y, spawnpt.z)
                    petals:AddTag("magicpetals")  --No usefuel way to save this tag as they are stackable
                    fx.Transform:SetPosition(petals.Transform:GetWorldPosition())
				    if not petals:IsOnValidGround() then
				        petals:Remove()
				    end	
					if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
						if petals:GetIsOnWater() then
							if petals.components.floatable ~= nil then
							    petals.components.floatable:OnHitWater()
							else
								petals:Remove()
							end
						end
					end
                end					
            end			
			return true	
		end
		if self.onconjureflowers ~= nil then
            self.onconjureflowers(self.inst, doer)
        end
		return true	
	end
end

function Magician:EnchantSomething(doer, target)
    if doer == nil or target == nil then
	    return false
	end
    if self.inst:HasTag(self.enchant_required_tag) then
		if not doer.components.sanity or doer.components.sanity.current == 0 then
            return false
        end
		if target:HasTag(self.enchant_exclude_tag) then
			return false
		end
        if doer.components.sanity ~= nil then
            doer.components.sanity:DoDelta(-self.enchant_sanity_cost)
        end
		if target:HasTag(self.enchant_tag) then
		    if target.ConvertToMagician ~= nil then
			    target:ConvertToMagician()
			end		    
            --For updating itme tile image:
            local owner = target.components.inventoryitem and target.components.inventoryitem.owner or nil
			if target:IsInLimbo() and owner ~= nil then
			    if owner == doer and doer.components.inventory then
                    doer.components.inventory:DropItem(target)		
		            doer.components.inventory:GiveItem(target, nil, Vector3(TheSim:GetScreenPos(target.Transform:GetWorldPosition())))
				elseif owner.components.container and doer.components.inventory then			    
					doer.components.inventory:GiveItem(target, nil, Vector3(TheSim:GetScreenPos(owner.Transform:GetWorldPosition()))) --target's position will be wrong
				end
			end
		end			

        if self.onenchant ~= nil then
            self.onenchant(self.inst, doer, target)
        end	
	    return true
	end	
end

--Deprecated
--[[
function Magician:SummonShadowPuppet()
    if not self.inst:IsVaild() or not self.inst.entity:IsVisible() then
	    return false
	end
    local theta = math.random() * 2 * PI
    local pt = self.inst:GetPosition()
    local radius = math.random(3, 6)
    local offset = FindWalkableOffset(pt, theta, radius, 12, true)
    if offset then
        local puppet = SpawnPrefab("shadow_puppet")
        local pos = pt + offset
        puppet.Transform:SetPosition(pos:Get())
        if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
            if puppet:GetIsOnWater() then
			    if puppet.SpawnShadowBoat ~= nil then
                    puppet:SpawnShadowBoat(pos)
				end
            end
		end
        SpawnPrefab("statue_transition").Transform:SetPosition(pos:Get())
        SpawnPrefab("statue_transition_2").Transform:SetPosition(pos:Get())
        if puppet.components.follower ~= nil then
            puppet.components.follower:SetLeader(self.inst)
		end
	    local GetSkinName = (self.inst.components.dsskins ~= nil and self.inst.components.dsskins.skin) or nil
	    if puppet.AnimState ~= nil and GetSkinName ~= nil then
	        puppet.AnimState:SetBuild(GetSkinName)
	        puppet.AnimState:OverrideSymbol("torso", GetSkinName, "torso")	
	        puppet.AnimState:OverrideSymbol("torso_pelvis", GetSkinName, "torso_pelvis")
      	end
		if self.inst.components.sanity ~= nil then
            self.inst.components.sanity:DoDelta(-self.summon_sanity_cost)
        end
		if self.inst.SoundEmitter ~= nil then
            self.inst.SoundEmitter:PlaySound("dontstarve/maxwell/shadowmax_appear")
		end

        return true
    end
end
]]

--Magic Powers Template
--[[
function Magician:xxx(doer, target)

end
]]

return Magician