local Magicturner = Class(function(self, inst)
    self.inst = inst
	self.forceleft = false
    self.target_require_tags = nil
	self.convert_prefab = nil
	self.doer_require_tags = nil
end)

function Magicturner:CanSelfTurnTarget(doer, target)
    if self.target_require_tags ~= nil and type(self.target_require_tags) == "table" then
	    for k,v in pairs(self.target_require_tags) do
		    if target ~= nil and target:HasTag(v) then
			    return true
			end
		end
	end
	return false
end

function Magicturner:CanDoerTurnTarget(doer, target)
	if self.doer_require_tags ~= nil then
	    if type(self.doer_require_tags) == "string" then
            if doer ~= nil and doer:HasTag(self.doer_require_tags) then
			    return true
			end
		elseif type(self.doer_require_tags) == "table" then
	        for k,v in pairs(self.doer_require_tags) do
		        if doer ~= nil and doer:HasTag(v) then
			        return true
			    end
		    end		    
		end	
	end
	return false
end
	
function Magicturner:CollectUseActions(doer, target, actions, right)
    if self:CanSelfTurnTarget(doer, target) and self:CanDoerTurnTarget(doer, target) then
	    if self.forceleft or right then
            table.insert(actions, ACTIONS.MAGICTURN)
		end
    end
	
	--Don't want to create another new component, so putting the other actions here.
	if self.inst:HasTag("blackener")
	    and doer ~= nil 
	    and doer:HasTag("prospective_throne_owner") 
		and target ~= nil 
		and target:HasTag("blackenable") 
		and target.White ~= nil
		and right
	then
	    table.insert(actions, ACTIONS.BLACKEN)
	end
	
	if self.inst:HasTag("shadowupgrader")
	    and doer ~= nil 
	    and doer:HasTag("prospective_throne_owner") 
		and target ~= nil 
		and target:HasTag("shadowupgradeable") 
		and right
	then
	    table.insert(actions, ACTIONS.SHADOW_UPGRADE)
	end
	
end

return Magicturner
