local MayBeeBeeSpecific = Class(function(self, inst)
    self.inst = inst
	self.OriginalDamage = inst.components.combat and inst.components.combat.defaultdamage or 0
	self.CurrentDamage = inst.components.combat and inst.components.combat.defaultdamage or 0
	self.BeePoweredDamageMultiplier = 1.5
	self.ElectrifyingFXCooldown = 1
end)

function MayBeeBeeSpecific:OnSave()
    return 
	{
		Duration = self.inst.Duration,
		stun_chance = self.inst.stun_chance,
		stun_time = self.inst.stun_time,
	}
end

function MayBeeBeeSpecific:OnLoad(data)
    if data ~= nil then
	    if data.Duration then
		    self.inst.Duration = data.Duration
		end
		if data.stun_chance then
		    self.inst.stun_chance = data.stun_chance
		end
		if data.stun_time then
            self.inst.stun_time = data.stun_time
		end
	end
end

function MayBeeBeeSpecific:OnEntitySleep()
    self.inst:StopUpdatingComponent(self)
end

function MayBeeBeeSpecific:OnEntityWake()
    self.inst:StartUpdatingComponent(self)
end

local ElectrifyingList = { "lightningrod", "bug_zapper" }
local ElectrifyingBlackList = { "FX", "NOCLICK", "INLIMBO", "INTERIOR_LIMBO" }

function MayBeeBeeSpecific:OnUpdate(dt)
    if self.inst.Duration ~= nil and self.inst.persists then
	    self.inst.Duration = self.inst.Duration - dt
		if self.inst.Duration <= 0 then
		    self.inst.AnimState:PlayAnimation("death")
			self.inst.persists = false
		    self.inst:DoTaskInTime(2, ErodeAway)			
		end
	end
    local x, y, z = self.inst.Transform:GetWorldPosition()
    for k, v in pairs(TheSim:FindEntities(x, y, z, 5, nil, ElectrifyingBlackList, ElectrifyingList)) do
        if (v.prefab == "bug_zapper" and v.components.fueled and not v.components.fueled:IsEmpty()) or v.charged then
		    if self.CurrentDamage == self.OriginalDamage then
		        self.CurrentDamage = self.OriginalDamage * self.BeePoweredDamageMultiplier
			    if self.inst.components.combat ~= nil then
			        self.inst.components.combat:SetDefaultDamage(self.CurrentDamage)
			    end
			end
			self.ElectrifyingFXCooldown = self.ElectrifyingFXCooldown - dt
			if self.ElectrifyingFXCooldown <= 0 then
     			local lightning_rod_fx = SpawnPrefab("lightning_rod_fx")
				self.inst:AddChild(lightning_rod_fx)
				lightning_rod_fx.Transform:SetScale(0.5, 0.25, 0.5)	
				self.ElectrifyingFXCooldown = 1
			end
		elseif self.CurrentDamage ~= self.OriginalDamage then
            self.CurrentDamage = self.OriginalDamage
		    if self.inst.components.combat ~= nil then
			    self.inst.components.combat:SetDefaultDamage(self.CurrentDamage)
		    end					
		end
    end
end

return MayBeeBeeSpecific