local Physicsthingsshadowdestroyer = Class(function(self, inst)
    self.inst = inst
	
    self.inst:ListenForEvent("transformable_onshadowform", function() self:Enable(true) end)
    self.inst:ListenForEvent("transformable_onnormalform", function() self:Enable(false) end)
	
	self.destroy_cooldown = 0
end)

local DESTROY_MUST_ONEOF_TAGS = {"blocker", "destroyable_via_shadow"} --Note: things with the tag "destroyable_via_shadow" still need to have a active physics.
local DESTROY_CANT_TAGS = {"FX", "NOCLICK", "INLIMBO", "DECOR", "INTERIOR_LIMBO", "player", "boat", "charlie_portal", "shipwrecked_portal", "porkland_portal", "shadow_destroy_immune", "irreplaceable"}

function Physicsthingsshadowdestroyer:Enable(enable)
	if enable then
		self.inst:StartUpdatingComponent(self)
	else
		self.inst:StopUpdatingComponent(self)
	end
end

function Physicsthingsshadowdestroyer:OnUpdate(dt)
    if self.destroy_cooldown > 0 then
	    self.destroy_cooldown = self.destroy_cooldown - dt
	    return		
	end

	if (self.inst.components.transformable ~= nil and self.inst.components.transformable.shadowform) or (self.inst.shadowform ~= nil) then
	    local x, y, z = self.inst.Transform:GetWorldPosition()
	    local EntsToDestroy = TheSim:FindEntities(x, y, z, TUNING.SHADOW_FORM_DESTROY_RADIUS, nil, DESTROY_CANT_TAGS, DESTROY_MUST_ONEOF_TAGS)
	    for i,ent in pairs(EntsToDestroy) do
		    if ent.Physics ~= nil and ent.Physics:IsActive() and ent:IsValid() and ent.entity:IsVisible() then
		        local isworkable = false
                if ent.components.workable ~= nil then
                    local work_action = ent.components.workable.action --In vanilla there is no function "GetWorkAction()", until 2023 BETA UPDATE
                    isworkable =
                        (   work_action == nil and ent:HasTag("campfire")    ) or              
                            (   work_action == ACTIONS.CHOP or
                                work_action == ACTIONS.HAMMER or
                                work_action == ACTIONS.MINE or   
                                work_action == ACTIONS.DIG
                            )
                end
			    if isworkable then
			        if ent.components.workable ~= nil and ent.components.workable.workleft > 0 then
				        ent.components.workable:WorkedBy(self.inst, TUNING.SHADOW_FORM_WORK_NUMBER)
						self.destroy_cooldown = 10
	                    if ent.Transform ~= nil and self.inst:IsValid() then
	                        SpawnPrefab("statue_transition").Transform:SetPosition(ent.Transform:GetWorldPosition())
                            SpawnPrefab("statue_transition_2").Transform:SetPosition(ent.Transform:GetWorldPosition())								
				        end
				    end
                elseif ent.components.pickable ~= nil and ent.components.pickable:CanBePicked() and not ent:HasTag("intense") then
				    local num = ent.components.pickable.numtoharvest or 1
                    local product = ent.components.pickable.product
                    local x1, y1, z1 = nil, nil, nil
					if ent.Transform ~= nil then
					    x1, y1, z1 = ent.Transform:GetWorldPosition()
					end
					ent.components.pickable:Pick()
					self.destroy_cooldown = 10
					if product ~= nil and num > 0 and ent.Transform ~= nil then
                        for i = 1, num do
                            local loot = SpawnPrefab(product)
                            loot.Transform:SetPosition(x1, 0, z1)
							if ent.ApplyInheritedMoisture ~= nil then 
							    ent:ApplyInheritedMoisture(loot)
							end
							if loot.GetIsOnWater ~= nil and loot:GetIsOnWater() then
							    if loot.components.floatable ~= nil then
								    loot.components.floatable:OnHitWater()
								elseif loot.components.inventoryitem ~= nil then
								    loot.components.inventoryitem:OnHitWater()
								end
							end
                        end	
                    end						
				    if ent.Transform ~= nil and self.inst:IsValid() then
	                    SpawnPrefab("statue_transition").Transform:SetPosition(ent.Transform:GetWorldPosition())
                        SpawnPrefab("statue_transition_2").Transform:SetPosition(ent.Transform:GetWorldPosition())								
				    end
				elseif ent:HasTag("destroyable_via_shadow") then
				    if ent.components.workable ~= nil and ent.components.workable.workleft > 0 then
					    ent.components.workable:WorkedBy(self.inst, TUNING.SHADOW_FORM_WORK_NUMBER)
					elseif ent.components.lootdropper ~= nil and not ent:HasTag("no_loot_from_shadow") then
						ent.components.lootdropper:DropLoot()
					end
					self.destroy_cooldown = 10
				    if ent.Transform ~= nil and self.inst:IsValid() then
	                    SpawnPrefab("statue_transition").Transform:SetPosition(ent.Transform:GetWorldPosition())
                        SpawnPrefab("statue_transition_2").Transform:SetPosition(ent.Transform:GetWorldPosition())								
				    end		
					if ent:IsValid() then
                        ent:Remove()	
                    end						
			    end
			end
		end
	end
end

return Physicsthingsshadowdestroyer