local PizzaCuttable = Class(function(self, inst)
    self.inst = inst
end)

function PizzaCuttable:GetProduct(tool, doer)
    local product = nil 
    if self.product ~= nil then 
        if type(self.product) == "function" then
            product = self.product(self.inst, tool, doer)
		elseif type(self.product) == "string" then
	        product = self.product
        end
    end 
    return product
end 

function PizzaCuttable:Cut(tool, doer)
    if self.oncut ~= nil then
		self.oncut(self.inst, tool, doer)
    end
    local product = self:GetProduct(tool, doer)
    if product ~= nil then
        local prod = SpawnPrefab(product)
        if prod ~= nil then
            if self.inst.ApplyInheritedMoisture ~= nil then
                self.inst:ApplyInheritedMoisture(prod)
            end		
            if self.inst.IsMeat then
                prod.IsMeat = true
	        elseif self.inst.IsVegetarian then
                prod.IsVegetarian = true
         	elseif self.inst.IsVegan then
                prod.IsVegan = true
	        elseif self.inst.IsUnpalatable then
                prod.IsUnpalatable = true
	        elseif self.inst.IsMixed then
                prod.IsMixed = true 
	        end
			local x, y, z = self.inst.Transform:GetWorldPosition()
		    if prod.Transform ~= nil then
			    prod.Transform:SetPosition(x, y, z)
			end
			if prod.Physics ~= nil and not self.nojump then
			    prod.Physics:SetVel(2*math.cos(math.random()*2*math.pi), 10, 2*math.sin(math.random()*2*math.pi))
			end
			if self.inst.components.perishable ~= nil and prod.components.perishable ~= nil and not self.alwaysfullfreshness then
				local new_percent = 1 - (1 - self.inst.components.perishable:GetPercent())*0.5
				prod.components.perishable:SetPercent(new_percent)
			end
			if tool ~= nil and not self.infinitecut and (tool.components.pizzacutter == nil or not tool.components.pizzacutter.infinitecut) then
                if tool.components.stackable ~= nil then
                    tool.components.stackable:Get():Remove()
                elseif tool.components.finiteuses ~= nil then
                    tool.components.finiteuses:Use(1)
                else
                    tool:Remove()
                end				
			end
			if not self.duplicable then
                if self.inst.components.stackable ~= nil then
                    self.inst.components.stackable:Get():Remove()
                else
                    self.inst:Remove()
                end			
			end
        end
    end
end

return PizzaCuttable