local Potholepuddle = Class(function(self, inst)
    self.inst = inst
	self.AlreadyFrozenEnts = {}
end)

function Potholepuddle:OnEntitySleep()
    self.inst:StopUpdatingComponent(self)
end

function Potholepuddle:OnEntityWake()
    self.inst:StartUpdatingComponent(self)
end

function Potholepuddle:OnUpdate(dt)
    local x, y, z = self.inst.Transform:GetWorldPosition()
	local DROWN_CANT_TAGS = { "NOCLICK", "INLIMBO", "wall", "structure" }
	local STUN_CANT_TAGS = self.inst.UnaffectedByPuddles or {}
	local LilyPad = nil
	
	if self.inst.UnaffectedByPuddles ~= nil then
	    for k1, v1 in pairs(self.inst.UnaffectedByPuddles) do
		    table.insert(DROWN_CANT_TAGS, v1)
	    end
	end
	
	if self.inst.StunnedByPuddles ~= nil then
	    for k2, v2 in pairs(self.inst.StunnedByPuddles) do
		    table.insert(DROWN_CANT_TAGS, v2)
	    end
	end
	
    for k3, v3 in pairs(TheSim:FindEntities(x, y, z, 2.5, nil, DROWN_CANT_TAGS)) do
        local HasLilyPad = false
        for x, l1 in pairs(TheSim:FindEntities(x, y, z, 0.5, {"LilyPadForPuddle"})) do
		    if l1 ~= nil and l1:IsValid() and l1.entity:IsVisible() then
			    HasLilyPad = true
			    break
			end
		end
		
		if HasLilyPad and self.inst.SafeIfLilyPad ~= nil then
		    for _, j in pairs(self.inst.SafeIfLilyPad) do
			    if v3 ~= nil and v3:IsValid() and v3:HasTag(j) then
			        LilyPad = true
			        break
				end
			end
		end
		
        if v3 ~= nil
		    and v3:IsValid() 
		    and v3.entity:IsVisible()  
			and (v3.components.health ~= nil or v3:HasTag("critter"))
			and self.inst.persists
			and not LilyPad
			and (v3.components.inventory == nil or not v3.components.inventory:IsItemNameEquipped("raincoat")) 
		then
		    if v3.components.lootdropper ~= nil then
			    v3.components.lootdropper.numrandomloot = nil
				v3.components.lootdropper.chanceloot = nil
				v3.components.lootdropper.chanceloottable = nil
				v3.components.lootdropper.ifnotchanceloot = nil
				v3.components.lootdropper.loot = nil
			end
			if v3.components.health ~= nil then
		        v3.components.health:SetVal(0)
			elseif v3:HasTag("critter") then
			    if (IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC)) and v3.Transform then
				    SpawnPrefab("splash_water_sink").Transform:SetPosition(v3.Transform:GetWorldPosition())
				end
			    v3:Remove()
			end
		end
    end
	
    for k4, v4 in pairs(TheSim:FindEntities(x, y, z, 2.5, nil, STUN_CANT_TAGS)) do
        local HasLilyPad = false
        for y, l2 in pairs(TheSim:FindEntities(x, y, z, 0.5, {"LilyPadForPuddle"})) do
		    if l2 ~= nil and l2:IsValid() and l2.entity:IsVisible() then
			    HasLilyPad = true
			    break
			end
		end
		
		if HasLilyPad and self.inst.SafeIfLilyPad ~= nil then
		    for _, j in pairs(self.inst.SafeIfLilyPad) do
			    if v4 ~= nil and v4:IsValid() and v4:HasTag(j) then
			        LilyPad = true
			        break
				end
			end
		end 

        if v4 ~= nil
		    and v4:IsValid() 
		    and v4.entity:IsVisible() 
			and (v4.components.freezable ~= nil and not v4.components.freezable:IsFrozen())
			and self.inst.persists
			and not self.AlreadyFrozenEnts[v4.GUID]
			and not LilyPad
			and (v4.components.inventory == nil or not v4.components.inventory:IsItemNameEquipped("raincoat")) 
		then
			v4.components.freezable:Freeze(self.inst.StunTime or 1)
			self.AlreadyFrozenEnts[v4.GUID] = true
		end
    end	
	
    for k5, v5 in pairs(TheSim:FindEntities(x, y, z, 2.5)) do
	    local IsMech = false
		if self.inst.MechsForPuddles ~= nil then
            for k6, v6 in pairs(self.inst.MechsForPuddles) do
		        if v5.prefab == v6 then
				    IsMech = true
				    break
				end
		    end
		end
		
		if IsMech then
		    if v5.components.floodable ~= nil then
	            --Change in other places
            elseif not v5:HasTag("INLIMBO") and not v5:HasTag("falling") then
			    if (IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC)) and v5.Transform then
				    SpawnPrefab("splash_water_sink").Transform:SetPosition(v5.Transform:GetWorldPosition())
				end
			    v5:Remove()
			end		
		end
    end	
	
end

return Potholepuddle