local Readyformagicchecker = Class(function(self, inst)
    self.inst = inst
	self.checktime = 0.5
	self.inst:StartUpdatingComponent(self)
end)

local MAGIC_SOURCE_MUST_TAG = {"magic_source"}
local MAGIC_SOURCE_CANT_TAGS = {"fire", "burnt", "stump", "smolder", "flooded", "invisible", "FX", "NOCLICK", "INLIMBO", "DECOR", "INTERIOR_LIMBO"}

function Readyformagicchecker:OnUpdate(dt)
    if self.checktime > 0 then 
        self.checktime = self.checktime - dt
    end
	
	if self.checktime <= 0 then
	    self.checktime = 0.5
        local equippeditem = self.inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HEAD)
	    local x, y, z = self.inst.Transform:GetWorldPosition()
	    local magic_source = TheSim:FindEntities(x, y, z, TUNING.MAGIC_SOURCE_RADIUS, MAGIC_SOURCE_MUST_TAG, MAGIC_SOURCE_CANT_TAGS)
        local MagicSourceNearby = (#magic_source > 0)	
	    if (equippeditem and equippeditem:HasTag("magichat")) or MagicSourceNearby then
		    if not self.inst:HasTag("tricks_player") then
	            self.inst:AddTag("tricks_player")
			end
			if not self.inst:HasTag("ready_to_play_tricks") then
	            self.inst:AddTag("ready_to_play_tricks")		
			end
	    else
		    if self.inst:HasTag("tricks_player") then
	            self.inst:RemoveTag("tricks_player")
			end
			if self.inst:HasTag("ready_to_play_tricks") then
	            self.inst:RemoveTag("ready_to_play_tricks")		
			end
	    end	
	end
end

return Readyformagicchecker