local ShadowAcidPuddle = Class(function(self, inst)
    self.inst = inst
    self.cooldowntime = 0 
end)

function ShadowAcidPuddle:OnEntitySleep()
    self.inst:StopUpdatingComponent(self)
end

function ShadowAcidPuddle:OnEntityWake()
    self.inst:StartUpdatingComponent(self)
end

function ShadowAcidPuddle:OnUpdate(dt)

    if self.cooldowntime > 0 then
	    self.cooldowntime = self.cooldowntime - dt
		return 
	end 
	
	local x, y, z = self.inst.Transform:GetWorldPosition() 
	local ents = TheSim:FindEntities(x, y, z, 2.5, {"hascombatcomponent"}, {"FX", "NOCLICK", "INLIMBO", "INTERIOR_LIMBO", "notarget", "companion", "wall", "structure"}) 
	for k,v in pairs(ents) do
	    if v ~= nil 
		    and v.prefab ~= nil 
			and v.prefab ~= "" 
			and v:IsValid() 
			and v.entity:IsVisible()  
			and v.components.combat ~= nil 
			and v.components.health ~= nil 
		then 
            if v:HasTag("shadow") then
				if math.random() < 0.1 and v.components.lootdropper ~= nil then 
				    if math.random() < 0.01 then 
					    v.components.lootdropper:SpawnLootPrefab("horrorfuel")
					else
					    v.components.lootdropper:SpawnLootPrefab("nightmarefuel")
					end 
				end 
				if GetPlayer() ~= nil and GetPlayer().superacidshadowsmoker and v.components.health ~= nil then 
				    v.components.health:DoDelta(self.inst.superacid and 450 or 200)
					v:DoTaskInTime(1, function()
					    v.components.health:DoDelta(self.inst.superacid and 450 or 200)
					end)
					v:DoTaskInTime(2, function()
					    v.components.health:DoDelta(self.inst.superacid and 450 or 200)
					end)					
				end 
			elseif v:HasTag("charlie") then 
			    if v:HasTag("shadow_form_on") then 
				    if v.superacidshadowsmoker and v.components.health ~= nil then 
				        v.components.health:DoDelta(self.inst.superacid and 200 or 75)
					    v:DoTaskInTime(1, function()
					        v.components.health:DoDelta(self.inst.superacid and 200 or 75)
					    end)
					    v:DoTaskInTime(2, function()
					        v.components.health:DoDelta(self.inst.superacid and 200 or 75)
					    end)			
                    end 	
					local amount = 1 
					local chance = 0.05
					if self.inst.superacid then 
					    amount = 3
						chance = 0.1
					end 
					if math.random() < chance and v.components.inventory ~= nil then 
					    for i = 1, amount do
					        v.components.inventory:GiveItem(SpawnPrefab("nitre"), nil, Vector3(TheSim:GetScreenPos(self.inst.Transform:GetWorldPosition()))) 
					    end 
					end 
				end 
			else 
			    v.components.health:SetVal(v.components.health.currenthealth - (self.inst.superacid and 600 or 200), self.inst.prefab) --shadow planar damage
				v:DoTaskInTime(1, function()
				    if v.components.health ~= nil and not v.components.health:IsDead() then 
					    v.components.health:SetVal(v.components.health.currenthealth - (self.inst.superacid and 800 or 225), self.inst.prefab)
					end 
				end)
				v:DoTaskInTime(2, function()
				    if v.components.health ~= nil and not v.components.health:IsDead() then 
					    v.components.health:SetVal(v.components.health.currenthealth - (self.inst.superacid and 1000 or 275), self.inst.prefab)
					end 				
				end)
				if self.inst.superacid then 
				    v:DoTaskInTime(3, function()
				        if v.components.health ~= nil and not v.components.health:IsDead() then 
					        v.components.health:SetVal(v.components.health.currenthealth - 1200, self.inst.prefab)
				    	end 				
				    end)				
				end 
				
				if GetPlayer() ~= nil and GetPlayer().superacidshadowsmoker and v.components.health ~= nil then
					if math.random() < 0.05 and v.components.lootdropper ~= nil then 
				        if math.random() < 0.1 then 
					        v.components.lootdropper:SpawnLootPrefab("horrorfuel")
					    else
					        v.components.lootdropper:SpawnLootPrefab("nightmarefuel")
					    end 
				    end 
				end
				
			end 
			self.cooldowntime = 3
		end
	end   
	
end

return ShadowAcidPuddle