local ShadowAcidSmoke = Class(function(self, inst)
    self.inst = inst
    self.cooldowntime = 0 
end)

function ShadowAcidSmoke:OnEntitySleep()
    self.inst:StopUpdatingComponent(self)
end

function ShadowAcidSmoke:OnEntityWake()
    self.inst:StartUpdatingComponent(self)
end

function ShadowAcidSmoke:OnUpdate(dt)

    if self.cooldowntime > 0 then
	    self.cooldowntime = self.cooldowntime - dt
		return 
	end 
	
	local x, y, z = self.inst.Transform:GetWorldPosition() 
	local ents = TheSim:FindEntities(x, y, z, 2.5, {"hascombatcomponent"}, {"FX", "NOCLICK", "INLIMBO", "INTERIOR_LIMBO", "notarget", "companion", "wall", "structure"}) 
	for k,v in pairs(ents) do
	    if v ~= nil 
		    and v.prefab ~= nil 
			and v.prefab ~= "" 
			and v:IsValid() 
			and v.entity:IsVisible()  
			and v.components.combat ~= nil 
			and v.components.health ~= nil 
		then 
            if v:HasTag("shadow") then
				if math.random() < 0.001 and v.components.lootdropper ~= nil then 
				    if math.random() < 0.0001 then 
					    v.components.lootdropper:SpawnLootPrefab("horrorfuel")
					else
					    v.components.lootdropper:SpawnLootPrefab("nightmarefuel")
					end 
				end 
				if GetPlayer() ~= nil and GetPlayer().superacidshadowsmoker and v.components.health ~= nil then 
				    v.components.health:DoDelta(10)			
				end 
			elseif v:HasTag("charlie") then 
			    if v:HasTag("shadow_form_on") then 
				    if v.superacidshadowsmoker and v.components.health ~= nil then 
				        v.components.health:DoDelta(1)
                    end 	
				end 
			else 
			    v.components.health:SetVal(v.components.health.currenthealth - 20, self.inst.prefab) --shadow planar damage
				if v.components.freezable ~= nil and math.random() < 0.25 then 
				    v.components.freezable:Freeze(0.5)
				end 
				
				if GetPlayer() ~= nil and GetPlayer().superacidshadowsmoker and v.components.health ~= nil then
					if math.random() < 0.01 and v.components.lootdropper ~= nil then 
				        if math.random() < 0.01 then 
					        v.components.lootdropper:SpawnLootPrefab("horrorfuel")
					    else
					        v.components.lootdropper:SpawnLootPrefab("nightmarefuel")
					    end 
				    end 
				end				
			end 
			self.cooldowntime = 1
		end
	end   
	
end

return ShadowAcidSmoke