local ShadowPuddle = Class(function(self, inst)
    self.inst = inst
    self.cooldowntime = 0 
end)

function ShadowPuddle:OnEntitySleep()
    self.inst:StopUpdatingComponent(self)
end

function ShadowPuddle:OnEntityWake()
    self.inst:StartUpdatingComponent(self)
end

function ShadowPuddle:OnUpdate(dt)

    local x, y, z = self.inst.Transform:GetWorldPosition() 
	local shadows = TheSim:FindEntities(x, y, z, 2.5, {"darkitem"}, {"FX", "NOCLICK", "INLIMBO", "INTERIOR_LIMBO", "notarget", "falling"})
	for k2,v2 in pairs(shadows) do
	    if v2 ~= nil 
		    and v2.prefab ~= nil 
			and v2.prefab ~= "" 
			and v2:IsValid() 
			and v2.entity:IsVisible() 
		then 
		    self.inst.persists = false 
			self.cooldowntime = 9999
			if self.inst.DestroyAnimation ~= nil and self.inst.AnimState ~= nil then 
			    self.inst.AnimState:PlayAnimation(self.inst.DestroyAnimation) 
				self.inst:ListenForEvent("animover", self.inst.Remove)
			else
			    self.inst:Remove() 
			end 
		end
	end	

    if self.cooldowntime > 0 then
	    self.cooldowntime = self.cooldowntime - dt
		return 
	end 
	
	local shadowers = TheSim:FindEntities(x, y, z, 2.5, {"shadow_form_on"}, {"FX", "NOCLICK", "INLIMBO", "INTERIOR_LIMBO", "notarget"}) 
	for k,v in pairs(shadowers) do
	    if v ~= nil 
		    and v.prefab ~= nil 
			and v.prefab ~= "" 
			and v:IsValid() 
			and v.entity:IsVisible() 
			and v.supershadowmanipulation 
			and v.components.health ~= nil 
		then 
		    v.components.health:DoDelta(5) 
			if math.random() < 0.1 and v.components.inventory ~= nil then 
			    if math.random() < 0.01 then 
				    v.components.inventory:GiveItem(SpawnPrefab("horrorfuel"), nil, Vector3(TheSim:GetScreenPos(self.inst.Transform:GetWorldPosition()))) 
				else 
				    v.components.inventory:GiveItem(SpawnPrefab("nightmarefuel"), nil, Vector3(TheSim:GetScreenPos(self.inst.Transform:GetWorldPosition()))) 
				end
			end 
			self.cooldowntime = 3
		end
	end   
	
end

return ShadowPuddle