local ShadowRepairable = Class(function(self, inst)
    self.inst = inst
    self.repairmaterial = nil
end)

function ShadowRepairable:SetRepairMaterial(material)
    self.repairmaterial = material
end

function ShadowRepairable:SetOnRepaired(fn)
    self.onrepaired = fn
end

function ShadowRepairable:Repair(doer, repair_item)
    if repair_item == nil or repair_item.components.shadowrepairer == nil or self.repairmaterial ~= repair_item.components.shadowrepairer.repairmaterial then
        return false
    end

	if self.inst.components.armor ~= nil then
	    if self.inst.components.armor:GetPercent() >= 1 then
		    return false
		end
        self.inst.components.armor:SetPercent(1)
	elseif self.inst.components.finiteuses ~= nil then
	    if self.inst.components.finiteuses:GetPercent() >= 1 then
		    return false
		end
		self.inst.components.finiteuses:SetPercent(1)
	elseif self.inst.components.fueled ~= nil then
	    if self.inst.components.fueled:GetPercent() >= 1 then
		    return false
		end
		self.inst.components.fueled:SetPercent(1)
	end
	
    if repair_item.components.stackable ~= nil then
        repair_item.components.stackable:Get():Remove()
    elseif repair_item.components.finiteuses ~= nil then
        repair_item.components.finiteuses:Use(1)
    else
        repair_item:Remove()
    end

    if self.onrepaired ~= nil then
        self.onrepaired(self.inst, doer, repair_item)
    end

    return true
end

return ShadowRepairable
