local ShadowRepairer = Class(function(self, inst)
    self.inst = inst
	self.repairmaterial = nil
end)

function ShadowRepairer:SetRepairMaterial(material)
    self.repairmaterial = material
end

function ShadowRepairer:CanShadowRepair(doer, target)
    if not doer:IsValid() or not target:IsValid() then
	    return false
	end
    if self.canrepairtest ~= nil then
	    return self.canrepairtest(self.inst, doer, target)
	end
	return (target.components.fueled ~= nil and target.components.fueled:GetPercent() < 1)
	    or (target.components.finiteuses ~= nil and target.components.finiteuses:GetPercent() < 1)
		or (target.components.armor ~= nil and target.components.armor:GetPercent() < 1)
end

function ShadowRepairer:CollectUseActions(doer, target, actions, right)
    if right and doer ~= nil and target ~= nil and target.components.shadowrepairable ~= nil and target.components.shadowrepairable.repairmaterial == self.repairmaterial then
        if self:CanShadowRepair(doer, target) then
            table.insert(actions, ACTIONS.SHADOW_REPAIR)
        end
    end
end

return ShadowRepairer

