--This component can be used in all entities (currently Charlie only). But it may be need the supports of other components such as health or combat to work perfectly.
--Please note that data here may overwrite the data in other places, so make sure to modify the data well.
--WARN: THIS COMPONENT IS NOT CURRENTLY COMPATIBLE WITH VANILLA DS

local LIGHT_POROG = 0.4
local LIGHT_DAMAGE_POROG = 0.25

local LIGHT_POROG_VISION = 0.33
local LIGHT_DAMAGE_POROG_NOVISION = 0.5

local LIGHT_DAMAGE_POROG_DAY = 1.25
local LIGHT_DAMAGE_POROG_DUSK = 2
local LIGHT_DAMAGE_POROG_NIGHT = 3
local LIGHT_DAMAGE_POROG_CAVE = 3

local LIGHT_DAMAGE_SHELTER_PROTECT = 0

local SHADOWFORM_PERCENTAGE = 0.32
local NORMALFORM_PERCENTAGE = 0.64

local VISION_CD = 0
local DAMAGE_WARN = 4.5
local DAMAGE_CD = 11.5

local WARN_PHRASES_ENG = {"The light burns!", "The light is eroding me!", "I have to retreat!"}
local WARN_PHRASES_OVER_ENG = {"I'm safe in the dark.", "Back into the realm of shadows.", "Now is my dark time."}
local WARN_PHRASES_OVER_FOGGY_ENG = {"The thick fog blocked the light, ha ha!", "It helps me absorb energy of light."}
local WARN_PHRASES_SHELTER_ENG = {"Much better now.", "A protection from the light.", "Now I can absorb light。"}
local PHRASES_FORM_SHADOW_ENG = {"Now you see me...", "The darkness calls me...", "I missed you...", "It's Metheus's turn...", "Nightmare fuel is playing a role..."}
local PHRASES_FORM_NORMAL_ENG = {"Oh, goodness...", "I'll never get used to that...", "That's enough of that.", "Let me go!", "Did I just... lose control?"}

local WARN_PHRASES_CN = {"这光在灼伤我！", "这光在侵蚀我！", "我得撤退！"}
local WARN_PHRASES_OVER_CN = {"处在黑暗里我很安全。", "重返暗影领域。", "现在是我的黑暗时刻。"}
local WARN_PHRASES_OVER_FOGGY_CN = {"这浓雾遮住了光，哈哈！", "它帮助我吸收光的能量。"}
local WARN_PHRASES_SHELTER_CN = {"现在好多了。", "避光保护。", "现在我可以吸收光了。"}
local PHRASES_FORM_SHADOW_CN = {"现在你可以看到我了……", "黑暗要召唤我了……", "我想你了……", "轮到米修斯了……", "梦魇燃料在发挥作用……"}
local PHRASES_FORM_NORMAL_CN = {"哦，天哪……", "我从不习惯那样……", "够了。", "放过我！", "我刚才……失控了吗？"}

local Transformable = Class(function(self, inst)	
    self.inst = inst 
	
    local IsAnyDLCEnabled = IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC)
    assert(IsAnyDLCEnabled, "Transformable component is not currently compatible with vanilla DS!")	
	
	self.shadowform = nil 
	self.vision = nil 
	self.vision_cd = 0 
	self.damage_cd = 0 
	self.damage_mult = 1 
	self.istakinglightdamage = false
	self.ignoresanitychange = false
	self.normalformtest = nil
	self.shadowformtest = nil
	
--Deprecated
--[[	
	self.multivalued_period = 1.5 
	self.update_values_interval = FRAMES
	self.change_form_interval = 0.25 
	self.damage_task = self.inst:DoPeriodicTask(self.update_values_interval, function() self:UpdateVariableValues(self.update_values_interval) end)	
    self.task = self.inst:DoPeriodicTask(self.multivalued_period, function() self:DoDec(self.multivalued_period) end)
    self.form_task = self.inst:DoPeriodicTask(self.change_form_interval, function() self:OnSanityChange() end)	
]]

    self.update_time = 1.5
	self.change_form_time = 0.25
	
	self.inst:StartUpdatingComponent(self)

end)

function Transformable:OnSave()
    return 
	{
		shadowform = self.shadowform,
		istakinglightdamage = self.istakinglightdamage,
		ignoresanitychange = self.ignoresanitychange,
		IsInInsight = self.IsInInsight,
	}
end

function Transformable:OnLoad(data)
    if data.shadowform then
		self.shadowform = true	
		print("SHADOW FORM LOADED")
		self:SetUpShadowForm(true)   
    end
    if data.istakinglightdamage then
		print("TAKING LIGHT DAMAGE LOADED")
		self.istakinglightdamage = true	
    end
    if data.ignoresanitychange then
		print("IGNORING SANITY LOADED")
		self.ignoresanitychange = true	  
    end
    if data.IsInInsight then
		self.IsInInsight = true	  
    end	
end

---------------------------------------------------
-----------------unused code start-----------------
---------------------------------------------------
--[[
function Transformable:EnterDarkVision()
	if self:VisionTurnOnTest(nil) then
		self:TurnOnNightVision()
	end
end

function Transformable:LongUpdate(dt)

end

function Transformable:OnRespawn()
	
end

function Transformable:SetBurnColor()

end
]]
--[[local function mole_onequip(owner)
    if owner ~= GetPlayer() then return end
    owner.SoundEmitter:PlaySound("dontstarve_DLC001/common/moggles_on")
    if GetClock() and GetWorld() and GetWorld().components.colourcubemanager then
        GetClock():SetNightVision(true)
        if GetClock():IsDay() and not GetWorld():IsCave() and not TheCamera.interior then
            GetWorld().components.colourcubemanager:SetOverrideColourCube("images/colour_cubes/mole_vision_off_cc.tex", .25)
        else
            GetWorld().components.colourcubemanager:SetOverrideColourCube("images/colour_cubes/mole_vision_on_cc.tex", .25)
        end
    end
end]]

--[[local function mole_onunequip(owner)
    if owner ~= GetPlayer() then return end
    owner.SoundEmitter:PlaySound("dontstarve_DLC001/common/moggles_off")
    if GetClock() then
        GetClock():SetNightVision(false)
    end
    if GetWorld() and GetWorld().components.colourcubemanager then
        GetWorld().components.colourcubemanager:SetOverrideColourCube(nil, .5)
    end
end]]

function Transformable:TurnOnNightVision()
	if self.vision then return end
	self.vision = true
	print("vision turn on")	
end

function Transformable:TurnOffNightVision()
	if not self.vision then return end
	self.vision = nil
	print("vision turn off")	
end
---------------------------------------------------
----------------unused code end--------------------
---------------------------------------------------




function Transformable:ResetColor()
    if self.inst.AnimState ~= nil then
	    self.inst.AnimState:SetMultColour(1, 1, 1, 1)
    end
end

function Transformable:SetShadowColor()
    if self.inst.AnimState ~= nil then
	    if TUNING.SHADOW_CHARLIE_MULT ~= 0 then
	        self.inst.AnimState:SetMultColour(TUNING.SHADOW_CHARLIE_MULT, TUNING.SHADOW_CHARLIE_MULT, TUNING.SHADOW_CHARLIE_MULT, TUNING.SHADOW_CHARLIE_MULT)
		else
		    self.inst.AnimState:SetMultColour(TUNING.SHADOW_CHARLIE_MULT, TUNING.SHADOW_CHARLIE_MULT, TUNING.SHADOW_CHARLIE_MULT, 0.5)
		end
	end
end

function Transformable:SetUpShadowForm(donot_check_skin, dontupdatehealth)

    if self.inst.Light ~= nil then
        self.inst.Light:Enable(true)
	end
	
	if self.inst.DynamicShadow ~= nil then
        self.inst.DynamicShadow:Enable(false)
	end
	
    if self.inst:HasTag("lightsource") then       
        self.inst:RemoveTag("lightsource")    
    end
	
    self:SetShadowColor()
 	self.inst:AddTag("shadow_form_on")

    if self.inst.components.combat ~= nil then
	    self.inst.components.combat:SetAttackPeriod(TUNING.WILSON_ATTACK_PERIOD * TUNING.SHADOW_ATTACK_PERIOD_MODE)
	end

    if self.inst.components.talker ~= nil then
	    self.inst.components.talker.colour = Vector3(0.9, 0.29, 0.29, 1)
	end
	
    --TUNING.WET_ITEM_DAPPERNESS = 0
    --TUNING.MOISTURE_SANITY_PENALTY_MAX = 0
	
    if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
	    if self.inst.components.sanity ~= nil then
	        self.inst.components.sanity.wetnessImmune = true
		end
    end
		
    if self.inst.components.autoshadowabsorber ~= nil then
		self.inst.components.autoshadowabsorber:CheckIfCanEnable()
    end			
		
    if self.inst.components.playerlightningtarget ~= nil then
        self.inst.components.playerlightningtarget:SetHitChance(0)
    end

    if self.inst.components.freezable ~= nil then
        self.inst.components.freezable:SetDefaultWearOffTime(TUNING.SHADOW_CHARLIE_FREEZE_WEAR_OFF_TIME)   
        self.inst.components.freezable.resistance = TUNING.SHADOW_CHARLIE_FREEZE_RESISTANCE     
    end
	
    if self.inst.components.eater ~= nil then
	   	self.inst.components.eater:SetAbsorptionModifiers(0.25, 0.25, 0)
    end

    if self.inst.components.burnable ~= nil then
	   	self.inst.components.burnable:SetBurnTime(0)
    end

    if self.inst.components.locomotor ~= nil and self.inst.hasspeedbuffonhittingother == nil then
        self.inst.components.locomotor.walkspeed = TUNING.WILSON_WALK_SPEED * TUNING.SHADOW_CHARLIE_WALK_SPEED_MULT_VANILLA  
        self.inst.components.locomotor.runspeed = TUNING.WILSON_RUN_SPEED * TUNING.SHADOW_CHARLIE_RUN_SPEED_MULT_VANILLA   
    end

    if self.inst.components.poisonable ~= nil then
		if self.inst.components.poisonable:IsPoisoned() then
	   	    self.inst.components.poisonable:Cure()
		end
	   	self.inst.components.poisonable.blockall = true
    end

    if self.inst.components.hunger ~= nil then		
	    self.inst.components.hunger:SetRate(TUNING.WILSON_HUNGER_RATE * TUNING.SHADOW_CHARLIE_HUNGER_RATE_MULT)  
        self.inst.components.hunger:SetKillRate(TUNING.SHADOW_CHARLIE_HUNGER_KILL_RATE_MULT)   
    end
		
    if IsDLCEnabled(PORKLAND_DLC) then
		SpawnPrefab("vortex_cloak_fx").entity:SetParent(self.inst.entity)
	end
	
	SpawnPrefab("statue_transition").entity:SetParent(self.inst.entity)
	SpawnPrefab("statue_transition_2").entity:SetParent(self.inst.entity)
	
	if self.inst.SoundEmitter ~= nil then
	    self.inst.SoundEmitter:PlaySound("dontstarve/sanity/creature1/appear", "shadow_form")
	    self.inst:DoTaskInTime(1.8, function()
		    self.inst.SoundEmitter:KillSound("shadow_form")
	    end)
	end
	
	self.shadowform = true
	
	if not donot_check_skin then
        if self.inst.components.dsskins ~= nil then
		    self.inst.components.dsskins:Changeskin(true)
        end
		
        local health_percent = self.inst.components.health ~= nil and self.inst.components.health:GetPercent() or nil

	    if self.inst.components.charlierefreshmodlevel ~= nil then
	        self.inst.components.charlierefreshmodlevel:UpdateData()
    	end			

	    if health_percent ~= nil then
	        self.inst.components.health:SetPercent(health_percent)
        end	
	end

	if not dontupdatehealth and self.inst.components.health ~= nil then
	    self.inst.components.health:DoDelta(0, nil, nil, true)	  --Update health when being on invincible state if not killed
	end
	
	if self.inst.CheckPeriodicShadowPuddleSpawn then 
	    self.inst:CheckPeriodicShadowPuddleSpawn() 
	end
	
	if self.onshadowform ~= nil then
        self.onshadowform(self.inst, donot_check_skin, dontupdatehealth)
	end	
	
	self.inst:PushEvent("transformable_onshadowform", {ignoreskin = donot_check_skin, ignorehealthupdate = dontupdatehealth})
	
	print("shadow form on")
	
end

function Transformable:SetUpNormalForm(dontupdatehealth)

    if self.inst.Light ~= nil and not self.IsInInsight then
        self.inst.Light:Enable(false)
	end
	
	if self.inst.DynamicShadow ~= nil then
        self.inst.DynamicShadow:Enable(true)
	end
	
	self:ResetColor()
 	self.inst:RemoveTag("shadow_form_on")

    if self.inst.components.combat ~= nil then
	    self.inst.components.combat:SetAttackPeriod(TUNING.WILSON_ATTACK_PERIOD * TUNING.UNSHADOW_ATTACK_PERIOD_MODE)
	end
	
    if self.inst.components.talker ~= nil then
	    self.inst.components.talker.colour = Vector3(255/255, 160/255, 203/255, 1) 
	end
	
	if self.inst.SoundEmitter ~= nil then
	    self.inst.SoundEmitter:PlaySound("dontstarve/sanity/creature1/death", "normal_form")
		self.inst:DoTaskInTime(1.8, function()
		    self.inst.SoundEmitter:KillSound("normal_form")
	    end)	
	end

    if self.inst.components.burnable ~= nil then
	   	self.inst.components.burnable:SetBurnTime(TUNING.PLAYER_BURN_TIME)
    end

    if self.inst.components.poisonable ~= nil then
	   	self.inst.components.poisonable.blockall = nil
    end
	
    if IsDLCEnabled(PORKLAND_DLC) then
		SpawnPrefab("vortex_cloak_fx").entity:SetParent(self.inst.entity)
	end

    SpawnPrefab("statue_transition").entity:SetParent(self.inst.entity)
	SpawnPrefab("statue_transition_2").entity:SetParent(self.inst.entity)

    if self.inst.components.playerlightningtarget ~= nil then
        self.inst.components.playerlightningtarget:SetHitChance(0.3)
    end
	
    if self.inst.components.autoshadowabsorber ~= nil then
		self.inst.components.autoshadowabsorber:CheckIfCanEnable()
    end				
	
    local health_percent = self.inst.components.health ~= nil and self.inst.components.health:GetPercent() or nil

	if self.inst.components.charlierefreshmodlevel ~= nil then
	    self.inst.components.charlierefreshmodlevel:UpdateData()
	end
	
	if self.inst.components.inventory ~= nil and self.inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) then 
	    local limited_to_shadow_form_item = self.inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS):HasTag("limited_to_shadow_form") or nil 
		if limited_to_shadow_form_item ~= nil then 
		    self.inst.components.inventory:DropItem(self.inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS), true, true)
		end 
	end 
	
	if self.inst.components.locomotor ~= nil and self.inst.hasspeedbuffonhittingother == nil then
        self.inst.components.locomotor.walkspeed = TUNING.WILSON_WALK_SPEED * TUNING.CHARLIE_WALK_SPEED_MULT_VANILLA   
	    self.inst.components.locomotor.runspeed = TUNING.WILSON_RUN_SPEED * TUNING.CHARLIE_RUN_SPEED_MULT_VANILLA	    		
    end	
	
	if health_percent ~= nil then
	    self.inst.components.health:SetPercent(health_percent)
    end
	
	if not dontupdatehealth and self.inst.components.health ~= nil then
	    self.inst.components.health:DoDelta(0, nil, nil, true)	  --Update health when being on invincible state if not killed
	end
	
    --TUNING.WET_ITEM_DAPPERNESS = -0.1
    --TUNING.MOISTURE_SANITY_PENALTY_MAX = -100/(300*6)

    if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
	    if self.inst.components.sanity ~= nil then
            self.inst.components.sanity.wetnessImmune = false
		end
    end

    if self.inst.components.eater ~= nil then		
	    self.inst.components.eater:SetAbsorptionModifiers(1, 1, 1)
    end

    if self.inst.components.freezable ~= nil then
        self.inst.components.freezable:SetDefaultWearOffTime(TUNING.PLAYER_FREEZE_WEAR_OFF_TIME)   
        self.inst.components.freezable.resistance = TUNING.CHARLIE_FREEZE_RESISTANCE            
    end

    if self.inst.components.hunger ~= nil then
	    self.inst.components.hunger:SetRate(TUNING.WILSON_HUNGER_RATE * TUNING.CHARLIE_HUNGER_RATE_MULT_VANILLA)    
        self.inst.components.hunger:SetKillRate(TUNING.CHARLIE_HUNGER_KILL_RATE_MULT)      
    end
	
	self.shadowform = nil
    if self.inst.components.dsskins ~= nil then
	    self.inst.components.dsskins:Changeskin()
    end
	
	if self.inst.shadowmanipulation and self.inst.DropShadowFuelAsShadowManipulation and not self.inst.dropshadowfuelcooldown then
	    self.inst:DropShadowFuelAsShadowManipulation() 
	end	 
	
	if self.inst.CheckPeriodicShadowPuddleSpawn then 
	    self.inst:CheckPeriodicShadowPuddleSpawn() 
	end

	if self.onnormalform ~= nil then
        self.onnormalform(self.inst, dontupdatehealth)
	end
	
	self.inst:PushEvent("transformable_onnormalform", {ignorehealthupdate = dontupdatehealth})
	
	print("shadow form off")
	
end

function Transformable:IsInLight(porog)

	local spawnPos = Vector3(self.inst.Transform:GetWorldPosition())  
	local lightLevel = TheSim:GetLightAtPoint(spawnPos:Get())
	--print("lightLevel "..lightLevel.."| light porog "..porog)
	if lightLevel > porog then
		return lightLevel
	else
		return
	end

end

local seg_time = 30
local total_day_time = seg_time*16
local lightdps_max_porog = 0.48
local lightdps_max = 60/seg_time

function Transformable:VisionTurnOnTest(is_in_light_vision)
	if self.shadowform and not self.vision and not is_in_light_vision and self.inst:HasTag("lightsource") then
		return true    
	end
	return 
end

local function CanCheckPhysic(inst)
	if inst.AnimState ~= nil and (
		inst.AnimState:IsCurrentAnimation("jumpboat") or
        inst.AnimState:IsCurrentAnimation("land") or
		inst.AnimState:IsCurrentAnimation("landboat") 
      	) then
	    return false
	end
	return true
end

function Transformable:UpdateVariableValues(dt)
	
	local damage_phase = 5
    if GetWorld():IsRuins() then
        damage_phase = 1
	elseif GetWorld():IsCave() then
		damage_phase = 2
	elseif GetClock() and GetClock():IsDay() then
		damage_phase = 5
	elseif GetClock() and GetClock():IsDusk() then
		damage_phase = 4
	elseif GetClock() and GetClock():IsNight() then
		damage_phase = 3
	end
	
	if self.inst.components.inventory ~= nil 
	    and self.inst.components.inventory:EquipHasTag("super_shadow_item") 
	then
        damage_phase = 1
	end		
	
	if self.shadowform then

        if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
		    if self.inst.damage_mult_shadow == nil then
		        self.damage_mult = TUNING.DAMAGE_SHADOW_ALLPHASES[damage_phase]  
			end
		else
            if self.inst.components.combat ~= nil and self.inst.damage_mult_shadow == nil then
			    self.inst.components.combat.damagemultiplier = TUNING.DAMAGE_SHADOW_ALLPHASES[damage_phase]
			elseif self.inst.damage_mult_shadow == nil then
			    self.damage_mult = TUNING.DAMAGE_SHADOW_ALLPHASES[damage_phase] 
            end
		end
		
		if self.inst.damage_mult_shadow ~= nil then
		    if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
			    self.damage_mult = self.inst.damage_mult_shadow[damage_phase]  
			else
			    if self.inst.components.combat ~= nil then
				    self.inst.components.combat.damagemultiplier = self.inst.damage_mult_shadow[damage_phase]  
				else
				    self.damage_mult = self.inst.damage_mult_shadow[damage_phase]  
				end
			end
		end

		if self.inst.components.combat ~= nil  then
		    if self.inst.unarmed_damage_shadow == nil then
		        self.inst.components.combat:SetDefaultDamage(TUNING.SHADOW_FORM_UNARMED_DAMAGE_ALLPHASES[damage_phase])
			else
			    self.inst.components.combat:SetDefaultDamage(self.inst.unarmed_damage_shadow[damage_phase])
			end
		end
		
		if self.inst.Physics ~= nil and CanCheckPhysic(self.inst) then
		    self.inst.Physics:ClearCollisionMask()
	        self.inst.Physics:SetCollisionGroup(COLLISION.CHARACTERS)
		    self.inst.Physics:CollidesWith(COLLISION.SANITY)

		    if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
	            self.inst.Physics:CollidesWith(COLLISION.WAVES)		
	        end
		
	        if IsDLCEnabled(PORKLAND_DLC) then
			    self.inst.Physics:CollidesWith(GetWorldCollision())
	            self.inst.Physics:CollidesWith(GetWaterCollision())
			    self.inst.Physics:CollidesWith(COLLISION.INTWALL)			
	        else
	            self.inst.Physics:CollidesWith(COLLISION.WORLD)
	        end
		end
		
		if self.inst.components.health ~= nil then
		    if self.inst.DAMAGE_REDUCTION_SHADOW == nil then
	      	    self.inst.components.health.absorb = TUNING.PROTECTION_ALLPHASES[damage_phase]   
			else
			    self.inst.components.health.absorb = self.inst.DAMAGE_REDUCTION_SHADOW[damage_phase]
			end   
		end
	
        if self.inst.components.talker ~= nil then
      	    self.inst.components.talker.colour = Vector3(0.9, 0.29, 0.29, 1)		
        end

 	    if self.inst.components.sanity ~= nil then
	        self.inst.components.sanity.night_drain_mult = TUNING.SHADOW_CHARLIE_NIGHT_SANITY_MULT  
	        self.inst.components.sanity.neg_aura_mult = TUNING.SHADOW_CHARLIE_NEG_SANITY_MULT    
        end	

        if self.inst.components.poisonable ~= nil then
		    if self.inst.components.poisonable:IsPoisoned() then
	   	        self.inst.components.poisonable:Cure()
			end
        end
		
	    if self.inst.Light ~= nil then
            self.inst.Light:Enable(true)
		end
	
        if self.inst:HasTag("lightsource") then
            self.inst:RemoveTag("lightsource")    
        end
		
		if not self.inst:HasTag("shadow_form_on") then
 		    self.inst:AddTag("shadow_form_on")
	    end
--[[		
        if not self.inst:HasTag("not_hit_stunned") then
		    local inventory = self.inst.components.inventory
		    if inventory ~= nil and not inventory:EquipHasTag("vortex_cloak") then
 		        self.inst:AddTag("not_hit_stunned")
			end
        end
]]		
        if not self.inst:HasTag("has_gasmask") then
		    local inventory = self.inst.components.inventory
		    if inventory ~= nil and not inventory:EquipHasTag("gasmask") then
 		        self.inst:AddTag("has_gasmask")
			end
        end		
	
	else

        if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
		    if self.inst.damage_mult == nil then
		        self.damage_mult = TUNING.DAMAGE_NORMAL_ALLPHASES[damage_phase]	 
			end
        else
		    if self.inst.components.combat ~= nil and self.inst.damage_mult == nil then
		        self.inst.components.combat.damagemultiplier = TUNING.DAMAGE_NORMAL_ALLPHASES[damage_phase]  
			elseif self.inst.damage_mult == nil then
			    self.damage_mult = TUNING.DAMAGE_NORMAL_ALLPHASES[damage_phase]	 
		    end
		end
		
		if self.inst.damage_mult ~= nil then
		    if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
			    self.damage_mult = self.inst.damage_mult[damage_phase]  
			else
			    if self.inst.components.combat ~= nil then
				    self.inst.components.combat.damagemultiplier = self.inst.damage_mult[damage_phase]  
				else
				    self.damage_mult = self.inst.damage_mult[damage_phase]  
				end
			end
		end		
		
		if self.inst.components.combat ~= nil then
		    self.inst.components.combat:SetDefaultDamage(TUNING.UNARMED_DAMAGE)
		end
--[[
        if self.inst:HasTag("not_hit_stunned") then
		    local inventory = self.inst.components.inventory
		    if inventory ~= nil and not inventory:EquipHasTag("vortex_cloak") then		
 		        self.inst:RemoveTag("not_hit_stunned")
			end
        end
]]
        if self.inst:HasTag("has_gasmask") then
		    local inventory = self.inst.components.inventory
		    if inventory ~= nil and not inventory:EquipHasTag("gasmask") then
 		        self.inst:RemoveTag("has_gasmask")
			end
        end
		
		if self.inst.Physics ~= nil and CanCheckPhysic(self.inst) then
		    self.inst.Physics:ClearCollisionMask()
		    self.inst.Physics:SetCollisionGroup(COLLISION.CHARACTERS)
			
		    if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
	            self.inst.Physics:CollidesWith(COLLISION.WAVES)
		    end
			
		    if IsDLCEnabled(PORKLAND_DLC) then
			    self.inst.Physics:CollidesWith(GetWorldCollision())
	            self.inst.Physics:CollidesWith(GetWaterCollision())
			    self.inst.Physics:CollidesWith(COLLISION.INTWALL)
	        else
	            self.inst.Physics:CollidesWith(COLLISION.WORLD)
	        end
	
	        self.inst.Physics:CollidesWith(COLLISION.OBSTACLES)
            self.inst.Physics:CollidesWith(COLLISION.CHARACTERS)
        end
		
		if self.inst.Light ~= nil and not self.IsInInsight then
            self.inst.Light:Enable(false)
		end

        if self.inst.components.talker ~= nil then
            self.inst.components.talker.colour = Vector3(255/255, 160/255, 203/255, 1)   
        end
		
        if self.inst.components.sanity ~= nil then
	        self.inst.components.sanity.night_drain_mult = TUNING.CHARLIE_NIGHT_SANITY_MULT   
	        self.inst.components.sanity.neg_aura_mult = TUNING.CHARLIE_NEG_SANITY_MULT    
        end		
	
	    if self.inst:HasTag("shadow_form_on") then
 		    self.inst:RemoveTag("shadow_form_on")
		end
		
		if self.inst.components.health ~= nil then
		    if self.inst.DAMAGE_REDUCTION == nil then
	      	    self.inst.components.health.absorb = TUNING.PROTECTION_ALLPHASES[damage_phase]   
			else
			    self.inst.components.health.absorb = self.inst.DAMAGE_REDUCTION[damage_phase]
			end
        end

	end

end

---------------------------------

function Transformable:OnSanityChange()
    if not self.ignoresanitychange and not self.IsInInsight then
        if self.inst.components.sanity ~= nil then
	        if self.inst.components.sanity:GetPercent() <= SHADOWFORM_PERCENTAGE and not self.shadowform then
		        self:SetUpShadowForm()
			    if self.inst.components.health ~= nil then
                    self.inst.components.health:StartRegen(self.inst.ShadowHealthGain or 12, self.inst.ShadowHealthTime or 20, false)
                end				
                if self.inst.components.talker ~= nil then
                    if TUNING.LANGUAGE == true then
	                	self.inst.components.talker:Say(PHRASES_FORM_SHADOW_ENG[math.random(#PHRASES_FORM_SHADOW_ENG)])
                    elseif TUNING.LANGUAGE == false then
	                	self.inst.components.talker:Say(PHRASES_FORM_SHADOW_CN[math.random(#PHRASES_FORM_SHADOW_CN)])		
	     	        end
                end
	        elseif self.shadowform and self.inst.components.sanity:GetPercent() >= NORMALFORM_PERCENTAGE then
	      	    self:SetUpNormalForm()
			    self.istakinglightdamage = false
			    if self.inst.components.health ~= nil then
			        self.inst.components.health:StopRegen()
			    end
                if self.inst.components.talker ~= nil then
                    if TUNING.LANGUAGE == true then
		                self.inst.components.talker:Say(PHRASES_FORM_NORMAL_ENG[math.random(#PHRASES_FORM_NORMAL_ENG)])		
                    elseif TUNING.LANGUAGE == false then
		                self.inst.components.talker:Say(PHRASES_FORM_NORMAL_CN[math.random(#PHRASES_FORM_NORMAL_CN)])		
                    end
                end
	        end	
	    end
    end
end

function Transformable:SetNormalFormTest(fn)
    self.normalformtest = fn
end

function Transformable:SetShadowFormTest(fn)
	self.shadowformtest = fn
end

function Transformable:CancelAllFormTest()
	self.normalformtest = nil
	self.shadowformtest = nil
end

function Transformable:DoDec(dt)
	--print("=============================================")
	--print("=============================================")	
	--print("=============================================")

	local damage_porog = LIGHT_DAMAGE_POROG
	local vision_porog = LIGHT_POROG_VISION
	if self.vision then
		if GetWorld():IsCave() then
			damage_porog = LIGHT_DAMAGE_POROG_CAVE 
		elseif GetClock() and GetClock():IsDay() then
			damage_porog = LIGHT_DAMAGE_POROG_DAY
		elseif GetClock() and GetClock():IsDusk() then
			damage_porog = LIGHT_DAMAGE_POROG_DUSK
		elseif GetClock() and GetClock():IsNight() then
			damage_porog = LIGHT_DAMAGE_POROG_NIGHT
		end
		--print("vision porog state")
		vision_porog = damage_porog
	else
		vision_porog = LIGHT_POROG_VISION
		damage_porog = LIGHT_DAMAGE_POROG_NOVISION
	end
	
	
	--print("damage porog = "..damage_porog)
	local is_in_light = self:IsInLight(damage_porog)
	local is_in_light_vision = self:IsInLight(damage_porog)
	
	if self:VisionTurnOnTest(is_in_light_vision) then
		if self.vision_cd > VISION_CD then
			self.vision_cd = 0
		else
			self.vision_cd = self.vision_cd + self.update_time --Changed from dt
		end
	elseif self.vision and ((not self.shadowform) or is_in_light_vision) then
		self.vision_cd = 0
	end
	
	if self.shadowform then			
		if is_in_light and not (IsDLCEnabled(PORKLAND_DLC) and SaveGameIndex:IsModePorkland() and GetSeasonManager() and GetSeasonManager():IsFoggy() and not TheCamera.interior) 
		               and not (IsDLCEnabled(PORKLAND_DLC) and SaveGameIndex:IsModePorkland() and GetClock() and GetClock():GetBloodMoon() and not TheCamera.interior) 
					   and not (self.inst.components.health ~= nil and self.inst.components.health:IsDead())
					   and not (IsDLCEnabled(PORKLAND_DLC) and GetInteriorSpawner() and GetInteriorSpawner():InPlayerRoom() and self.inst.LightWatcher:GetLightValue() < (1)) then
			local rate = 1
			---------------------------------------------------------------
			if self.inst.components.moisture ~= nil and self.inst.components.inventory ~= nil then
			    if self.inst.components.moisture.sheltered then
				    rate = rate * (1 - (self.inst.components.inventory:GetWaterproofness() + self.inst.components.moisture.shelter_waterproofness))
			    else----CODE HERE NOT COMPATIBLE WITH VANILLA DS-----------
				    rate = rate * (1 - self.inst.components.inventory:GetWaterproofness())
			    end
			end
			---------------------------------------------------------------
			--print("rate = "..rate)			
			
			if rate <= LIGHT_DAMAGE_SHELTER_PROTECT then
				--print("Rate is too low, no damage")
				
				if self.damage_cd > DAMAGE_WARN+1 then
                    if self.inst.components.talker ~= nil then
                        if TUNING.LANGUAGE == true then
	    				    self.inst.components.talker:Say(WARN_PHRASES_SHELTER_ENG[math.random(#WARN_PHRASES_SHELTER_ENG)])
                        elseif TUNING.LANGUAGE == false then
	    				    self.inst.components.talker:Say(WARN_PHRASES_SHELTER_CN[math.random(#WARN_PHRASES_SHELTER_CN)])
                        end
                    end
				end
				if self.inst.components.health ~= nil then
                    self.inst.components.health:StartRegen(self.inst.ShadowHealthGain or 12, self.inst.ShadowHealthTime or 20, false)
                end					
				self.damage_cd = 0
				self.istakinglightdamage = false
				
			elseif is_in_light > damage_porog then
				self.damage_cd = self.damage_cd + self.update_time --Changed from dt
				if (self.damage_cd > DAMAGE_WARN) and (self.damage_cd < DAMAGE_WARN+self.update_time+0.1) then
                    if self.inst.components.talker ~= nil then
                        if TUNING.LANGUAGE == true then
				         	self.inst.components.talker:Say(WARN_PHRASES_ENG[math.random(#WARN_PHRASES_ENG)])
                        elseif TUNING.LANGUAGE == false then
			    	       	self.inst.components.talker:Say(WARN_PHRASES_CN[math.random(#WARN_PHRASES_CN)])
                        end
                    end
				end
				
				if self.damage_cd > (DAMAGE_CD - self.update_time) then
				    --Don't know what this does for yet.
				end
				
				if self.damage_cd > DAMAGE_CD then
					local damage = rate * lightdps_max * (is_in_light/lightdps_max_porog)
					--print("damage = "..damage)
					if self.inst.components.health ~= nil then
				        self.inst.components.health:DoFireDamage(damage, nil, true)
					end
				    self.damage_cd = 11.5				
				end
				
				if self.inst.components.health ~= nil then
				    local GetInventory = self.inst.components.inventory
					if GetInventory ~= nil and GetInventory:EquipHasTag("fire_immune_item") then
					    self.inst.components.health:StartRegen(self.inst.ShadowHealthGain or 12, self.inst.ShadowHealthTime or 20, false)
					    self.istakinglightdamage = false
					else
				        self.inst.components.health:StopRegen()
						self.istakinglightdamage = true
					end	
				end
			end
		else
			if self.damage_cd > DAMAGE_WARN+1 
		     	and not (self.inst.components.health ~= nil and self.inst.components.health:IsDead())
		     	and not (IsDLCEnabled(PORKLAND_DLC) and SaveGameIndex:IsModePorkland() and GetSeasonManager() and GetSeasonManager():IsFoggy()) then
                if self.inst.components.talker ~= nil then
                    if TUNING.LANGUAGE == true then
		    		    self.inst.components.talker:Say(WARN_PHRASES_OVER_ENG[math.random(#WARN_PHRASES_OVER_ENG)])
                    elseif TUNING.LANGUAGE == false then
		    		    self.inst.components.talker:Say(WARN_PHRASES_OVER_CN[math.random(#WARN_PHRASES_OVER_CN)])
                    end
                end
            elseif self.damage_cd > DAMAGE_WARN+1 
			       and (IsDLCEnabled(PORKLAND_DLC) and SaveGameIndex:IsModePorkland() and GetSeasonManager() and GetSeasonManager():IsFoggy()) then
                if self.inst.components.talker ~= nil then
                    if TUNING.LANGUAGE == true then
		    		    self.inst.components.talker:Say(WARN_PHRASES_OVER_FOGGY_ENG[math.random(#WARN_PHRASES_OVER_FOGGY_ENG)])
                    elseif TUNING.LANGUAGE == false then
	    			    self.inst.components.talker:Say(WARN_PHRASES_OVER_FOGGY_CN[math.random(#WARN_PHRASES_OVER_FOGGY_CN)])
                    end
                end
			end
			if self.inst.components.health ~= nil then
			    self.inst.components.health:StartRegen(self.inst.ShadowHealthGain or 12, self.inst.ShadowHealthTime or 20, false)
            end				
			self.damage_cd = 0
			self.istakinglightdamage = false
		end
		
	elseif self.damage_cd > 0 then
		self.damage_cd = 0
	end
	
	if self.normalformtest ~= nil and self.normalformtest(self.inst) then
	    if self.shadowform then
		    self:SetUpNormalForm()
		end
	end
	
	if self.shadowformtest ~= nil and self.shadowformtest(self.inst) then
	    if not self.shadowform then
		    self:SetUpShadowForm()
		end
	end	
	
end

function Transformable:OnUpdate(dt)
    self:UpdateVariableValues(dt)
    if self.change_form_time > 0 then	
	    self.change_form_time = self.change_form_time - dt	
	end
	if self.change_form_time <= 0 then
	    self.change_form_time = 0.25
		self:OnSanityChange()
	end
	if self.update_time > 0 then
	    self.update_time = self.update_time - dt
	end
	if self.update_time <= 0 then
	    self.update_time = 1.5
		self:DoDec(dt)
	end
end

function Transformable:EnterInsightState(pushevent)
    if self.shadowform then
	    self:SetUpNormalForm()
	end
	self.IsInInsight = true
	if self.inst.Light ~= nil then
	    self.inst.Light:Enable(true)
	end
	if pushevent then
	    self.inst:PushEvent("Transformable_EnterInsightState")
	end
end

function Transformable:ExitInsightState()
    self.IsInInsight = nil
	self.inst:DoTaskInTime(0, function()
	    if self.inst.Light ~= nil then
	        self.inst.Light:Enable(false)
	    end	
	end)
end

function Transformable:IgnoreSanityToSetUpShadowForm()
    if not self.shadowform and not self.IsInInsight then
        self.ignoresanitychange = true
		self:SetUpShadowForm()
		if self.inst.components.health ~= nil then
			self.inst.components.health:StartRegen(self.inst.ShadowHealthGain or 12, self.inst.ShadowHealthTime or 20, false)
		end
		if self.inst.components.talker ~= nil then
            if TUNING.LANGUAGE == true then
	            self.inst.components.talker:Say(PHRASES_FORM_SHADOW_ENG[math.random(#PHRASES_FORM_SHADOW_ENG)])
            elseif TUNING.LANGUAGE == false then
	            self.inst.components.talker:Say(PHRASES_FORM_SHADOW_CN[math.random(#PHRASES_FORM_SHADOW_CN)])		
	     	end		
		end
	end
end

function Transformable:SetUpNormalFormDueToIgnoringSanityChangeAndLight()
    if self.istakinglightdamage 
	    and self.shadowform 
		and self.ignoresanitychange 
	    and (self.inst.components.sanity == nil or self.inst.components.sanity:GetPercent() > SHADOWFORM_PERCENTAGE)
	then
	    self:SetUpNormalForm()
	    self.ignoresanitychange = false
	    self.istakinglightdamage = false
		if self.inst.components.health ~= nil then
			self.inst.components.health:StopRegen()
		end	
        if self.inst.components.talker ~= nil then		
            if TUNING.LANGUAGE == true then
	            self.inst.components.talker:Say(PHRASES_FORM_NORMAL_ENG[math.random(#PHRASES_FORM_NORMAL_ENG)])
            elseif TUNING.LANGUAGE == false then
	            self.inst.components.talker:Say(PHRASES_FORM_NORMAL_CN[math.random(#PHRASES_FORM_NORMAL_CN)])		
	     	end
        end				
	end
end

return Transformable
