local ValentineDayFishingRod = Class(function(self, inst)
    self.inst = inst
end)

function ValentineDayFishingRod:GetRewards()
    if self.custome_rewards_fn ~= nil then
	    return self.custome_rewards_fn(self.inst)
	end 
    local rewards =  
	{
        "boards",
        "rope",
        "twigs",
        "twigs",
        "twigs",
        "cutgrass",
        "cutgrass",
        "cutgrass",
        "log",
        "log",
		"rose_inv",
		"rose_inv",
		"rose_inv",
		"rose_inv",
		"rose_inv",		
		"feather_crow",
		"feather_robin",
		"feather_robin_winter",
        "sunken_boat_trinket_1",
        "sunken_boat_trinket_2",
        "sunken_boat_trinket_3",
        "sunken_boat_trinket_5",	
	}
	if not TheSim:FindFirstEntityWithTag("task_envelope") then
	    table.insert(rewards, "charlie_valentine_day_envelope")
	end
	if math.random() < 0.1 then
	    table.insert(rewards, "sunken_boat_trinket_4")
	end
	if math.random() < 0.01 then
	    table.insert(rewards, "krampus_sack")
	end
	return rewards
end

function ValentineDayFishingRod:DropRewards(doer, pos)
    if self.custome_drop_rewards_fn ~= nil then
        self.custome_drop_rewards_fn(self.inst, doer, pos)
	else
	    local reward = self:GetRewards()
        if type(reward) == "table" and #reward > 0 then
		    local loot = SpawnPrefab(GetRandomItem(reward))
			if loot ~= nil and pos ~= nil then
			    loot.Transform:SetPosition(pos:Get())
				if doer ~= nil then
				    if doer.components.hunger ~= nil then
					    doer.components.hunger:DoDelta(-1)
					end 
				    local doer_pos = doer:GetPosition()
					local direction = doer_pos - pos
					local angle = math.atan2(direction.z, direction.x) + (math.random()*10-5)*DEGREES
					local sp = math.random(6, 7)
					if loot.Physics ~= nil then
					    loot.Physics:SetVel(sp*math.cos(angle), 30, sp*math.sin(angle))
					end 
	                loot:DoTaskInTime(1.546, function() 
			            if not (loot.components.inventoryitem and loot.components.inventoryitem:IsHeld()) then
				            if not loot:IsOnValidGround() then
					            local fx = SpawnPrefab("splash_ocean")
				                local ps = loot:GetPosition()
					            fx.Transform:SetPosition(ps.x, ps.y, ps.z)
					            if loot:HasTag("irreplaceable") or loot:HasTag("task_envelope") then
						            loot.Transform:SetPosition(doer.Transform:GetWorldPosition())
					            else
						            loot:Remove()
				              	end								
				            end
			            end
		            end)			
                    if loot.GetIsOnWater ~= nil then
                        loot:DoTaskInTime(2.546, function() 
						    if not (loot.components.inventoryitem and loot.components.inventoryitem:IsHeld()) then
							    if loot.GetIsOnWater ~= nil and loot:GetIsOnWater() then
			                        if loot.components.floatable ~= nil then
				                        loot.components.floatable:OnHitWater()
				                    elseif loot.components.inventoryitem ~= nil then
			                            loot.components.inventoryitem:OnHitWater()
			                        end										
								end
							end
						end)
                    end 		 			
				end
			end
		end
    end
end

local function _GetVisualTileType(ptx, pty, ptz)

    if GetWorld().Map and ptx ~= nil and pty ~= nil and ptz ~= nil then

        local tilecenter_x, tilecenter_y, tilecenter_z  = GetWorld().Map:GetTileCenterPoint(ptx, 0, ptz)
        local tx, ty = GetWorld().Map:GetTileCoordsAtPoint(ptx, 0, ptz)
        local actual_tile = GetWorld().Map:GetTile(tx, ty)

        if actual_tile and tilecenter_x and tilecenter_z then
            local xpercent = (tilecenter_x - ptx)/TILE_SCALE + .5
            local ypercent = (tilecenter_z - ptz)/TILE_SCALE + .5

            local x_off = 0
            local y_off = 0

            local x_min = 0
            local x_max = 0
            local y_min = 0
            local y_max = 0
			
			local onwater = false
            
			if actual_tile == GROUND.IMPASSABLE then
			    onwater = true
			end
			
			if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then 
			    if not GetWorld().Map:IsWater(actual_tile) then
				    onwater = true
				end
			end
			
            if onwater then

                if xpercent < .25 then
                    x_max = 1

                elseif xpercent > .75 then
                    x_min = -1
                end

                if ypercent < .25 then
                    y_max = 1

                elseif ypercent > .75 then
                    y_min = -1
                end

                for x = x_min, x_max do
                    for y = y_min, y_max do
                        local tile = GetWorld().Map:GetTile(tx + x, ty + y)
                        -- this will return the largest of the two tile types. Slight caveat, water tiles should always be higher than land tiles
                        local higher = false
						if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then 
                            if GetWorld().Map:IsWater(tile) and GetWorld().Map:IsLand(actual_tile) then
                                higher = true
                            elseif GetWorld().Map:IsLand(tile) and GetWorld().Map:IsWater(actual_tile) then
							    higher = false
                            else
                                higher = tile > actual_tile
                            end
						else
						    higher = tile > actual_tile
						end
                        if higher then 
                            actual_tile = tile
                            x_off = x
                            y_off = y
                        end
                    end
                end
            end

            return actual_tile
        end
    end

end

function ValentineDayFishingRod:CanValentineDayFishAtPoint(pos)
    if self.custome_position_fn ~= nil then
	    return self.custome_position_fn(self.inst, pos)
	end
	local IsOnWater = false
	if pos ~= nil then
	    local tile = _GetVisualTileType(pos.x, pos.y, pos.z)
	    if GetWorld().prefab == "forest" and tile ~= nil and tile == GROUND.IMPASSABLE then 
		    IsOnWater = true
		end
		if self.inst.IsPosSurroundedByWater ~= nil and self.inst:IsPosSurroundedByWater(pos.x, pos.y, pos.z, 0.25) then
			IsOnWater = true
		end
	end
	return IsOnWater
end

function ValentineDayFishingRod:CollectPointActions(doer, pos, actions, right)
	if right and doer ~= nil and doer:HasTag("charlie") and self:CanValentineDayFishAtPoint(pos) then 
		table.insert(actions, ACTIONS.VALENTINEDAYFISH)
	end
end

return ValentineDayFishingRod