require("prefabutil")

local castleassets = 
{
    Asset("ANIM", "anim/charlie_castle.zip"),
    Asset("ANIM", "anim/pig_shop_doormats.zip"),	
    Asset("ANIM", "anim/palace_door.zip"),
	Asset("ANIM", "anim/player_house_doors.zip"),	
    Asset("ANIM", "anim/interior_wall_decals_palace.zip"),	
}

local prefabs = 
{

}

local function CreateInterior(inst, name)
    if not inst:HasTag("spawned_shop") then
        -- CREATE THE INTERIOR
        local interior_spawner = GetWorld().components.interiorspawner

        local ID = interior_spawner:GetNewID()
        local ID2 = interior_spawner:GetNewID()
        local ID3 = interior_spawner:GetNewID()      
		local ID4 = interior_spawner:GetNewID()  
		local ID5 = interior_spawner:GetNewID()
		local ID6 = interior_spawner:GetNewID()
		local ID7 = interior_spawner:GetNewID()
		local ID8 = interior_spawner:GetNewID()
		local ID9 = interior_spawner:GetNewID()

        local exterior_door_def =
        {
            my_door_id = name..ID.."_door",
            target_door_id = name..ID.."_exit",
            target_interior = ID
        }

        interior_spawner:AddDoor(inst, exterior_door_def)

        local floortexture   = "levels/textures/interiors/floor_marble_royal.tex"
        local walltexture    = "levels/textures/interiors/wall_royal_high.tex"
        local minimaptexture = "levels/textures/map_interior/mini_floor_marble_royal.tex"     

        local room2_door_def =
        {
            my_door_id = "castle_WEST"..ID2,
            target_door_id = "castle_EAST"..ID2,
            target_interior = ID2,
        }
		
        local room3_door_def =
        {
            my_door_id = "castle_NORTH"..ID3,
            target_door_id = "castle_SOUTH"..ID3,
            target_interior = ID3,
        }	

        local room4_door_def =
        {
            my_door_id = "castle_EAST"..ID4,
            target_door_id = "castle_WEST"..ID4,
            target_interior = ID4,
        }	

        local room5_door_def =
        {
            my_door_id = "castle_NORTH"..ID5,
            target_door_id = "castle_SOUTH"..ID5,
            target_interior = ID5,
        }	
		
        local room6_door_def =
        {
            my_door_id = "castle_WEST"..ID6,
            target_door_id = "castle_EAST"..ID6,
            target_interior = ID6,
        }	

        local room7_door_def =
        {
            my_door_id = "castle_EAST"..ID7,
            target_door_id = "castle_WEST"..ID7,
            target_interior = ID7,
        }	
		
        local room8_door_def =
        {
            my_door_id = "castle_NORTH"..ID8,
            target_door_id = "castle_SOUTH"..ID8,
            target_interior = ID8,
        }	
		
        local room9_door_def =
        {
            my_door_id = "castle_NORTH"..ID9,
            target_door_id = "castle_SOUTH"..ID9,
            target_interior = ID9,
        }	
		
        local addprops = {}     
        addprops =
        { 
            { name = "prop_door", x_offset = 9, z_offset = 0, animdata = {bank = "palace_door", build = "palace_door", anim = "south", background = false }, 
                my_door_id = exterior_door_def.target_door_id, target_door_id = exterior_door_def.my_door_id, rotation = -90, addtags = {"guard_entrance"}, usesounds={"dontstarve_DLC003/common/objects/store/door_close"} },

            { name = "prop_door_shadow", x_offset = 9, z_offset = 0, animdata = {bank = "palace_door", build = "palace_door", anim = "south_floor"} },

            { name = "deco_roomglow_large", x_offset = 0, z_offset = 0 },               
           
            { name = "prop_door", x_offset = 0, z_offset = -26/2, animdata = {bank = "wall_decals_palace", build = "interior_wall_decals_palace", anim = "door_sidewall", background = true }, 
                my_door_id = room2_door_def.my_door_id, target_door_id = room2_door_def.target_door_id, target_interior = room2_door_def.target_interior, rotation = -90, flip = true, addtags = {"door_west"}, usesounds={"dontstarve_DLC003/common/objects/store/door_close"} },

            { name = "prop_door", x_offset = -9, z_offset = 0, animdata = {bank = "wall_decals_palace", build = "interior_wall_decals_palace", anim = "throne", background = true }, 
                my_door_id = room3_door_def.my_door_id, target_door_id = room3_door_def.target_door_id, target_interior = room3_door_def.target_interior, rotation = 90, addtags = {"door_north"}, usesounds={"dontstarve_DLC003/common/objects/store/door_close"} },

            { name = "prop_door", x_offset = 0, z_offset = 26/2, animdata = {bank = "wall_decals_palace", build = "interior_wall_decals_palace", anim = "door_sidewall", background = true }, 
                my_door_id = room4_door_def.my_door_id, target_door_id = room4_door_def.target_door_id, target_interior = room4_door_def.target_interior, rotation = 90, addtags = {"door_east"}, usesounds={"dontstarve_DLC003/common/objects/store/door_close"} },

            { name = "deco_palace_beam_room_tall_corner",       x_offset = -18/2, z_offset = -26/2, rotation = 90, flip = true },
            { name = "deco_palace_beam_room_tall_corner",       x_offset = -18/2, z_offset =  26/2, rotation = 90 },      
            { name = "deco_palace_beam_room_tall_corner_front", x_offset =  18/2, z_offset = -26/2, rotation = 90, flip = true },
            { name = "deco_palace_beam_room_tall_corner_front", x_offset =  18/2, z_offset =  26/2, rotation = 90 }, 

            { name = "deco_palace_beam_room_tall", x_offset = -18/2, z_offset = -26/6-1, rotation = 90, flip = true },
            { name = "deco_palace_beam_room_tall", x_offset = -18/2, z_offset =  26/6+1, rotation = 90 }, 

            { name = "deco_palace_beam_room_tall_lights", x_offset = -18/6, z_offset = -26/6 -1, rotation = 90, flip = true },
            { name = "deco_palace_beam_room_tall_lights", x_offset = -18/6, z_offset =  26/6 +1, rotation = 90 }, 

            { name = "deco_palace_beam_room_tall_lights", x_offset = 18/6, z_offset = -26/6 -1, rotation = 90, flip = true },
            { name = "deco_palace_beam_room_tall_lights", x_offset = 18/6, z_offset =  26/6 +1, rotation = 90 }, 

            { name = "deco_palace_banner_big_front", x_offset = -18/6, z_offset = -26/3-0.5, rotation = 90 },
            { name = "deco_palace_banner_big_front", x_offset = -18/6, z_offset =  26/3+0.5, rotation = 90 }, 
            { name = "deco_palace_banner_big_front", x_offset =  18/6, z_offset = -26/3-0.5, rotation = 90 },
            { name = "deco_palace_banner_big_front", x_offset =  18/6, z_offset =  26/3+0.5, rotation = 90 }, 

            { name = "deco_palace_banner_small_front", x_offset = -18/2, z_offset = -26/18-3, rotation = 90 },
            { name = "deco_palace_banner_small_front", x_offset = -18/2, z_offset =  26/18+3, rotation = 90 }, 

            { name = "deco_palace_banner_small_front", x_offset = -18/2, z_offset = -26/18 - 26/3, rotation = 90 },
            { name = "deco_palace_banner_small_front", x_offset = -18/2, z_offset =  26/18 - 26/3, rotation = 90 },        

            { name = "deco_palace_banner_small_sidewall", x_offset = -18/14, z_offset = -26/2, rotation = 90, flip = true },
            { name = "deco_palace_banner_small_sidewall", x_offset = -18/14, z_offset =  26/2, rotation = 90 },
            { name = "deco_palace_banner_small_sidewall", x_offset =  18/14, z_offset = -26/2, rotation = 90, flip = true },
            { name = "deco_palace_banner_small_sidewall", x_offset =  18/14, z_offset =  26/2, rotation = 90 },

            { name = "deco_palace_banner_small_sidewall", x_offset = -18/14 * 3, z_offset = -26/2, rotation = 90, flip = true },
            { name = "deco_palace_banner_small_sidewall", x_offset = -18/14 * 3, z_offset =  26/2, rotation = 90 },
            { name = "deco_palace_banner_small_sidewall", x_offset =  18/14 * 3, z_offset = -26/2, rotation = 90, flip = true },
            { name = "deco_palace_banner_small_sidewall", x_offset =  18/14 * 3, z_offset =  26/2, rotation = 90 },

            { name = "deco_palace_banner_small_sidewall", x_offset = -18/14 * 5, z_offset =  -26/2, rotation = 90, flip = true },
            { name = "deco_palace_banner_small_sidewall", x_offset = -18/14 * 5, z_offset =   26/2, rotation = 90 },
            { name = "deco_palace_banner_small_sidewall", x_offset =  18/14 * 5, z_offset =  -26/2, rotation = 90, flip = true },
            { name = "deco_palace_banner_small_sidewall", x_offset =  18/14 * 5, z_offset =   26/2, rotation = 90 },

            { name = "deco_palace_beam_room_tall_corner", x_offset = -18/6, z_offset = -26/2, rotation = 90, flip = true },
            { name = "deco_palace_beam_room_tall_corner", x_offset =  18/6, z_offset = -26/2, rotation = 90, flip = true }, 
            { name = "deco_palace_beam_room_tall_corner", x_offset = -18/6, z_offset =  26/2, rotation = 90 },
            { name = "deco_palace_beam_room_tall_corner", x_offset =  18/6, z_offset =  26/2, rotation = 90 }, 

            { name = "deco_palace_plant", x_offset = -18/2 +0.3, z_offset = -26/6.5, rotation = 90, flip = true },
            { name = "deco_palace_plant", x_offset = -18/2 +0.3, z_offset =  26/6.5, rotation = 90 },

            { name = "wall_mirror", x_offset =  18/3, z_offset = -26/2, rotation = -90 }, 
            { name = "wall_mirror", x_offset = -18/3, z_offset = -26/2, rotation = -90 }, 
            
            { name = "deco_cityhall_picture1", x_offset =  18/3, z_offset = 26/2, rotation = 90 },
            { name = "deco_cityhall_picture1", x_offset =  -18/3, z_offset = 26/2, rotation = 90 },              

            -- floor corner pieces
            { name = "rug_palace_corners", x_offset = -18/2, z_offset =  26/2, rotation = 90  },
            { name = "rug_palace_corners", x_offset =  18/2, z_offset =  26/2, rotation = 180 },
            { name = "rug_palace_corners", x_offset =  18/2, z_offset = -26/2, rotation = 270 },
            { name = "rug_palace_corners", x_offset = -18/2, z_offset = -26/2, rotation = 0   },

            -- front wall floor lights
            { name = "swinglightobject", x_offset = 18/2, z_offset = -26/3, rotation = -90 }, 
            { name = "swinglightobject", x_offset = 18/2, z_offset =  26/3, rotation = -90 }, 

            -- back wall lights and floor lights
            { name = "window_round_light_backwall", x_offset = -18/2, z_offset = -26/3, rotation = -90 }, 
            { name = "window_palace",               x_offset = -18/2, z_offset = -26/3, rotation =  90 },
            { name = "window_round_light_backwall", x_offset = -18/2, z_offset =  26/3, rotation = -90 }, 
            { name = "window_palace",               x_offset = -18/2, z_offset =  26/3, rotation =  90 }, 	

            -- aisle rug
            { name = "rug_palace_runner", x_offset =   -3.38, z_offset = 0, rotation = 90 },
            { name = "rug_palace_runner", x_offset = -3.38*2, z_offset = 0, rotation = 90 },
            { name = "rug_palace_runner", x_offset =       0, z_offset = 0, rotation = 90 },
            { name = "rug_palace_runner", x_offset =    3.38, z_offset = 0, rotation = 90 },
            { name = "rug_palace_runner", x_offset =  3.38*2, z_offset = 0, rotation = 90 },
        } 

        interior_spawner:CreateRoom("generic_interior", 26, 13, 18, name..ID, ID, addprops, {}, walltexture, floortexture, minimaptexture, nil, "images/colour_cubes/pigshop_interior_cc.tex", nil, nil, "palace", "PALACE", "STONE")

        -- CREATE ROOM 2     
        
        addprops = {}     
        addprops =
        {
            { name = "deco_roomglow_large", x_offset = 0, z_offset = 0 },               

            { name = "prop_door", x_offset = 0, z_offset = 26/2, animdata = {bank = "wall_decals_palace", build = "interior_wall_decals_palace", anim = "door_sidewall", background = true }, 
                my_door_id = room2_door_def.target_door_id, target_door_id = room2_door_def.my_door_id, target_interior = exterior_door_def.target_interior, rotation = 90, addtags = {"door_east"}, usesounds={"dontstarve_DLC003/common/objects/store/door_close"} },

            { name = "prop_door", x_offset = -9, z_offset = 0, animdata = {bank = "player_house_doors", build = "player_house_doors", anim = "pillar_door_open_north", background = true }, 
                my_door_id = "CastleRoomTwoDoorNorth"..ID2, target_door_id = "CastleRoomTwoDoorSouth"..ID2, target_interior = room5_door_def.target_interior, rotation = 90, addtags = {"door_north"}, usesounds={"dontstarve_DLC003/common/objects/store/door_close"} },

        } 

        interior_spawner:CreateRoom("generic_interior", 26, 13, 18, name..ID, ID2, addprops, {}, walltexture, floortexture, minimaptexture, nil, "images/colour_cubes/pigshop_interior_cc.tex", nil, nil, "palace", "PALACE", "STONE")

        -- CREATE ROOM3

        addprops = {}     
        addprops =
        {
            { name = "deco_roomglow_large", x_offset = 0, z_offset = 0 },               

            { name = "prop_door", x_offset = 9, z_offset = 0, animdata = {bank = "pig_shop_doormats", build = "pig_shop_doormats", anim = "idle_giftshop", background = true }, 
                my_door_id = room3_door_def.target_door_id, target_door_id = room3_door_def.my_door_id, target_interior = exterior_door_def.target_interior, rotation = 90, addtags = {"door_south"}, usesounds={"dontstarve_DLC003/common/objects/store/door_close"} },

            { name = "prop_door", x_offset = 0, z_offset = -26/2, animdata = {bank = "wall_decals_palace", build = "interior_wall_decals_palace", anim = "door_sidewall", background = true }, 
                my_door_id = "CastleCenterRoomDoorWest"..ID5, target_door_id = "CastleCenterRoomDoorEast"..ID5, target_interior = room5_door_def.target_interior, rotation = -90, flip = true, addtags = {"door_west"}, usesounds={"dontstarve_DLC003/common/objects/store/door_close"} },

            { name = "prop_door", x_offset = -9, z_offset = 0, animdata = {bank = "player_house_doors", build = "player_house_doors", anim = "pillar_door_open_north", background = true }, 
                my_door_id = "CastleCenterRoomDoorNorth"..ID6, target_door_id = "CastleCenterRoomDoorSouth"..ID6, target_interior = room6_door_def.target_interior, rotation = 90, addtags = {"door_north"}, usesounds={"dontstarve_DLC003/common/objects/store/door_close"} },

            { name = "prop_door", x_offset = 0, z_offset = 26/2, animdata = {bank = "wall_decals_palace", build = "interior_wall_decals_palace", anim = "door_sidewall", background = true }, 
                my_door_id = "CastleCenterRoomDoorEast"..ID7, target_door_id = "CastleCenterRoomDoorWest"..ID7, target_interior = room7_door_def.target_interior, rotation = 90, addtags = {"door_east"}, usesounds={"dontstarve_DLC003/common/objects/store/door_close"} },
				
        }

        interior_spawner:CreateRoom("generic_interior", 26, 13, 18, name..ID, ID3, addprops, {}, walltexture, floortexture, minimaptexture, nil, "images/colour_cubes/pigshop_interior_cc.tex", nil, nil, "palace", "PALACE", "STONE")

        -- CREATE ROOM4

        addprops = {}     
        addprops =
        {
            { name = "deco_roomglow_large", x_offset = 0, z_offset = 0 },               

            { name = "prop_door", x_offset = 0, z_offset = -26/2, animdata = {bank = "wall_decals_palace", build = "interior_wall_decals_palace", anim = "door_sidewall", background = true }, 
                my_door_id = room4_door_def.target_door_id, target_door_id = room4_door_def.my_door_id, target_interior = exterior_door_def.target_interior, rotation = -90, flip = true, addtags = {"door_west"}, usesounds={"dontstarve_DLC003/common/objects/store/door_close"} },

            { name = "prop_door", x_offset = -9, z_offset = 0, animdata = {bank = "player_house_doors", build = "player_house_doors", anim = "pillar_door_open_north", background = true }, 
                my_door_id = "CastleRoomFourDoorNorth"..ID4, target_door_id = "CastleRoomFourDoorSouth"..ID4, target_interior = room7_door_def.target_interior, rotation = 90, addtags = {"door_north"}, usesounds={"dontstarve_DLC003/common/objects/store/door_close"} },

        }

        interior_spawner:CreateRoom("generic_interior", 26, 13, 18, name..ID, ID4, addprops, {}, walltexture, floortexture, minimaptexture, nil, "images/colour_cubes/pigshop_interior_cc.tex", nil, nil, "palace", "PALACE", "STONE")

        -- CREATE ROOM5

        addprops = {}     
        addprops =
        {
            { name = "deco_roomglow_large", x_offset = 0, z_offset = 0 },               

            { name = "prop_door", x_offset = 0, z_offset = 26/2, animdata = {bank = "wall_decals_palace", build = "interior_wall_decals_palace", anim = "door_sidewall", background = true }, 
                my_door_id = "CastleCenterRoomDoorEast"..ID5, target_door_id = "CastleCenterRoomDoorWest"..ID5, target_interior = room3_door_def.target_interior, rotation = 90, addtags = {"door_east"}, usesounds={"dontstarve_DLC003/common/objects/store/door_close"} },

            { name = "prop_door", x_offset = -9, z_offset = 0, animdata = {bank = "player_house_doors", build = "player_house_doors", anim = "pillar_door_open_north", background = true }, 
                my_door_id = "CastleRoomFiveDoorNorth"..ID5, target_door_id = "CastleRoomFiveDoorSouth"..ID5, target_interior = room8_door_def.target_interior, rotation = 90, addtags = {"door_north"}, usesounds={"dontstarve_DLC003/common/objects/store/door_close"} },

            { name = "prop_door", x_offset = 9, z_offset = 0, animdata = {bank = "player_house_doors", build = "player_house_doors", anim = "pillar_door_open_south", background = true }, 
                my_door_id = "CastleRoomTwoDoorSouth"..ID2, target_door_id = "CastleRoomTwoDoorNorth"..ID2, target_interior = room2_door_def.target_interior, rotation = 90, addtags = {"door_south"}, usesounds={"dontstarve_DLC003/common/objects/store/door_close"} },
        }

        interior_spawner:CreateRoom("generic_interior", 26, 13, 18, name..ID, ID5, addprops, {}, walltexture, floortexture, minimaptexture, nil, "images/colour_cubes/pigshop_interior_cc.tex", nil, nil, "palace", "PALACE", "STONE")

        -- CREATE ROOM6

        addprops = {}     
        addprops =
        {
            { name = "deco_roomglow_large", x_offset = 0, z_offset = 0 },               

            { name = "prop_door", x_offset = 0, z_offset = -26/2, animdata = {bank = "wall_decals_palace", build = "interior_wall_decals_palace", anim = "door_sidewall", background = true }, 
                my_door_id = "CastleRoomSixDoorWest"..ID6, target_door_id = "CastleRoomSixDoorEast"..ID6, target_interior = room8_door_def.target_interior, rotation = -90, flip = true, addtags = {"door_west"}, usesounds={"dontstarve_DLC003/common/objects/store/door_close"} },

            { name = "prop_door", x_offset = 0, z_offset = 26/2, animdata = {bank = "wall_decals_palace", build = "interior_wall_decals_palace", anim = "door_sidewall", background = true }, 
                my_door_id = "CastleRoomSixDoorEast"..ID9, target_door_id = "CastleRoomSixDoorWest"..ID9, target_interior = room9_door_def.target_interior, rotation = 90, addtags = {"door_east"}, usesounds={"dontstarve_DLC003/common/objects/store/door_close"} },

            { name = "prop_door", x_offset = 9, z_offset = 0, animdata = {bank = "player_house_doors", build = "player_house_doors", anim = "pillar_door_open_south", background = true }, 
                my_door_id = "CastleCenterRoomDoorSouth"..ID6, target_door_id = "CastleCenterRoomDoorNorth"..ID6, target_interior = room3_door_def.target_interior, rotation = 90, addtags = {"door_south"}, usesounds={"dontstarve_DLC003/common/objects/store/door_close"} },
        }

        interior_spawner:CreateRoom("generic_interior", 26, 13, 18, name..ID, ID6, addprops, {}, walltexture, floortexture, minimaptexture, nil, "images/colour_cubes/pigshop_interior_cc.tex", nil, nil, "palace", "PALACE", "STONE")

        -- CREATE ROOM7

        addprops = {}     
        addprops =
        {
            { name = "deco_roomglow_large", x_offset = 0, z_offset = 0 },               

            { name = "prop_door", x_offset = 0, z_offset = -26/2, animdata = {bank = "wall_decals_palace", build = "interior_wall_decals_palace", anim = "door_sidewall", background = true }, 
                my_door_id = "CastleCenterRoomDoorWest"..ID7, target_door_id = "CastleCenterRoomDoorEast"..ID7, target_interior = room3_door_def.target_interior, rotation = -90, flip = true, addtags = {"door_west"}, usesounds={"dontstarve_DLC003/common/objects/store/door_close"} },

            { name = "prop_door", x_offset = -9, z_offset = 0, animdata = {bank = "player_house_doors", build = "player_house_doors", anim = "pillar_door_open_north", background = true }, 
                my_door_id = "CastleRoomSevenDoorNorth"..ID7, target_door_id = "CastleRoomSevenDoorSouth"..ID7, target_interior = room9_door_def.target_interior, rotation = 90, addtags = {"door_north"}, usesounds={"dontstarve_DLC003/common/objects/store/door_close"} },

            { name = "prop_door", x_offset = 9, z_offset = 0, animdata = {bank = "player_house_doors", build = "player_house_doors", anim = "pillar_door_open_south", background = true }, 
                my_door_id = "CastleRoomFourDoorSouth"..ID4, target_door_id = "CastleRoomFourDoorNorth"..ID4, target_interior = room4_door_def.target_interior, rotation = 90, addtags = {"door_south"}, usesounds={"dontstarve_DLC003/common/objects/store/door_close"} },
        }

        interior_spawner:CreateRoom("generic_interior", 26, 13, 18, name..ID, ID7, addprops, {}, walltexture, floortexture, minimaptexture, nil, "images/colour_cubes/pigshop_interior_cc.tex", nil, nil, "palace", "PALACE", "STONE")

        -- CREATE ROOM8

        addprops = {}     
        addprops =
        {
            { name = "deco_roomglow_large", x_offset = 0, z_offset = 0 },               

            { name = "prop_door", x_offset = 9, z_offset = 0, animdata = {bank = "player_house_doors", build = "player_house_doors", anim = "pillar_door_open_south", background = true }, 
                my_door_id = "CastleRoomFiveDoorSouth"..ID5, target_door_id = "CastleRoomFiveDoorNorth"..ID5, target_interior = room5_door_def.target_interior, rotation = 90, addtags = {"door_south"}, usesounds={"dontstarve_DLC003/common/objects/store/door_close"} },

            { name = "prop_door", x_offset = 0, z_offset = 26/2, animdata = {bank = "wall_decals_palace", build = "interior_wall_decals_palace", anim = "door_sidewall", background = true }, 
                my_door_id = "CastleRoomSixDoorEast"..ID6, target_door_id = "CastleRoomSixDoorWest"..ID6, target_interior = room6_door_def.target_interior, rotation = 90, addtags = {"door_east"}, usesounds={"dontstarve_DLC003/common/objects/store/door_close"} },
        }

        interior_spawner:CreateRoom("generic_interior", 26, 13, 18, name..ID, ID8, addprops, {}, walltexture, floortexture, minimaptexture, nil, "images/colour_cubes/pigshop_interior_cc.tex", nil, nil, "palace", "PALACE", "STONE")
	
        -- CREATE ROOM9

        addprops = {}     
        addprops =
        {
            { name = "deco_roomglow_large", x_offset = 0, z_offset = 0 },               

            { name = "prop_door", x_offset = 9, z_offset = 0, animdata = {bank = "player_house_doors", build = "player_house_doors", anim = "pillar_door_open_south", background = true }, 
                my_door_id = "CastleRoomSevenDoorSouth"..ID7, target_door_id = "CastleRoomSevenDoorNorth"..ID7, target_interior = room7_door_def.target_interior, rotation = 90, addtags = {"door_south"}, usesounds={"dontstarve_DLC003/common/objects/store/door_close"} },

            { name = "prop_door", x_offset = 0, z_offset = -26/2, animdata = {bank = "wall_decals_palace", build = "interior_wall_decals_palace", anim = "door_sidewall", background = true }, 
                my_door_id = "CastleRoomSixDoorWest"..ID9, target_door_id = "CastleRoomSixDoorEast"..ID9, target_interior = room6_door_def.target_interior, rotation = -90, flip = true, addtags = {"door_west"}, usesounds={"dontstarve_DLC003/common/objects/store/door_close"} },

        }

        interior_spawner:CreateRoom("generic_interior", 26, 13, 18, name..ID, ID9, addprops, {}, walltexture, floortexture, minimaptexture, nil, "images/colour_cubes/pigshop_interior_cc.tex", nil, nil, "palace", "PALACE", "STONE")
	
        inst.interiorID = ID
        inst:AddTag("spawned_shop")
    end
end

local function onhit(inst, worker, workleft)
   	inst.AnimState:PlayAnimation("hit")
   	inst.AnimState:PushAnimation("idle")
end

local function onhammered(inst, worker)
    if not inst.components.fixable then
        inst.components.lootdropper:DropLoot()
    end

	SpawnPrefab("collapse_big").Transform:SetPosition(inst.Transform:GetWorldPosition())
    inst.SoundEmitter:PlaySound("dontstarve/common/destroy_stone")
	inst:Remove()
end

local function usedoor(inst, data)
    if inst.usesounds then
        if data and data.doer and data.doer.SoundEmitter then
            for i,sound in ipairs(inst.usesounds) do
                data.doer.SoundEmitter:PlaySound(sound)
            end
        end
    end
end

local function CastleOnBuilt(inst)
	inst.AnimState:PlayAnimation("place")
	inst.AnimState:PushAnimation("idle")
	inst.SoundEmitter:PlaySound("dontstarve_DLC003/common/crafted/pighouse/brick")
end

local function reconstructed(inst)
    inst.SoundEmitter:PlaySound("dontstarve_DLC003/common/crafted/pighouse/brick")
end

local function OnSave(inst, data)
    if inst:HasTag("spawned_shop") then
        data.spawned_shop = true
    end
end

local function OnLoad(inst, data)
    if data and data.spawned_shop then
        inst:AddTag("spawned_shop")
    end
end

local function castlefn()
    local inst = CreateEntity()

	inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddMiniMapEntity()
	
	MakeObstaclePhysics(inst, 1.25)
	
	inst:AddTag("structure")
	inst:AddTag("charlie_castle")
	
	inst.MiniMapEntity:SetIcon("charlie_castle.tex")

    inst.AnimState:SetBank("charlie_castle")
    inst.AnimState:SetBuild("charlie_castle")
    inst.AnimState:PlayAnimation("idle")
    inst.AnimState:SetLightOverride(0.25)	
	
	inst.Transform:SetScale(3, 3, 3)
	
    inst:AddComponent("inspectable")
	
    inst:AddComponent("lootdropper")	

    inst:AddComponent("workable")
    inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
    inst.components.workable:SetWorkLeft(4)
    inst.components.workable:SetOnWorkCallback(onhit)
  	inst.components.workable:SetOnFinishCallback(onhammered)

    if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
        inst:AddComponent("waterproofer")
        inst.components.waterproofer:SetEffectiveness(0)
    end
	
	if IsDLCEnabled(PORKLAND_DLC) then 
	    inst:AddTag("city_hammerable")
	
	    inst:AddComponent("door")
      
	    inst:DoTaskInTime(0, function() 
            CreateInterior(inst, "charlie_castle")
        end)	
		
        inst.usesounds = {"dontstarve_DLC003/common/objects/store/door_open"}
        inst:ListenForEvent("usedoor", function(inst, data) usedoor(inst, data) end)  
		
        inst:AddComponent("fixable")
		inst.components.fixable:AddRecinstructionStageData("rubble", "charlie_castle", "charlie_castle")
        inst.components.fixable:AddRecinstructionStageData("unbuilt", "charlie_castle", "charlie_castle")	
	end
	
	inst:ListenForEvent("onbuilt", CastleOnBuilt)
	
	inst.reconstructed = reconstructed
	
    inst.OnSave = OnSave 
    inst.OnLoad = OnLoad
	
	return inst
end 

return Prefab("charlie_castle", castlefn, castleassets, prefabs),
    MakePlacer("charlie_castle_placer", "charlie_castle", "charlie_castle", "idle")	