
local assets =
{
    Asset("ANIM", "anim/willow_embers.zip"),
}

local prefabs =
{

}

local function OnHitGround(inst, onwater)
    onwater = onwater == nil and inst:GetIsOnWater() or onwater
    inst.AnimState:OverrideSymbol("shimmer_sprite", "willow_embers", onwater and "" or "shimmer_sprite")
end

local function CanInteract(inst, doer)
    return doer ~= nil and doer.emberguru  
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()

    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)

    inst.AnimState:SetBank("willow_embers")
    inst.AnimState:SetBuild("willow_embers")
    inst.AnimState:PlayAnimation("idle_loop", true)
	inst.AnimState:SetScale(0.8, 0.8)
	inst.AnimState:OverrideSymbol("ash_part", "willow_embers", "")

    inst:AddTag("nosteal") 
	inst:AddTag("shadowboxitem") 
	
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.nosink = true
	
    inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM

    inst:AddComponent("inspectable")
	
	if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
        inst:DoTaskInTime(0, OnHitGround)
        inst:ListenForEvent("onhitground", OnHitGround)
	end	

    if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
        inst:AddComponent("waterproofer")
        inst.components.waterproofer:SetEffectiveness(0)
    end 
	
    inst:AddComponent("machine")	
	inst.components.machine.caninteractfn = CanInteract
    inst.components.machine.cooldowntime = 0.1
	inst.components.machine.CollectSceneActions = function() end  
	
    return inst
end

return Prefab("charlie_exp", fn, assets, prefabs)