--This file exists to solve the problems that Charlie.lua file has too many local variables and functions.

local function AcidRainTryToDamageMob(inst)
    local TheSeasonManager = GetSeasonManager()
    if GetWorld():IsCave() 
	    and inst ~= nil
	    and	TheSeasonManager ~= nil 
	    and TheSeasonManager.precip 
		and type(TheSeasonManager.precip_rate) == "number"
		and TheSeasonManager.precip_rate > 0 then
	    
		if TheCamera.interior then
		    inst:DoTaskInTime(2+math.random()*2, AcidRainTryToDamageMob)
			return
		end
		
		local x, y, z = inst.Transform:GetWorldPosition() 
		local ENTS_TO_BE_AFFECTED_BY_ACID_RAIN = TheSim:FindEntities(x, y, z, 50, {"hascombatcomponent"}, {"FX", "NOCLICK", "INLIMBO", "INTERIOR_LIMBO", "notarget", "shadow", "shadow_form_on", "wall", "structure"}) 
	    for k,v in pairs(ENTS_TO_BE_AFFECTED_BY_ACID_RAIN) do
	        if v ~= nil 
		        and v.prefab ~= nil 
			    and v.prefab ~= "" 
			    and v:IsValid() 
			    and v.entity:IsVisible()  
			    and v.components.health ~= nil 
		    then 
			    v.components.health:SetVal(v.components.health.currenthealth - 3 * TheSeasonManager.precip_rate, "acidrain") 
				v:DoTaskInTime(0.75, function()
				    if v.components.health ~= nil and not v.components.health:IsDead() then 
					    v.components.health:SetVal(v.components.health.currenthealth - 5 * TheSeasonManager.precip_rate, "acidrain")
					end 
				end)
				v:DoTaskInTime(1.5, function()
				    if v.components.health ~= nil and not v.components.health:IsDead() then 
					    v.components.health:SetVal(v.components.health.currenthealth - 7 * TheSeasonManager.precip_rate, "acidrain")
					end 				
				end)			
            end
	    end  		
        inst:DoTaskInTime(2+math.random()*2, AcidRainTryToDamageMob)
    elseif inst ~= nil and inst.AcidRainDamageTask ~= nil then
	    inst.AcidRainDamageTask:Cancel()
		inst.AcidRainDamageTask = nil
	end
end

local function AcidRainTryToFallNitre(inst)
    local TheSeasonManager = GetSeasonManager()
    if GetWorld():IsCave() 
	    and inst ~= nil
	    and	TheSeasonManager ~= nil 
	    and TheSeasonManager.precip 
		and type(TheSeasonManager.precip_rate) == "number"
		and TheSeasonManager.precip_rate > 0 then  
		if math.random() < TheSeasonManager.precip_rate and not TheCamera.interior then 
		    local pt = inst:GetPosition()
			local result_offset = FindValidPositionByFan(math.random()*2*math.pi, math.random()*30, 12, function(offset)
                local spawn_point = pt + offset
				if GetWorld() == nil or GetWorld().Map == nil then
				    return false
				end
				local tile = GetWorld().Map:GetTileAtPoint(spawn_point.x, spawn_point.y, spawn_point.z)
				local blockers = TheSim:FindEntities(spawn_point.x, spawn_point.y, spawn_point.z, 3, nil, {"FX", "NOCLICK", "INLIMBO", "INTERIOR_LIMBO", "PLAYER"})
				if #blockers > 0 then
				    return false
				end
                if tile ~= GROUND.IMPASSABLE and tile < GROUND.UNDERGROUND then
                    return true
                end
                return false
            end)
			
			if result_offset ~= nil then
			    local spawn_pt = pt + result_offset
				local Nitre = SpawnPrefab("nitre")
				Nitre.Transform:SetPosition(spawn_pt.x, 10, spawn_pt.z)
				if Nitre.components.inventoryitem ~= nil and Nitre.components.inventoryitem.OnHitGround ~= nil then
				    Nitre:AddTag("falling")
                    Nitre.falltask = Nitre:DoPeriodicTask(1/15, function()
                        local x, y, z = Nitre.Transform:GetWorldPosition()
                        if y <= 0.1 then
                            if Nitre.falltask ~= nil then
                                Nitre.falltask:Cancel()
                                Nitre.falltask = nil
                            end
							Nitre.components.inventoryitem:OnHitGround(0)
                        end
                   end)
			    end
			end 
			
		end
		inst:DoTaskInTime(12+math.random()*3, AcidRainTryToFallNitre)
	elseif inst ~= nil and inst.AcidRainFallNitreTask ~= nil then
	    inst.AcidRainFallNitreTask:Cancel()
		inst.AcidRainFallNitreTask = nil	
	end
end

local function AcidRainTryToSpawnAcidPuddle(inst)
    local TheSeasonManager = GetSeasonManager()
    if GetWorld():IsCave() 
	    and inst ~= nil
	    and	TheSeasonManager ~= nil 
	    and TheSeasonManager.precip 
		and type(TheSeasonManager.precip_rate) == "number"
		and TheSeasonManager.precip_rate > 0 then
		if math.random() < TheSeasonManager.precip_rate and not TheCamera.interior then 
		    local environment_to_spawn = math.random() < 0.5 and "shadowacidpuddle" or "shadow_acid_smoke"
		    local pt = inst:GetPosition()
			local result_offset = FindValidPositionByFan(math.random()*2*math.pi, math.random()*30, 12, function(offset)
                local spawn_point = pt + offset
				if GetWorld() == nil or GetWorld().Map == nil then
				    return false
				end
				local tile = GetWorld().Map:GetTileAtPoint(spawn_point.x, spawn_point.y, spawn_point.z)
				local blockers = TheSim:FindEntities(spawn_point.x, spawn_point.y, spawn_point.z, 1, nil, {"FX", "NOCLICK", "INLIMBO", "INTERIOR_LIMBO", "PLAYER", "isinventoryitem"})
				local find_puddle_or_smoke = TheSim:FindEntities(spawn_point.x, spawn_point.y, spawn_point.z, 3, nil, nil, {"puddle", "butterpuddle", "shadow_acid_smoke"})
				local find_base = TheSim:FindEntities(spawn_point.x, spawn_point.y, spawn_point.z, 10, nil, nil, {"wall", "structure"})
				if #blockers > 0 or #find_puddle_or_smoke > 0 or #find_base > 0 then
				    return false
				end
                if tile ~= GROUND.IMPASSABLE and tile < GROUND.UNDERGROUND then
                    return true
                end
                return false
            end)	
			if result_offset ~= nil then
			    local spawn_pt = pt + result_offset
			    if environment_to_spawn == "shadowacidpuddle" then
			        local shadowacidpuddle = SpawnPrefab(environment_to_spawn)
			        shadowacidpuddle.Transform:SetPosition(spawn_pt.x, spawn_pt.y, spawn_pt.z) 
				    if shadowacidpuddle.StartingAnimation ~= nil and shadowacidpuddle.LoopingAnimation ~= nil then 
				        shadowacidpuddle.AnimState:PlayAnimation(shadowacidpuddle.StartingAnimation)
					    shadowacidpuddle.AnimState:PushAnimation(shadowacidpuddle.LoopingAnimation, true)
				    end 
					if shadowacidpuddle.SetLifeTime ~= nil then
					    shadowacidpuddle:SetLifeTime(60)
					end						
					if math.random() < 0.06 then
					    shadowacidpuddle.superacid = true 
					end				
                else
			        local shadow_acid_smoke = SpawnPrefab(environment_to_spawn)
			        shadow_acid_smoke.Transform:SetPosition(spawn_pt.x, spawn_pt.y, spawn_pt.z) 
					if shadow_acid_smoke.SetLifeTime ~= nil then
					    shadow_acid_smoke:SetLifeTime(60)
					end						
                end	
			end 			
		end
		inst:DoTaskInTime(15+math.random()*12, AcidRainTryToSpawnAcidPuddle)  
	elseif inst ~= nil and inst.AcidRainSpawnAcidPuddleTask ~= nil then
	    inst.AcidRainSpawnAcidPuddleTask:Cancel()
		inst.AcidRainSpawnAcidPuddleTask = nil	
	end
end

local function TryToSpawnTaskBubble(inst)
    local TheSeasonManager = GetSeasonManager()
    if inst ~= nil
	    and not TheSim:FindFirstEntityWithTag("task_bubble")
	    and	TheSeasonManager ~= nil 
	    and TheSeasonManager.precip 
		and type(TheSeasonManager.precip_rate) == "number"
		and TheSeasonManager.precip_rate > 0 then
		
	    if type(inst.spawn_task_bubble_left) == "number" then
		    inst.spawn_task_bubble_left = math.max(inst.spawn_task_bubble_left - 1, 0)
			if inst.spawn_task_bubble_left == 0 and TheSeasonManager.precip_rate >= 0.35 then
		        local pt = inst:GetPosition()
			    local result_offset = FindValidPositionByFan(math.random()*2*math.pi, math.random()*50, 24, function(offset)
                    local spawn_point = pt + offset
				    if GetWorld() == nil or GetWorld().Map == nil then
				        return false
				    end
				    local tile = GetWorld().Map:GetTileAtPoint(spawn_point.x, spawn_point.y, spawn_point.z)
				    local blockers = TheSim:FindEntities(spawn_point.x, spawn_point.y, spawn_point.z, 1, nil, {"FX", "NOCLICK", "INLIMBO", "INTERIOR_LIMBO", "PLAYER", "isinventoryitem"})
			    	local find_base = TheSim:FindEntities(spawn_point.x, spawn_point.y, spawn_point.z, 7, nil, nil, {"wall", "structure"})
			        local IsPassableTile = false
			        local IsForestTile = false
			        local NotInInterior = true
				    if #blockers > 0 or #find_base > 0 then
				        return false
				    end          
			        if tile ~= GROUND.IMPASSABLE and tile ~= GROUND.INVALID and tile < GROUND.UNDERGROUND then
			            IsPassableTile = true
			        end
					if tile == GROUND.FOREST then
					    IsForestTile = true
					end
			        if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
			            if tile == GROUND.JUNGLE then
				            IsForestTile = true
				        end
						if GetWorld().Map:IsWater(tile) then
						    IsPassableTile = false
						end 
			        end					
			        if IsDLCEnabled(PORKLAND_DLC) then
			            if tile == GROUND.RAINFOREST or tile == GROUND.DEEPRAINFOREST or tile == GROUND.GASJUNGLE then
				            IsForestTile = true
				        end			
				        if tile == GROUND.INTERIOR then
				            NotInInterior = false
				        end
						if GetWorld().Map:IsWater(tile) then
						    IsPassableTile = false
						end 
			        end
                    return IsPassableTile and IsForestTile and NotInInterior
                end)			
			
				if result_offset ~= nil then
			        local spawn_pt = pt + result_offset
				    local charlie_valentine_day_bubble = SpawnPrefab("charlie_valentine_day_bubble")
				    charlie_valentine_day_bubble.Transform:SetPosition(spawn_pt.x, 10, spawn_pt.z)
				    if charlie_valentine_day_bubble.components.inventoryitem ~= nil and charlie_valentine_day_bubble.components.inventoryitem.OnHitGround ~= nil then
				        charlie_valentine_day_bubble:AddTag("falling")
                        charlie_valentine_day_bubble.falltask = charlie_valentine_day_bubble:DoPeriodicTask(1/15, function()
                            local x, y, z = charlie_valentine_day_bubble.Transform:GetWorldPosition()
                            if y <= 0.1 then
                                if charlie_valentine_day_bubble.falltask ~= nil then
                                    charlie_valentine_day_bubble.falltask:Cancel()
                                    charlie_valentine_day_bubble.falltask = nil
                                end
							    charlie_valentine_day_bubble.components.inventoryitem:OnHitGround(0)
                            end
                       end)
			        end
					inst.spawn_task_bubble_left = nil
				else
				    inst:DoTaskInTime(5, TryToSpawnTaskBubble)  
			    end		
			
			else
			    inst:DoTaskInTime(5, TryToSpawnTaskBubble)  
			end 
		end
	
	elseif inst ~= nil and inst.SpawnTaskBubbleTask ~= nil then
	    inst.SpawnTaskBubbleTask:Cancel()
		inst.SpawnTaskBubbleTask = nil		
		inst.spawn_task_bubble_left = nil
	end
end

local function CharlieRainStart(inst, data)
    local TheSeasonManager = GetSeasonManager()
    if GetWorld():IsCave() and TheSeasonManager ~= nil and inst:HasTag("shadow_form_on") and inst.acidshadowsmoker then
	    if inst.AcidRainDamageTask == nil then
		    inst.AcidRainDamageTask = inst:DoTaskInTime(1, AcidRainTryToDamageMob)
		end
	    if inst.AcidRainFallNitreTask == nil then
		    inst.AcidRainFallNitreTask = inst:DoTaskInTime(5+math.random()*2.5, AcidRainTryToFallNitre)
		end
	    if inst.AcidRainSpawnAcidPuddleTask == nil then
		    inst.AcidRainSpawnAcidPuddleTask = inst:DoTaskInTime(10+math.random()*5, AcidRainTryToSpawnAcidPuddle)
		end
	end 
	if GetCharlieTaskRose() and not inst.taskcoffeespawntask and not inst.FirstTimeTaskCoffeeSpawn then
	    inst.taskcoffeespawntask, inst.taskcoffeespawntaskinfo = inst:ResumeTask(TUNING.TOTAL_DAY_TIME*5+math.random()*TUNING.TOTAL_DAY_TIME*7, inst.SpawnTaskCoffee)
		inst.FirstTimeTaskCoffeeSpawn = true
	end
	if GetCharlieTaskRose() and not TheSim:FindFirstEntityWithTag("task_bubble") then
	    if inst.spawn_task_bubble_left == nil then
	        inst.spawn_task_bubble_left = 7
	    end 
	    if inst.SpawnTaskBubbleTask == nil then
		    inst.SpawnTaskBubbleTask = inst:DoTaskInTime(5, TryToSpawnTaskBubble)
		end	
	end
end

local function SpawnTaskCoffee(inst)
    if inst.taskcoffeespawntask then
	    inst.taskcoffeespawntask:Cancel()
		inst.taskcoffeespawntask = nil 
	end 
	if inst.taskcoffeespawntaskinfo then
	    inst.taskcoffeespawntaskinfo = nil 
	end
	local centers = {}
	if GetWorld() and GetWorld().topology and GetWorld().topology.nodes and GetWorld().Map then
        for i, node in pairs(GetWorld().topology.nodes) do
		    if node ~= nil and node.x ~= nil and node.y ~= nil then
		        local tile = GetWorld().Map:GetTileAtPoint(node.x, 0, node.y)
		        local nearby_player = TheSim:FindEntities(node.x, 0, node.y, 200, {"player"}) 
			    local IsPassableTile = false
		        local IsGrassTile = false
			    local NotInInterior = true
			    if tile == GROUND.GRASS then
			        IsGrassTile = true
			    end
			    if tile ~= GROUND.IMPASSABLE and tile ~= GROUND.INVALID and tile < GROUND.UNDERGROUND then
			        IsPassableTile = true
		    	end
			    if inst.IsPosSurroundedByLand ~= nil and not inst:IsPosSurroundedByLand(node.x, 0, node.y, 2) then
			        IsPassableTile = false
			    end 
			    if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
			        if tile == GROUND.MEADOW then
				        IsGrassTile = true
				    end
			    end
			    if IsDLCEnabled(PORKLAND_DLC) then
			        if tile == GROUND.PLAINS or tile == GROUND.LAWN then
				        IsGrassTile = true
				    end			
			    	if tile == GROUND.INTERIOR then
				        NotInInterior = false
				    end
			    end
                if #nearby_player == 0 and IsPassableTile and IsGrassTile and NotInInterior	then
                    table.insert(centers, {x = node.x, z = node.y})
                end
			end
        end
	end 
    if #centers > 0 then
		local spawn_position = centers[math.random(#centers)]
        SpawnPrefab("charlie_valentine_day_coffee").Transform:SetPosition(spawn_position.x, 0, spawn_position.z)
    else
	    inst.taskcoffeespawntask, inst.taskcoffeespawntaskinfo = inst:ResumeTask(TUNING.TOTAL_DAY_TIME, inst.SpawnTaskCoffee)
	end
end

return function(inst)
    if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
	    local charlie_dragon_house_recipe = Recipe("charlie_dragon_house", {Ingredient("cutstone", 8), Ingredient("taffy", 20), Ingredient("charlie_dragon_feather", 6)}, RECIPETABS.TOWN, TECH.LOST, RECIPE_GAME_TYPE.COMMON, "charlie_dragon_house_placer", 4)
	    charlie_dragon_house_recipe.atlas = "images/map_icons/charlie_dragon_house.xml"
	    charlie_dragon_house_recipe.image = "charlie_dragon_house.tex"
		charlie_dragon_house_recipe.sortkey = 1
	else
	    local charlie_dragon_house_recipe = Recipe("charlie_dragon_house", {Ingredient("cutstone", 8), Ingredient("taffy", 20), Ingredient("charlie_dragon_feather", 6)}, RECIPETABS.TOWN, TECH.LOST, "charlie_dragon_house_placer", 4)
	    charlie_dragon_house_recipe.atlas = "images/map_icons/charlie_dragon_house.xml"
	    charlie_dragon_house_recipe.image = "charlie_dragon_house.tex"
		charlie_dragon_house_recipe.sortkey = 1
	end
	
	local charlie_dragon_sword_recipe = Recipe("charlie_dragon_sword", {Ingredient("cutstone", 1), Ingredient("ash", 4), Ingredient("charlie_dragon_feather", 8)}, RECIPETABS.WAR, TECH.LOST)
	charlie_dragon_sword_recipe.sortkey = 1	

	local charlie_candy_recipe = Recipe("charlie_candy", {Ingredient("twigs", 1), Ingredient("taffy", 2)}, RECIPETABS.WAR, TECH.LOST)
	charlie_candy_recipe.sortkey = 1.01	
	
	if IsDLCEnabled(PORKLAND_DLC) then
	
	    local shopping_bag_recipe1 = Recipe("charlie_shoppingbag_red", {Ingredient("oinc", 10)}, RECIPETABS.CITY, TECH.LOST)
		shopping_bag_recipe1.sortkey = 1	
	
	    local shopping_bag_recipe2 = Recipe("charlie_shoppingbag_blue", {Ingredient("oinc", 10)}, RECIPETABS.CITY, TECH.LOST)
		shopping_bag_recipe2.sortkey = 1.01
		
		local shopping_bag_recipe3 = Recipe("charlie_shoppingbag_green", {Ingredient("oinc", 10)}, RECIPETABS.CITY, TECH.LOST)
		shopping_bag_recipe3.sortkey = 1.02	
		
		local charlie_castle_recipe = Recipe("charlie_castle", {Ingredient("cutstone", 12), Ingredient("charlie_heart_inv", 10), Ingredient("charlie_heart_seed", 5)}, RECIPETABS.CITY, TECH.LOST, RECIPE_GAME_TYPE.COMMON, "charlie_castle_placer", 4)
	    charlie_castle_recipe.atlas = "images/map_icons/charlie_castle.xml"
	    charlie_castle_recipe.image = "charlie_castle.tex"
		charlie_castle_recipe.sortkey = 1.03 
		
	end
	
	inst:ListenForEvent("rainstart", function(_, data) CharlieRainStart(inst, data) end, GetWorld()) 
	
	if inst.components.shopper ~= nil then
	    local _shopper_component_original_PayFor_fn = inst.components.shopper.PayFor
		if _shopper_component_original_PayFor_fn ~= nil then
		    inst.components.shopper.PayFor = function(self, prefab)
			    if inst.components.builder ~= nil 
				    and ((not table.contains(inst.components.builder.recipes, "charlie_shoppingbag_blue"))
				        or (not table.contains(inst.components.builder.recipes, "charlie_shoppingbag_green")) 
				        or (not table.contains(inst.components.builder.recipes, "charlie_shoppingbag_red")))		
				    and math.random() < 0.05
				then
				    local recipe_names = {"charlie_shoppingbag_blue", "charlie_shoppingbag_green", "charlie_shoppingbag_red"}
					local recipes_to_unlock = {}
					for k,v in pairs(recipe_names) do
					    if not table.contains(inst.components.builder.recipes, v) then
						    table.insert(recipes_to_unlock, v)
						end
					end
					if #recipes_to_unlock > 0 then
					    local recipe_to_unlock = GetRandomItem(recipes_to_unlock)
						inst.components.builder:UnlockRecipe(recipe_to_unlock)
					end				
				end
			    if _shopper_component_original_PayFor_fn ~= nil then
				    _shopper_component_original_PayFor_fn(self, prefab)
				end
			end
		end
	end
	
	inst.SpawnTaskCoffee = SpawnTaskCoffee

end