local CharlieSkillTreeScreen = require("screens/charlieskilltreescreen")

local assets =
{
    Asset("ANIM", "anim/shadow_portal.zip"),
	Asset("ANIM", "anim/ui_portal_shadow_3x4.zip"), 
}

local prefabs = 
{

}

local function OnActivate(inst, doer)
    if doer ~= nil then
	    if doer.shadowbox ~= nil then
		    inst.components.interactivelevel.inactive = true
			return
		else
            doer.shadowbox = inst
		end
	end
    inst.AnimState:PlayAnimation("activate")
    inst.AnimState:PushAnimation("idle_loop_on", true)
    inst:DoTaskInTime(1, function() 
	    TheFrontEnd:PushScreen(CharlieSkillTreeScreen()) 
		inst.components.interactivelevel.inactive = true
	end)
end

local function OnHitWater(inst)
	if inst.float_fx == nil then
		inst.float_fx = SpawnPrefab("float_fx_front")
		inst.float_fx.entity:SetParent(inst.entity)
		inst.float_fx.AnimState:PlayAnimation("idle_front_med", true)		
		inst.float_fx.Transform:SetScale(0.6, 0.75, 0.6)
	end
	if inst.float_fx2 == nil then
		inst.float_fx2 = SpawnPrefab("float_fx_back")
		inst.float_fx2.entity:SetParent(inst.entity)
		inst.float_fx2.AnimState:PlayAnimation("idle_back_med", true)
		inst.float_fx2.Transform:SetScale(0.6, 0.75, 0.6)
	end	
end

local function OnHitLand(inst)
	if inst.float_fx ~= nil then
		inst.float_fx:Remove()
		inst.float_fx = nil
	end
	if inst.float_fx2 ~= nil then
		inst.float_fx2:Remove()
		inst.float_fx2 = nil
	end	
end

local function TestItemCharlieShadowbox(inst, item, slot)
	return item:HasTag("shadowboxitem") 
end

local function CheckIfCanUnlockContainer(inst)
    if GetPlayer() and GetPlayer().superemberguru then
	    if inst.components.container ~= nil then 
		    inst.components.container.canbeopened = true 
		end
	elseif inst.components.container ~= nil then
	    inst.components.container.canbeopened = false
	end
end

local charlie_shadowbox_slotpos = {}

for y = 2.5, -0.5, -1 do
	for x = 0, 2 do
		table.insert(charlie_shadowbox_slotpos, Vector3(75*x-75*2+75, 75*y-75*2+75, 0))
	end
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
	
    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("shadow_portal")
    inst.AnimState:SetBuild("shadow_portal")
    inst.AnimState:PlayAnimation("idle_off")

    inst:AddTag("charlie_shadowbox")
	
    inst:AddComponent("inventoryitem")

    inst:AddComponent("inspectable")

	if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
	    inst:AddComponent("floatable")
		inst.components.floatable:SetOnHitWaterFn(OnHitWater)
		inst.components.floatable:SetOnHitLandFn(OnHitLand)

		inst:ListenForEvent("onputininventory", OnHitLand)
	end
	
	if GetPlayer() and GetPlayer().prefab == "charlie" then
        inst:AddComponent("interactivelevel")
    	inst.components.interactivelevel.OnActivate = OnActivate
	end 
	
    inst:AddComponent("container")
	inst.components.container:SetNumSlots(#charlie_shadowbox_slotpos, true)
	inst.components.container.itemtestfn = TestItemCharlieShadowbox
	inst.components.container.widgetslotpos = charlie_shadowbox_slotpos
	inst.components.container.widgetpos = Vector3(75, 200, 0)
	inst.components.container.side_align_tip = 160
	inst.components.container.canbeopened = false 
	inst.components.container.widgetanimbank = "ui_portal_shadow_3x4"
	inst.components.container.widgetanimbuild = "ui_portal_shadow_3x4"	 	
	
	inst.UpdateContainer = CheckIfCanUnlockContainer
	inst:DoTaskInTime(0, CheckIfCanUnlockContainer)
	
    return inst
end

return Prefab("charlie_shadowbox", fn, assets, prefabs)