
local function MakeShoppingBag(colour)

    local commonassets = 
    {
        Asset("ANIM", "anim/charlie_shoppingbag.zip"),
    }

    local commonprefabs = 
    {

    }

    local function onopen(inst)
	    inst.SoundEmitter:PlaySound("dontstarve/wilson/backpack_open", "open")
    end

    local function onclose(inst)
	    inst.SoundEmitter:PlaySound("dontstarve/wilson/backpack_close", "open")
    end
	
	local function OnlyInCity(inst, item, slot)
	    local x, y, z = inst.Transform:GetWorldPosition()
		if inst.components.inventoryitem ~= nil and inst.components.inventoryitem:GetGrandOwner() then 
		    local grandowner = inst.components.inventoryitem:GetGrandOwner()
		    x, y, z = grandowner.Transform:GetWorldPosition()
		end 
		local CITY_TILES = {GROUND.FOUNDATION, GROUND.COBBLEROAD, GROUND.LAWN}
		return table.contains(CITY_TILES, GetWorld().Map:GetTileAtPoint(x, y, z))
	end 

    local slotpos = {}

    for y = 2, 0, -1 do
	    for x = 0, 2 do
            table.insert(slotpos, Vector3(80*x-80*2+80, 80*y-80*2+80, 0))
    	end
    end
	
	local function OnHitWater(inst)
	    if inst.float_fx == nil then
		    inst.float_fx = SpawnPrefab("float_fx_front")
		    inst.float_fx.entity:SetParent(inst.entity) 
	    end
	    if inst.float_fx2 == nil then
		    inst.float_fx2 = SpawnPrefab("float_fx_back")
		    inst.float_fx2.entity:SetParent(inst.entity) 
    	end	
    end

    local function OnHitLand(inst)
	    if inst.float_fx ~= nil then
		    inst.float_fx:Remove()
		    inst.float_fx = nil
    	end
	    if inst.float_fx2 ~= nil then
		    inst.float_fx2:Remove()
		    inst.float_fx2 = nil
	    end	
    end

    local function commonfn()	
        local inst = CreateEntity()

        inst.entity:AddTransform()
        inst.entity:AddAnimState()	
        inst.entity:AddSoundEmitter()
        inst.entity:AddMiniMapEntity()
		
		MakeInventoryPhysics(inst)
		
		inst.MiniMapEntity:SetIcon("charlie_shoppingbag_"..colour..".tex")
		
        inst.AnimState:SetBuild("charlie_shoppingbag")
        inst.AnimState:SetBank("charlie_shoppingbag")
        inst.AnimState:PlayAnimation(colour)

		inst:AddComponent("inspectable")
		inst:AddComponent("inventoryitem")
		
		inst:AddComponent("container")
		inst.components.container:SetNumSlots(#slotpos)
		inst.components.container.onopenfn = onopen
		inst.components.container.onclosefn = onclose
		inst.components.container.widgetslotpos = slotpos
		inst.components.container.widgetanimbank = "ui_chest_3x3"
		inst.components.container.widgetanimbuild = "ui_chest_3x3"
		inst.components.container.widgetpos = Vector3(0, 200, 0)
		inst.components.container.side_align_tip = 160
		inst.components.container.itemtestfn = OnlyInCity

        if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
            inst:AddComponent("waterproofer")
            inst.components.waterproofer:SetEffectiveness(0)
        end

        if inst.GetIsOnWater ~= nil then
	        inst:AddComponent("floatable")
		    inst.components.floatable:SetOnHitWaterFn(OnHitWater)
		    inst.components.floatable:SetOnHitLandFn(OnHitLand)
		    inst.components.inventoryitem:SetOnPutInInventoryFn(OnHitLand)		      
        end

		return inst
	end
	
    return Prefab("charlie_shoppingbag_"..colour, commonfn, commonassets, commonprefabs)

end 

return MakeShoppingBag("red"),
    MakeShoppingBag("blue"),
	MakeShoppingBag("green")