local assets=
{ 
    Asset("ANIM", "anim/creditcard.zip"),
}

local prefabs = 
{

}

local function accepttest(inst, item, giver)
    if item.prefab == "oinc" then
	    return inst.oinc_amount_inside < inst.max_oinc
	elseif item.prefab == "oinc10" then
	    return inst.oinc_amount_inside < inst.max_oinc - 9
	elseif item.prefab == "oinc100" then
	    return inst.oinc_amount_inside < inst.max_oinc - 99
	else
	    return false
	end
end

local function onaccept(inst, giver, item)
    if item.prefab == "oinc" then
	    inst.oinc_amount_inside = math.min(inst.oinc_amount_inside + 1, inst.max_oinc)
	elseif item.prefab == "oinc10" then
	    inst.oinc_amount_inside = math.min(inst.oinc_amount_inside + 10, inst.max_oinc)
	elseif item.prefab == "oinc100" then
	    inst.oinc_amount_inside = math.min(inst.oinc_amount_inside + 100, inst.max_oinc)
	end
	inst.SoundEmitter:PlaySound("dontstarve_DLC003/common/objects/coins/1")
end

local function onrefuse(inst, giver, item)
    if giver == nil or giver.components.talker == nil then 
	    return 	
	end
    if TUNING.LANGUAGE == true then
	    if item.prefab == "oinc" or item.prefab == "oinc10" or item.prefab == "oinc100" then
	        giver.components.talker:Say("Balance limit has been reached.")
		else
		    giver.components.talker:Say("What needs to be deposited is oincs.")
	    end
	elseif TUNING.LANGUAGE == false then
	    if item.prefab == "oinc" or item.prefab == "oinc10" or item.prefab == "oinc100" then
	        giver.components.talker:Say("已达到余额上限。")
		else
		    giver.components.talker:Say("需要存入的是呼噜币。")
	    end
	end
end

local function OnHitWater(inst)
	if inst.float_fx == nil then
		inst.float_fx = SpawnPrefab("float_fx_front")
		inst.float_fx.entity:SetParent(inst.entity)
		inst.float_fx.AnimState:PlayAnimation("idle_front_med", true)
        inst.float_fx.Transform:SetPosition(0, 0.1, 0)		
	end
	if inst.float_fx2 == nil then
		inst.float_fx2 = SpawnPrefab("float_fx_back")
		inst.float_fx2.entity:SetParent(inst.entity)
		inst.float_fx2.AnimState:PlayAnimation("idle_back_med", true)
        inst.float_fx2.Transform:SetPosition(0, 0.1, 0)
	end	
end

local function OnHitLand(inst)
	if inst.float_fx ~= nil then
		inst.float_fx:Remove()
		inst.float_fx = nil
	end
	if inst.float_fx2 ~= nil then
		inst.float_fx2:Remove()
		inst.float_fx2 = nil
	end	
end

local function description(inst, viwer)
    local desc = ""
    if TUNING.LANGUAGE == true then
	    if inst.oinc_amount_inside <= 0 then
		    desc = "There is not any oincs in this credit card."
		else
		    if inst.oinc_amount_inside == 1 then
			    desc = "There is "..inst.oinc_amount_inside.." oinc left on this credit card."
			else
			    desc = "There is "..inst.oinc_amount_inside.." oincs left on this credit card."
			end
	        if inst.oinc_amount_inside >= inst.max_oinc then
		        desc = desc.." Balance limit has been reached."
		    end			
		end	
	elseif TUNING.LANGUAGE == false then
	    if inst.oinc_amount_inside <= 0 then
		    desc = "这张信用卡里没有任何呼噜币。"
		else
		    desc = "这张信用卡还剩"..inst.oinc_amount_inside.."呼噜币。"
		end	
	    if inst.oinc_amount_inside >= inst.max_oinc then
		    desc = desc.."已达到余额上限。"
		end
	end
	return desc
end

local function OnSave(inst, data)
    data.oinc_amount_inside = inst.oinc_amount_inside or 0
end

local function OnLoad(inst, data)
    if data ~= nil then
        inst.oinc_amount_inside = data.oinc_amount_inside or 0
    end	
end

local function InsertOincs(loots, num, type)
	if num > 0 then
		for n=1, num do
			table.insert(loots, type)
		end
	end
end

local function OnRemoveEntity(inst)
    if inst.oinc_amount_inside ~= nil and inst.oinc_amount_inside > 0 then
	    local loots = {}
        local amt = inst.oinc_amount_inside
		local oinc100 = math.floor(amt / 100)
		local oinc10  = math.floor((amt - (oinc100 * 100)) / 10)
		local oinc    = amt - (oinc100 * 100) - (oinc10 * 10)
		InsertOincs(loots, oinc100, "oinc100")
		InsertOincs(loots, oinc10,  "oinc10" )
		InsertOincs(loots, oinc,    "oinc"   )
	    for k,v in pairs(loots) do
		    inst.components.lootdropper:SpawnLootPrefab(v)
	    end	    
	end
end

local function fn()
    local inst = CreateEntity()

	if not IsDLCEnabled(PORKLAND_DLC) then
	    inst:DoTaskInTime(0, inst.Remove)
		return inst
	end
	
    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddMiniMapEntity()

    inst.MiniMapEntity:SetIcon("creditcard.tex")
	
    MakeInventoryPhysics(inst)
   	MakeBlowInHurricane(inst, TUNING.WINDBLOWN_SCALE_MIN.LIGHT, TUNING.WINDBLOWN_SCALE_MAX.LIGHT)
	
    inst.AnimState:SetBank("creditcard")
    inst.AnimState:SetBuild("creditcard")
    inst.AnimState:PlayAnimation("idle")

    inst:AddTag("creditcard")

	inst:AddComponent("inspectable")
    inst.components.inspectable:SetDescription(description)
	
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.CollectInventoryActions = function(inst, doer, actions)
	    if inst ~= nil and inst.inst ~= nil and inst.inst.oinc_amount_inside ~= nil and inst.inst.oinc_amount_inside > 0 then
	        table.insert(actions, ACTIONS.DRAW_OINC)
		end
	end
	inst.components.inventoryitem:SetOnPutInInventoryFn(OnHitLand)	

    inst:AddComponent("floatable")
	inst.components.floatable:SetOnHitWaterFn(OnHitWater)
	inst.components.floatable:SetOnHitLandFn(OnHitLand)

    inst:AddComponent("trader")
    inst.components.trader:SetAcceptTest(accepttest)
    inst.components.trader.onaccept = onaccept
    inst.components.trader.onrefuse = onrefuse
	inst.components.trader.acceptnontradable = true

    inst:AddComponent("waterproofer")
    inst.components.waterproofer:SetEffectiveness(0)

    inst:AddComponent("lootdropper")

    inst.oinc_amount_inside = 0
	inst.max_oinc = 10000
	
    inst.OnSave = OnSave
    inst.OnLoad = OnLoad
	inst.OnRemoveEntity = OnRemoveEntity

    return inst
end

return Prefab("creditcard", fn, assets, prefabs)
