local assets =
{
	Asset("ANIM", "anim/eye_of_insight.zip"),
}

local prefabs = 
{
    "shadowcorrosionmachine_fx",
}

local function OnHitWater(inst)
	if inst.float_fx == nil then
		inst.float_fx = SpawnPrefab("float_fx_front")
		inst.float_fx.entity:SetParent(inst.entity) 
	end
	if inst.float_fx2 == nil then
		inst.float_fx2 = SpawnPrefab("float_fx_back")
		inst.float_fx2.entity:SetParent(inst.entity) 
	end	
end

local function OnHitLand(inst)
	if inst.float_fx ~= nil then
		inst.float_fx:Remove()
		inst.float_fx = nil
	end
	if inst.float_fx2 ~= nil then
		inst.float_fx2:Remove()
		inst.float_fx2 = nil
	end	
end

local function fn(Sim)
	local inst = CreateEntity()
	
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
    inst.entity:AddMiniMapEntity()

    inst.MiniMapEntity:SetIcon("eyeofinsight.tex")
	
    MakeInventoryPhysics(inst)
    
    inst.AnimState:SetBank("eye_of_insight")
    inst.AnimState:SetBuild("eye_of_insight")
    inst.AnimState:PlayAnimation("idle")
 
    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem") 
    inst.components.inventoryitem.CollectInventoryActions = function(inst, doer, actions)
	    if doer ~= nil and doer:HasTag("charlie") and not doer.IsInInsight then
		    table.insert(actions, ACTIONS.EYEOFINSIGHT_SEE)
		end
	end

    if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
        inst:AddComponent("waterproofer")
        inst.components.waterproofer:SetEffectiveness(0)
    end

    if inst.GetIsOnWater ~= nil then
	    inst:AddComponent("floatable")
		inst.components.floatable:SetOnHitWaterFn(OnHitWater)
		inst.components.floatable:SetOnHitLandFn(OnHitLand)
		inst.components.inventoryitem:SetOnPutInInventoryFn(OnHitLand)		      
    end
	
    return inst
end

return Prefab("eyeofinsight", fn, assets, prefabs)