local assets =
{
    Asset("ANIM", "anim/float_fx.zip"),
}

local prefabs =
{

}

local function common_fn(is_front)
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()

    inst.persists = false

    inst:AddTag("FX")
	inst:AddTag("NOCLICK")
	inst:AddTag("NOBLOCK")
	inst:AddTag("INTERIOR_LIMBO_IMMUNE")  --If someday we get a water tile in interior...

    if inst.GetIsOnWater == nil then  --Need to enable Shipwrecked or Hamlet DLC to use this fx
	    inst:DoTaskInTime(0, inst.Remove)
	    return inst
	end

    inst.AnimState:SetBuild("float_fx")

    if is_front then
        inst.AnimState:SetBank("float_front")
        inst.AnimState:PlayAnimation("idle_front_small", true)
        inst.AnimState:SetLayer(LAYER_BACKGROUND)
		inst.AnimState:SetSortOrder(4)		
    else
        inst.AnimState:SetBank("float_back")
        inst.AnimState:SetLayer(LAYER_BACKGROUND)
		inst.AnimState:SetSortOrder(2)
        inst.AnimState:PlayAnimation("idle_back_small", true)
    end

    return inst
end

local function front_fn()
    return common_fn(true)
end

local function back_fn()
    return common_fn(false)
end

return Prefab("float_fx_front", front_fn, assets, prefabs),
    Prefab("float_fx_back", back_fn, assets, prefabs)
