local assets =
{
    Asset("ANIM", "anim/abigail_flower_rework.zip"),
}

local prefabs = 
{

}

local function OnHitWater(inst)
	if inst.float_fx == nil then
		inst.float_fx = SpawnPrefab("float_fx_front")
		inst.float_fx.entity:SetParent(inst.entity)
		inst.float_fx.AnimState:PlayAnimation("idle_front_small", true)		
		inst.float_fx.Transform:SetScale(0.9, 0.9, 0.9)
		inst.float_fx.Transform:SetPosition(0, 0.15, 0)
	end
	if inst.float_fx2 == nil then
		inst.float_fx2 = SpawnPrefab("float_fx_back")
		inst.float_fx2.entity:SetParent(inst.entity)
		inst.float_fx2.AnimState:PlayAnimation("idle_back_small", true)
		inst.float_fx2.Transform:SetScale(0.9, 0.9, 0.9)
		inst.float_fx2.Transform:SetPosition(0, 0.15, 0)
	end	
end

local function OnHitLand(inst)
	if inst.float_fx ~= nil then
		inst.float_fx:Remove()
		inst.float_fx = nil
	end
	if inst.float_fx2 ~= nil then
		inst.float_fx2:Remove()
		inst.float_fx2 = nil
	end	
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()

    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("abigail_flower_rework")
    inst.AnimState:SetBuild("abigail_flower_rework")
    inst.AnimState:PlayAnimation("level0_loop")

    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/inventoryimages/friendly_shadow_flower.xml"
    inst.components.inventoryitem.imagename = "friendly_shadow_flower"	

    inst:AddComponent("inspectable")

	if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
	    inst:AddComponent("floatable")
		inst.components.floatable:SetOnHitWaterFn(OnHitWater)
		inst.components.floatable:SetOnHitLandFn(OnHitLand)

		inst:ListenForEvent("onputininventory", OnHitLand)
	end
	
	--TO DO, NOT FINISHED

    return inst
end

return Prefab("friendly_shadow_flower", fn, assets, prefabs)