local assets = 
{
    Asset("ANIM", "anim/miasma_over.zip"),
}

local assets2 = 
{
    Asset("ANIM", "anim/miasma_over.zip"),
	Asset("ANIM", "anim/torch_shadow.zip"),
}

local prefabs = 
{

}

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()

    inst.AnimState:SetBuild("miasma_over")
    inst.AnimState:SetBank("miasma_over")
    inst.AnimState:PlayAnimation("blind_loop", true)
    inst.AnimState:SetOrientation(ANIM_ORIENTATION.OnGround)
    inst.AnimState:SetLayer(LAYER_BACKGROUND)
    inst.AnimState:SetSortOrder(3)

	inst:AddTag("FX")
    inst:AddTag("NOCLICK")
    inst:AddTag("NOBLOCK")
    inst:AddTag("INTERIOR_LIMBO_IMMUNE")
	inst:AddTag("pugalisk_avoids")
	inst:AddTag("miasma")
	
	inst.Transform:SetScale(0.45, 0.45, 0.45)
	
	inst:DoTaskInTime(0, function()
	    if not inst:IsOnValidGround() then
		    inst:Remove()
		end	
	    if inst.GetIsOnWater ~= nil and inst:GetIsOnWater() then
		    inst:Remove()
		end
	end)
	
    return inst
end

local function CreateAcidCore()
	local inst = CreateEntity()

	inst.entity:AddTransform()
	inst.entity:AddAnimState()

	inst:AddTag("FX")
	inst:AddTag("NOCLICK")
	inst:AddTag("NOBLOCK")
	inst:AddTag("INTERIOR_LIMBO_IMMUNE")	

    inst.AnimState:SetBank("torch")
    inst.AnimState:SetBuild("torch_shadow")	
	inst.AnimState:PlayAnimation("idle") 
	inst.AnimState:SetOrientation(ANIM_ORIENTATION.OnGround)
	inst.AnimState:SetLayer(LAYER_BACKGROUND)
	inst.AnimState:SetSortOrder(4)
	
	inst.Transform:SetScale(3, 3, 3)		
	
	inst.persists = false

	return inst
end

local function SetLifeTime(inst, lifetime)
    if lifetime ~= nil then
	    inst.disappeartask, inst.disappeartaskinfo = inst:ResumeTask(lifetime, inst.Remove)
	end
end

local function OnSave(inst, data)
    if inst.disappeartaskinfo then
        data.disappeartask = inst:TimeRemainingInTask(inst.disappeartaskinfo)
    end
end 

local function OnLoad(inst, data)
	if data ~= nil then 
        if data.disappeartask then
            if inst.disappeartask then 
			    inst.disappeartask:Cancel() 
				inst.disappeartask = nil 		
			end
            inst.disappeartaskinfo = nil
            inst.disappeartask, inst.disappeartaskinfo = inst:ResumeTask(data.disappeartask, inst.Remove)
        end
	end
end 

local function OnLongUpdate(inst, dt)
    if inst.disappeartask and inst.disappeartaskinfo then
        local new_time = math.max(inst:TimeRemainingInTask(inst.disappeartaskinfo) - dt, 0)

        inst.disappeartask:Cancel()
        inst.disappeartask = nil 
        inst.disappeartaskinfo = nil

        inst.disappeartask, inst.disappeartaskinfo = inst:ResumeTask(new_time, inst.Remove)
    end
end 

local function fn2()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()

    inst.AnimState:SetBuild("miasma_over")
    inst.AnimState:SetBank("miasma_over")
    inst.AnimState:PlayAnimation("blind_loop", true)
    inst.AnimState:SetOrientation(ANIM_ORIENTATION.OnGround)
    inst.AnimState:SetLayer(LAYER_BACKGROUND)
    inst.AnimState:SetSortOrder(3)

    inst:AddTag("NOCLICK")
    inst:AddTag("NOBLOCK")
	inst:AddTag("shadow_acid_smoke")
	
	inst.Transform:SetScale(0.45, 0.45, 0.45)

	inst:AddComponent("shadowacidsmoke")
	
    inst.acidcore = SpawnPrefab("fire")
    inst.acidcore.entity:SetParent(inst.entity)		
	inst.acidcore.persists = false
	inst.acidcore:AddTag("NOCLICK") 
	inst.acidcore:AddTag("NOBLOCK") 
	inst.acidcore.components.firefx:SetLevel(4) 
	inst.acidcore.components.heater.heatfn = function() return 0 end
	inst.acidcore.AnimState:SetOrientation(ANIM_ORIENTATION.OnGround)
	inst.acidcore.AnimState:SetLayer(LAYER_BACKGROUND)
	inst.acidcore.AnimState:SetSortOrder(4)
    inst.acidcore.AnimState:SetMultColour(0, 0, 0, 0.6)
	inst.acidcore.Transform:SetScale(1.5, 1.5, 1.5)	
	inst.acidcore.Light:Enable(false)
	
	inst.SetLifeTime = SetLifeTime
	inst.OnLongUpdate = OnLongUpdate   
	inst.OnSave = OnSave
	inst.OnLoad = OnLoad	
	
    return inst
end

return Prefab("miasma", fn, assets, prefabs),
    Prefab("shadow_acid_smoke", fn2, assets2, prefabs)