--Grid Item Shallow Puddle and Pothole Puddle are from Plants vs. Zombies 2.

local common_puddle_assets = 
{
    Asset("ANIM", "anim/oasis_tile.zip"),
}

local acid_puddle_assets = 
{
    Asset("ANIM", "anim/oasis_tile.zip"),
    Asset("ANIM", "anim/shadow_acid_bottle.zip"),
    Asset("ANIM", "anim/shadow_acid_bottle_advanced.zip"),	
}

local puddle_prefabs =
{

}

local function CheckPlaceIfValidAndUpdateItem(inst)
    local x, y, z = inst.Transform:GetWorldPosition()
	for k,v in pairs(TheSim:FindEntities(x, y, z, 2.75)) do
	    if inst:IsValid() and v:HasTag("puddle") and v ~= inst then
	        inst:Remove()
		    break
		end
		for i,j in pairs(inst.BlockingGridItems or {}) do
		    if inst:IsValid() and v:HasTag(j) then
			    inst:Remove()
			    break
			end
		end
	end
	
	local radius = 2	
    for i = -radius, radius, 1 do
        if inst:IsValid() and (GetWorld().Map:GetTileAtPoint(x - radius, y, z + i) == GROUND.IMPASSABLE or GetWorld().Map:GetTileAtPoint(x + radius, y, z + i) == GROUND.IMPASSABLE) then
            inst:Remove()
			break
        end
    end
	
    for i = -(radius - 1), radius - 1, 1 do
        if inst:IsValid() and (GetWorld().Map:GetTileAtPoint(x + i, y, z - radius) == GROUND.IMPASSABLE or GetWorld().Map:GetTileAtPoint(x + i, y, z + radius) == GROUND.IMPASSABLE) then
            inst:Remove()
			break
        end
    end	
	
	if inst:IsValid() and inst.IsPosSurroundedByLand ~= nil and not inst:IsPosSurroundedByLand(x, y, z, 3) then
	    inst:Remove()
	end	
	
	if inst:IsValid() and inst.GetIsFlooded ~= nil and inst:GetIsFlooded() then
	    inst:Remove()
	end
	
	if inst:IsValid() and inst.GetIsFlooded ~= nil then
	    if GetWorld() and GetWorld().Map and GetWorld().Map:IsTileGridValid() and GetWorld():HasTag("volcano") then
			local tx, ty = GetWorld().Map:GetTileXYAtPoint(x, y, z)
			local lava_dist = GetWorld().Map:GetClosestTileDist(tx, ty, GROUND.VOLCANO_LAVA, 3)
		    if lava_dist <= 3 then
	            inst:Remove()
			end
		end
	end
	
	
	if inst:IsValid() and inst.UpdateIsInInterior ~= nil then
	    inst:UpdateIsInInterior()
	    if inst.CheckIsInInterior ~= nil and inst:CheckIsInInterior() then
		    inst:Remove()
		end
	end
	
	if inst:IsValid() then
	    for _,item in pairs(TheSim:FindEntities(x, y, z, 2.5, {"isinventoryitem"}, {"INLIMBO", "NOFORAGE", "aquatic"})) do
	        if item ~= inst and item.entity:IsVisible() and item.components.inventoryitem ~= nil then
			    if item.components.inventoryitem.OnHitGround ~= nil then
				    item.components.inventoryitem:OnHitGround(0)
				end
			end
	    end		
	end
end

local function CheckIfMinimapIconCanEnable(inst)
    if inst:IsValid() and inst.persists and not inst.AlreadyCheckedMiniMap then
        local x, y, z = inst.Transform:GetWorldPosition()
		if inst:HasTag("deeppuddle") then 
	        for k,v in pairs(TheSim:FindEntities(x, y, z, 10, nil, {"shadowpuddle", "shadowacidpuddle"}, {"puddle", "deeppuddle"})) do
                if v ~= inst and v:IsValid() and v.persists and v.MiniMapEntity ~= nil then
				    v.MiniMapEntity:SetEnabled(false)
					v.AlreadyCheckedMiniMap = true 
				end 
     	    end	
		else
	        for k,v in pairs(TheSim:FindEntities(x, y, z, 10, {"puddle"}, {"shadowpuddle", "shadowacidpuddle", "deeppuddle"})) do
                if v ~= inst and v:IsValid() and v.persists and v.MiniMapEntity ~= nil then
				    v.MiniMapEntity:SetEnabled(false)
					v.AlreadyCheckedMiniMap = true 
				end 
     	    end			
		end 
	end 
end

local function PuddleOnDryUp(inst, data)
    local x, y, z = inst.Transform:GetWorldPosition()
    for k, v in pairs(TheSim:FindEntities(x, y, z, 0.5, {"LilyPadForPuddle"})) do  
		if v ~= nil and v:IsValid() and v.entity:IsVisible() then
			v.persists = false
			v:AddComponent("smallerandsmallerondestroy")
		end
	end
	
    for k2, v2 in pairs(TheSim:FindEntities(x, y, z, 2.5, nil, {"isinventoryitem", "player", "ground"}, {"wall", "structure", "aquatic", "plant", "heart_plant", "coralreef"})) do
		if v2 ~= nil and v2:IsValid() and v2.entity:IsVisible() then
		    if v2:HasTag("heart_plant") then
			    if v2.CheckHeartType ~= nil then
				    v2:CheckHeartType()
				end 
			elseif v2.components.workable ~= nil then
			    v2.components.workable:Destroy(inst)
			elseif v2.components.health ~= nil then
			    v2.components.health:SetVal(0)
			else
			    v2:Remove()
			end
		end
	end	
	
	for _,item in pairs(TheSim:FindEntities(x, y, z, 2.5, {"isinventoryitem"}, {"INLIMBO", "NOFORAGE"})) do
	    if item ~= inst and item.entity:IsVisible() and item.components.inventoryitem ~= nil then
		    if item.components.inventoryitem.OnHitGround ~= nil then
			    item.components.inventoryitem:OnHitGround(0)
			end
    	end
	end
end

local function PuddleOnDisappear(inst)
    inst.persists = false
    if inst.disappeartask then 
		inst.disappeartask:Cancel() 
		inst.disappeartask = nil 		
	end	
	inst.disappeartaskinfo = nil
	inst.AnimState:PlayAnimation("dry_pre")
	inst:ListenForEvent("animover", inst.Remove)
end

local function SetLifeTime(inst, lifetime)
    if lifetime ~= nil then
	    inst.disappeartask, inst.disappeartaskinfo = inst:ResumeTask(lifetime, PuddleOnDisappear)
	end
end

local function AcidPuddleOnSave(inst, data)
    if inst.disappeartaskinfo then
        data.disappeartask = inst:TimeRemainingInTask(inst.disappeartaskinfo)
    end
	if inst.superacid then 
	    data.superacid = true 
	end 
end 

local function AcidPuddleOnLoad(inst, data)
	if data ~= nil then 
        if data.disappeartask then
            if inst.disappeartask then 
			    inst.disappeartask:Cancel() 
				inst.disappeartask = nil 		
			end
            inst.disappeartaskinfo = nil
            inst.disappeartask, inst.disappeartaskinfo = inst:ResumeTask(data.disappeartask, PuddleOnDisappear)
        end
		if data.superacid then 
		    inst.superacid = true 
		end 
	end
end 

local function AcidPuddleOnLongUpdate(inst, dt)
    if inst.disappeartask and inst.disappeartaskinfo then
        local new_time = math.max(inst:TimeRemainingInTask(inst.disappeartaskinfo) - dt, 0)

        inst.disappeartask:Cancel()
        inst.disappeartask = nil 
        inst.disappeartaskinfo = nil

        inst.disappeartask, inst.disappeartaskinfo = inst:ResumeTask(new_time, PuddleOnDisappear)
    end
end 

local function CreateAcidCore(issuper)
	local inst = CreateEntity()

	inst.entity:AddTransform()
	inst.entity:AddAnimState()

	inst:AddTag("FX")
	inst:AddTag("NOCLICK")
	inst:AddTag("NOBLOCK")
	inst:AddTag("INTERIOR_LIMBO_IMMUNE")	

    if issuper then 
	    inst.AnimState:SetBank("shadow_acid_bottle_advanced")
	    inst.AnimState:SetBuild("shadow_acid_bottle_advanced")
	else
	    inst.AnimState:SetBank("shadow_acid_bottle")
	    inst.AnimState:SetBuild("shadow_acid_bottle")	
	end
	inst.AnimState:PlayAnimation("idle_water") 
	inst.AnimState:SetOrientation(ANIM_ORIENTATION.OnGround)
	inst.AnimState:SetLayer(LAYER_BACKGROUND)
	inst.AnimState:SetSortOrder(2)
	
	inst.Transform:SetScale(1.5, 1.5, 1.5)		
	
	inst.persists = false

	return inst
end

local function SpawnCoreEntForAcid(inst)
    if inst.superacid then 
        inst.acidcore = CreateAcidCore(true)
        inst.acidcore.entity:SetParent(inst.entity)	
	else
        inst.acidcore = CreateAcidCore(false)
        inst.acidcore.entity:SetParent(inst.entity)		
	end 
end 

local function MakePuddle(name, _assets, prefabs, custome_fn, IsDeeper, IsShadow)
	local assets = {}
	for _, v in ipairs(_assets) do
		table.insert(assets, v)
	end
	
    local function normal_fn()	
        local inst = CreateEntity()

        inst.entity:AddTransform()
        inst.entity:AddAnimState()	
        inst.entity:AddSoundEmitter()
        inst.entity:AddMiniMapEntity()
		
		inst.MiniMapEntity:SetIcon("commonpuddle.tex")
		
        inst.AnimState:SetBuild("oasis_tile")
        inst.AnimState:SetBank("oasis_tile")
        inst.AnimState:PlayAnimation("idle", true)
        inst.AnimState:SetOrientation(ANIM_ORIENTATION.OnGround)
        inst.AnimState:SetLayer(LAYER_BACKGROUND)
        inst.AnimState:SetSortOrder(1)
		inst.AnimState:OverrideSymbol("sandlines", "oasis_tile", "")
		
		inst.Transform:SetScale(0.8, 0.8, 0.8)
		
	    inst:AddTag("NOCLICK")
	    inst:AddTag("NOBLOCK")	
		inst:AddTag("puddle") 
		inst:AddTag("pugalisk_avoids")
		inst:AddTag("watersource")
		
		inst.StartingAnimation = "dry_pst"
		inst.LoopingAnimation = "idle"
		inst.DestroyAnimation = "dry_pre"
		inst.BlockingGridItems = { "butterpuddle" }
		
		inst:DoTaskInTime(0, CheckPlaceIfValidAndUpdateItem)
		
		inst:AddComponent("floatfxspawner")
		
		inst:ListenForEvent("dryup", PuddleOnDryUp)
		
		if IsDeeper then
		    inst.MiniMapEntity:SetIcon("deeppuddle.tex")
			
		    inst:AddTag("deeppuddle")
			
	        inst.AnimState:SetMultColour(0.5, 0.5, 0.5, 1)		
			
			inst.StunTime = 2
			inst.UnaffectedByPuddles = { "flying", "ghost", "shadow", "crocodog", "hippopotamoose", "frog", "platapine", "snake_amphibious", "seaflora" }
			inst.StunnedByPuddles = { "epic", "player" }
			inst.MechsForPuddles = { "researchlab", "researchlab2", "transistor", "diviningrod", "winterometer", "rainometer", "lightning_rod", "firesuppressor", "smelter", "basefan", "hogusporkusator", "piratihatitator", "researchlab4", "researchlab3", "cookpot", "icebox" }
			inst.SafeIfLilyPad = { "player", "critter", "smallcreature" }
		   	
			inst:AddComponent("potholepuddle")
		end 
		
		if IsShadow then
		    inst.MiniMapEntity:SetEnabled(false)
            inst.AnimState:SetMultColour(0, 0, 0, 1)		
            if name ~= "shadowacid" then 			
			    inst:AddComponent("shadowpuddle")
			    inst:AddTag("shadowpuddle")
			else
			    inst:AddTag("shadowacidpuddle")
			    inst:AddComponent("shadowacidpuddle")
				inst.SetLifeTime = SetLifeTime 
				inst.OnLongUpdate = AcidPuddleOnLongUpdate
				inst.OnSave = AcidPuddleOnSave
				inst.OnLoad = AcidPuddleOnLoad
				inst:DoTaskInTime(0, SpawnCoreEntForAcid)
			end 
		else
			inst:DoTaskInTime(math.random()*0.25, CheckIfMinimapIconCanEnable)
        end 		
		
		if custome_fn ~= nil then
		    custome_fn(inst)
		end
		
		return inst
	end
	
    return Prefab(name.."puddle", normal_fn, assets, prefabs)
end

local function PuddleSpreader(inst)
    inst:AddComponent("puddlespreader")
end

return MakePuddle("shallow", common_puddle_assets, puddle_prefabs, PuddleSpreader),
    MakePuddle("pothole", common_puddle_assets, puddle_prefabs, PuddleSpreader, true), 
	MakePuddle("shadow", common_puddle_assets, puddle_prefabs, nil, nil, true),
	MakePuddle("shadowacid", acid_puddle_assets, puddle_prefabs, nil, nil, true)
