local assets =
{
    Asset("ANIM", "anim/purebrilliance.zip"),
}

local function OnHitWater(inst)
	if inst.float_fx == nil then
		inst.float_fx = SpawnPrefab("float_fx_front")
		inst.float_fx.entity:SetParent(inst.entity)	
	end
	if inst.float_fx2 == nil then
		inst.float_fx2 = SpawnPrefab("float_fx_back")
		inst.float_fx2.entity:SetParent(inst.entity)
	end	
	inst.AnimState:OverrideSymbol("pb_shad", "purebrilliance", "") 	
end

local function OnHitLand(inst)
	if inst.float_fx ~= nil then
		inst.float_fx:Remove()
		inst.float_fx = nil
	end
	if inst.float_fx2 ~= nil then
		inst.float_fx2:Remove()
		inst.float_fx2 = nil
	end	
	inst.AnimState:OverrideSymbol("pb_shad", "purebrilliance", "pb_shad") 	
end

local function _CreateCore()
    --Vanilla DS does not have SetSymbolLightOverride function on AnimState
	local inst = CreateEntity()

	inst.entity:AddTransform()
	inst.entity:AddAnimState()

	inst:AddTag("FX")
	inst:AddTag("NOCLICK")
	inst:AddTag("NOBLOCK")
	inst:AddTag("INTERIOR_LIMBO_IMMUNE")	

	inst.AnimState:SetBank("purebrilliance")
	inst.AnimState:SetBuild("purebrilliance")
	inst.AnimState:PlayAnimation("idle", true) 
	inst.AnimState:SetBloomEffectHandle("shaders/anim.ksh")
	inst.AnimState:SetLightOverride(0.5)
	inst.AnimState:OverrideSymbol("glow", "purebrilliance", "") 
	inst.AnimState:OverrideSymbol("pb_shad", "purebrilliance", "") 
	inst.AnimState:OverrideSymbol("pb_part", "purebrilliance", "") 	
	
	inst.persists = false

	return inst
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()

    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("purebrilliance")
    inst.AnimState:SetBuild("purebrilliance")
    inst.AnimState:PlayAnimation("idle", true)
    inst.AnimState:SetBloomEffectHandle("shaders/anim.ksh")
	inst.AnimState:SetLightOverride(0.1) 
	inst.AnimState:OverrideSymbol("pb_energy_loop", "purebrilliance", "") 
	inst.AnimState:OverrideSymbol("pb_ray", "purebrilliance", "") 
	inst.AnimState:OverrideSymbol("SparkleBit", "purebrilliance", "") 

    inst:AddComponent("inspectable")
    inst:AddComponent("inventoryitem")

    inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM

	if inst.GetIsOnWater ~= nil then
	    inst:AddComponent("floatable")
 		inst.components.floatable:SetOnHitWaterFn(OnHitWater)
		inst.components.floatable:SetOnHitLandFn(OnHitLand)    
		
		inst.components.inventoryitem:SetOnPutInInventoryFn(OnHitLand)

        inst:AddComponent("appeasement")
        inst.components.appeasement.appeasementvalue = TUNING.APPEASEMENT_SMALL*2
	end
 
    inst.core = _CreateCore()
    inst.core.entity:SetParent(inst.entity)
 
    return inst
end

return Prefab("purebrilliance", fn, assets)
