
local assets =   
{
    Asset("ANIM", "anim/yotc_seedpacket_rare.zip"),
}

local prefabs = 
{

}

local function OnHitWater(inst)
	if inst.float_fx == nil then
		inst.float_fx = SpawnPrefab("float_fx_front")
		inst.float_fx.entity:SetParent(inst.entity)
		inst.float_fx.Transform:SetPosition(0, -0.25, 0)
		inst.float_fx.Transform:SetScale(1.25, 1.25, 1.25)
	end
	if inst.float_fx2 == nil then
		inst.float_fx2 = SpawnPrefab("float_fx_back")
		inst.float_fx2.entity:SetParent(inst.entity)
		inst.float_fx2.Transform:SetPosition(0, -0.25, 0)
		inst.float_fx2.Transform:SetScale(1.25, 1.25, 1.25)
	end	
end

local function OnHitLand(inst)
	if inst.float_fx ~= nil then
		inst.float_fx:Remove()
		inst.float_fx = nil
	end
	if inst.float_fx2 ~= nil then
		inst.float_fx2:Remove()
		inst.float_fx2 = nil
	end	
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()

    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)

    inst.AnimState:SetBank("yotc_seedpacket_rare")
    inst.AnimState:SetBuild("yotc_seedpacket_rare")
    inst.AnimState:PlayAnimation("idle_onesize")

    inst:AddTag("nosteal")

    inst:AddComponent("inspectable")
	
    inst:AddComponent("inventoryitem")

    inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM
	
	if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
	    inst:AddComponent("floatable")
		inst.components.floatable:SetOnHitWaterFn(OnHitWater)
		inst.components.floatable:SetOnHitLandFn(OnHitLand)
        inst:ListenForEvent("onputininventory", OnHitLand)	
	end

    if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
        inst:AddComponent("waterproofer")
        inst.components.waterproofer:SetEffectiveness(0)
    end
	
    return inst
end

return Prefab("seedpacket", fn, assets, prefabs)