local assets =
{
	Asset("ANIM", "anim/shadow_knowledge_classic.zip"),
}

local prefabs =
{

}

local ENG_LORE = 
{
    "Maxwell (né William Carter) was once nothing more than a humble stage magician,\n until the discovery of a mysterious tome changed the course of his life forever.",
	"In the Constant, the darkness has a name.\n Have you met Charlie yet?",
	"Once the King of the Nightmare Throne,\n Maxwell now finds himself surviving alongside the very people he once tormented.\n Needless to say, it makes for a bit of an... awkward atmosphere.",
	"It seems that every time we discover a doorway out of this terrible place,\n it just leads to more strange worlds with new horrors to endure.\n Still, I can't give up hope that one day\n we'll find a doorway that will take us home...",
	"Time moves differently in the Constant.\n Instead of a monotonous forward march, seconds and eternities seem to\n throw caution to the wind and do-si-do backwards\n and forwards as they please.",
	"Nothing here is what it seems.\n If you're reading this, keep an eye on the rabbits,\n don't trust the statues,\n and don't mistake that thing hanging in the night sky for the moon...",
	"Once upon a time,\n a little boy was swallowed up whole by a big hungry spider.\n Now they share everything; a body, a mind, and the name Webber.",
	"Nothing could ever come between Wendy and her twin sister Abigail.\n Some bonds transcend even death.",
	"Wickerbottom is of the firm belief that the pen is mightier than the sword.\n Words hold great power when used correctly.",
	"Nothing brings Willow more comfort than snuggling her faithful teddy bear Bernie,\n and committing a playful bit of arson.",
	"Wilson chose the path of an independent Gentleman Scientist\n after finding the university environment\n to be too stifling for a man of his ambitions.\n (The enormous bill the university sent him to pay for repairs to the chemistry lab had absolutely nothing to do with this.)",
	"Growing up, Winona always looked out for her younger sister.\n Even now, she can't help but feel that one day\n she'll be able to reach out into the darkness\n and pull Charlie back.",
	"Even with all the steps\n Woodie has taken to control his were-curse,\n there's little that can be done on nights\n when the moon is at its fullest.",
}

local CN_LORE =
{
    "麦斯威尔（曾用名威廉·卡特）曾经只是一个卑微的舞台魔术师。\n在发现一本神秘的旧典籍后，他的生活轨迹发生了永久的改变。",
	"永恒领域的黑暗有一个名字。\n你碰到过查理没有？",
	"昨日还坐在噩梦王座上的国王麦斯威尔，\n现如今居然沦落到跟他折磨过的人一起求生。\n不用说，这样的气氛确实有点……尴尬。",
	"似乎我们每发现一扇可能离开这个可怕地方的门，\n进去之后看到的都是更陌生的世界，\n然后经历新的恐怖。\n尽管如此，我仍不愿放弃希望，\n希望有天我们会找到一扇能带我们回家的门……",
	"时间在永恒领域中变得调皮起来：\n不再只是单调前行；\n秒和永恒将所有的小心翼翼都扔到了风里，舞步随心所欲地向前和向后。",
	"这里没有什么是它看起来的那样。\n如果你正在读这些文字，请留意兔子，不要相信雕像，\n也不要误以为那轮挂在夜空的东西是月亮……",
	"很久以前，一个小男孩被一只饥饿的大蜘蛛整个吞掉了。\n现在他们共享一切；身体、大脑，还有韦伯这个名字。",
	"温蒂和她的双胞胎姐妹阿比盖尔亲密无间。\n有些纽带甚至能超越死亡。",
	"薇克巴顿坚信笔比剑更有力量。\n只要使用得当，文字就能发挥巨大的力量。",
	"薇洛在依偎着她忠实的泰迪熊伯尼时会感到快乐，\n哦，对了，还有玩火。",
	"威尔逊在发现大学环境对他这样一个有雄心壮志的人\n来说太过窒息，于是走上了\n独立的绅士科学家之路。\n(与大学寄给他的修理化学实验室的巨额账单绝对无关)。",
	"在成长过程中，薇诺娜尽到了照顾妹妹的义务。\n即使是现在，她也常常感觉到有一天\n她能够伸手到黑暗中把查理拉回来。",
	"即使伍迪想尽办法来控制他的变身诅咒，\n但在月圆之夜，他还是会被其控制。",
}

local function SpawnShadowFX(inst)
    SpawnPrefab("statue_transition").Transform:SetPosition(inst.Transform:GetWorldPosition())
    SpawnPrefab("statue_transition_2").Transform:SetPosition(inst.Transform:GetWorldPosition())
end

local function FuelTaken(inst, taker)
    SpawnShadowFX(taker or inst)
end

--[[
local function canread(inst, reader)
    if reader ~= nil and reader:HasTag("shadow_form_on") then
	    return false, "SHADOWFORM"
	end
    return true
end
]]

local function onread(inst, reader)
    if reader ~= nil and reader.components.talker ~= nil then
 
        if reader:HasTag("shadow_form_on") then
            if TUNING.LANGUAGE == true then
			    reader.components.talker:Say("I have already mastered enough of that knowledge, hehe.")
			elseif TUNING.LANGUAGE == false then
			    reader.components.talker:Say("我已经掌握了足够多的那些知识了，呵呵。")
			end
            return true
        end
 
        if TUNING.LANGUAGE == true then
		    for k,v in pairs(ENG_LORE) do
			    if inst.page == k then
			        reader.components.talker:Say(v, 10)
					break
				end
			end
		elseif TUNING.LANGUAGE == false then
		    for k,v in pairs(CN_LORE) do
			    if inst.page == k then
			        reader.components.talker:Say(v, 10)
					break
				end			
			end		
		end
        inst.page = inst.page + 1
		
		if inst.page > inst.max_page then
		    reader.page_read = nil
		    SpawnShadowFX(reader)
			inst:Remove()
		    return true
		end
		
		local mult = 1
		if reader.page_read ~= nil then
		    mult = math.ceil(reader.page_read / inst.page_per_book)
		end
		
		if math.ceil(inst.page / inst.page_per_book) > mult then
		    reader.page_read = inst.page  --Note: need to save the page in the reader prefab file, its possible number: 11, 21, 31, 41, 51, 61, 71, 81, 91
		    SpawnShadowFX(reader)
			inst:Remove()
			return true
		end
		
		return true
	end
end

local function description(inst, viwer)
    local desc = ""
    if TUNING.LANGUAGE == true then
	    desc = "This book is currently on the page "..inst.page.."."
	    if inst.page >= inst.max_page then
		    desc = desc.." It's already at the end."
		end				
	elseif TUNING.LANGUAGE == false then
		desc = "这本书目前在第"..inst.page.."页。"
	    if inst.page >= inst.max_page then
		    desc = desc.."已经到末尾了。"
		end
	end
	return desc
end

local function OnHitWater(inst)
	if inst.float_fx == nil then
		inst.float_fx = SpawnPrefab("float_fx_front")
		inst.float_fx.entity:SetParent(inst.entity) 
	end
	if inst.float_fx2 == nil then
		inst.float_fx2 = SpawnPrefab("float_fx_back")
		inst.float_fx2.entity:SetParent(inst.entity) 
	end	
end

local function OnHitLand(inst)
	if inst.float_fx ~= nil then
		inst.float_fx:Remove()
		inst.float_fx = nil
	end
	if inst.float_fx2 ~= nil then
		inst.float_fx2:Remove()
		inst.float_fx2 = nil
	end	
end

local function OnSave(inst, data)
    data.page = inst.page
end

local function OnLoad(inst, data)
    if data ~= nil then    
        inst.page = data.page or 1
	end
end

local function fn()
	local inst = CreateEntity()
	
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    
    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("shadow_knowledge_classic")
    inst.AnimState:SetBuild("shadow_knowledge_classic")
    inst.AnimState:PlayAnimation("idle")
    
	inst:AddTag("shadow_knowledge_classic")
	inst:AddTag("shadow_item")
    inst:AddTag("shadow_destroy_immune")
	inst:AddTag("protected")
	
    inst:AddComponent("inventoryitem")
	
	if inst.GetIsOnWater ~= nil then
        MakeInventoryFloatable(inst, "idle_water", "idle")
		inst.components.floatable:SetOnHitWaterFn(OnHitWater)
		inst.components.floatable:SetOnHitLandFn(OnHitLand)
		inst.components.inventoryitem:SetOnPutInInventoryFn(OnHitLand)			
	end
	
	inst.page = 1	
	inst.page_per_book = 10
	inst.max_page = 100  --TO DO: MORE LORE.

    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription(description)
	
    inst:AddComponent("shadowbook")
    inst.components.shadowbook.onread = onread
	--inst.components.shadowbook.onreadtest = canread

    inst:AddComponent("fuel")
    inst.components.fuel.fuelvalue = TUNING.LARGE_FUEL
    inst.components.fuel:SetOnTakenFn(FuelTaken)

    MakeSmallBurnable(inst)
    MakeSmallPropagator(inst)

    inst.OnSave = OnSave
    inst.OnLoad = OnLoad

    return inst
end

return Prefab("shadow_knowledge_classic", fn, assets, prefabs)