local assets = 
{
	Asset("ANIM", "anim/hat_bloodcrown.zip"),
}

local prefabs = 
{

}

local function OnRepaired(inst, doer, repair_item)
	if doer ~= nil and doer.SoundEmitter ~= nil then
	    doer.SoundEmitter:PlaySound("dontstarve/HUD/repair_clothing")
	end
end

local function OnHitWater(inst)
	if inst.float_fx == nil then
		inst.float_fx = SpawnPrefab("float_fx_front")
		inst.float_fx.entity:SetParent(inst.entity)
		inst.float_fx.AnimState:PlayAnimation("idle_front_med", true)		
		inst.float_fx.Transform:SetScale(0.72, 0.72, 0.72)
	end
	if inst.float_fx2 == nil then
		inst.float_fx2 = SpawnPrefab("float_fx_back")
		inst.float_fx2.entity:SetParent(inst.entity)
		inst.float_fx2.AnimState:PlayAnimation("idle_back_med", true)
		inst.float_fx2.Transform:SetScale(0.72, 0.72, 0.72)
	end	
end

local function OnHitLand(inst)
	if inst.float_fx ~= nil then
		inst.float_fx:Remove()
		inst.float_fx = nil
	end
	if inst.float_fx2 ~= nil then
		inst.float_fx2:Remove()
		inst.float_fx2 = nil
	end	
end

local function CalcDapperness(inst, owner)
	return TUNING.DAPPERNESS_HUGE 
end

local function OnEquip(inst, owner)
	owner.AnimState:OverrideSymbol("swap_hat", "hat_bloodcrown", "swap_hat")

	owner.AnimState:Show("HAT")
	owner.AnimState:Hide("HAIR_HAT")
	owner.AnimState:Show("HAIR_NOHAT")
	owner.AnimState:Show("HAIR")
	owner.AnimState:Show("HAIRFRONT")

	if owner.components.transformable ~= nil then
        owner.components.transformable:IgnoreSanityToSetUpShadowForm()
	end
	
	if inst.fx ~= nil then
	    inst.fx:Remove()
	end
	inst.fx = SpawnPrefab("forcefieldfx")
	inst.fx.entity:SetParent(owner.entity)
	inst.fx.Transform:SetPosition(0, 0.2, 0)
	local fx_hitanim = function()
	    if inst ~= nil and inst.fx ~= nil and inst.fx.AnimState ~= nil then
		    inst.fx.AnimState:PlayAnimation("hit")
		    inst.fx.AnimState:PushAnimation("idle_loop")
		end
	end	
	inst.fx:ListenForEvent("blocked", fx_hitanim, owner)
    inst.fx:AddTag("INTERIOR_LIMBO_IMMUNE")	
end

local function OnUnequip(inst, owner)
	owner.AnimState:Hide("HAT")
	owner.AnimState:Hide("HAIR_HAT")
	owner.AnimState:Show("HAIR_NOHAT")
	owner.AnimState:Show("HAIR")

	if owner:HasTag("player") then
		owner.AnimState:Show("HEAD")
		owner.AnimState:Hide("HEAD_HAIR")
		owner.AnimState:Show("HAIRFRONT")
	end
	
	if inst.fx ~= nil then	
	    if inst.fx.kill_fx ~= nil then
		    inst.fx:kill_fx()
		else
		    inst.fx:Remove()
		end
		inst.fx = nil		
	end
end

local function fn()
	local inst = CreateEntity()
	
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()

	MakeInventoryPhysics(inst)

	inst.AnimState:SetBank("hat_bloodcrown")
	inst.AnimState:SetBuild("hat_bloodcrown")
	inst.AnimState:PlayAnimation("anim")	
	
	inst.Transform:SetScale(1.5, 1.5, 1.5)
	
	inst.opentop = true

    inst:AddTag("hat")
	inst:AddTag("metal")
	inst:AddTag("shadow_item")
	inst:AddTag("super_shadow_item")

	inst:AddComponent("inspectable")

	inst:AddComponent("inventoryitem")

	inst:AddComponent("armor")
	inst.components.armor:InitCondition(3000, 1)  

	inst:AddComponent("equippable")
	inst.components.equippable.equipslot = EQUIPSLOTS.HEAD
	inst.components.equippable:SetOnEquip(OnEquip)
	inst.components.equippable:SetOnUnequip(OnUnequip)
	
	inst:AddComponent("tradable")
	
    if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
        inst.components.equippable.dapperfn = CalcDapperness 
		
		inst:AddComponent("waterproofer")
		inst.components.waterproofer:SetEffectiveness(1)
	else
	    inst:AddComponent("dapperness")
        inst.components.dapperness.dapperfn = CalcDapperness  
		inst.components.dapperness.mitigates_rain = true
	end		
	
	if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
	    MakeInventoryFloatable(inst, "idle_water", "anim")
		inst.components.floatable:SetOnHitWaterFn(OnHitWater)
		inst.components.floatable:SetOnHitLandFn(OnHitLand)
		inst.components.inventoryitem:SetOnPutInInventoryFn(OnHitLand)		
	end	

    inst:AddComponent("shadowrepairable")
	inst.components.shadowrepairable:SetRepairMaterial("voidcloth")
	inst.components.shadowrepairable:SetOnRepaired(OnRepaired)
	
	return inst
end

return Prefab("shadow_ruins_crown", fn, assets, prefabs)