--WARNING: huge anim problems.

local hat_voidcloth_assets =
{
	Asset("ANIM", "anim/hat_voidcloth.zip"),
}

local hat_voidcloth_prefabs = 
{

}

local armor_voidcloth_assets = 
{
	Asset("ANIM", "anim/armor_voidcloth.zip"),
}

local armor_voidcloth_prefabs = 
{

}

local scythe_voidcloth_assets =
{
	Asset("ANIM", "anim/scythe_voidcloth.zip"),
}

local scythe_voidcloth_prefabs = 
{

}

local umbrella_voidcloth_assets = 
{
	Asset("ANIM", "anim/umbrella_voidcloth.zip"),
}

local umbrella_voidcloth_prefabs = 
{

}

local function OnRepaired(inst, doer, repair_item)
	if doer ~= nil and doer.SoundEmitter ~= nil then
	    doer.SoundEmitter:PlaySound("dontstarve/HUD/repair_clothing")
	end
end

local function OnHitWater(inst)
	if inst.float_fx == nil then
		inst.float_fx = SpawnPrefab("float_fx_front")
		inst.float_fx.entity:SetParent(inst.entity)
		inst.float_fx.AnimState:PlayAnimation("idle_front_med", true)		
		inst.float_fx.Transform:SetScale(0.72, 0.72, 0.72)
	end
	if inst.float_fx2 == nil then
		inst.float_fx2 = SpawnPrefab("float_fx_back")
		inst.float_fx2.entity:SetParent(inst.entity)
		inst.float_fx2.AnimState:PlayAnimation("idle_back_med", true)
		inst.float_fx2.Transform:SetScale(0.72, 0.72, 0.72)
	end	
end

local function OnHitLand(inst)
	if inst.float_fx ~= nil then
		inst.float_fx:Remove()
		inst.float_fx = nil
	end
	if inst.float_fx2 ~= nil then
		inst.float_fx2:Remove()
		inst.float_fx2 = nil
	end	
end

local function voidcloth_getsetbonusequip(inst, owner)
	local body = owner.components.inventory ~= nil and owner.components.inventory:GetEquippedItem(EQUIPSLOTS.BODY) or nil
	return body ~= nil and body.prefab == "armor_voidcloth" and body or nil
end

local function voidcloth_calcdapperness(inst, owner)
    if owner:HasTag("charlie") then
        return 0
    end
	local other = voidcloth_getsetbonusequip(inst, owner)
	if other ~= nil then
		return TUNING.CRAZINESS_SMALL * 0.5
	end
	return TUNING.CRAZINESS_SMALL
end

local function onequiphat(inst, owner)
	owner.AnimState:OverrideSymbol("swap_hat", "hat_voidcloth", "swap_hat")
	owner.AnimState:Show("HAT")	
	owner.AnimState:Show("HAIR_HAT")
	owner.AnimState:Hide("HAIR_NOHAT")
	owner.AnimState:Hide("HAIR")
	if owner:HasTag("player") then
		owner.AnimState:Hide("HEAD")
		owner.AnimState:Show("HEAD_HAIR")
		owner.AnimState:Hide("HAIRFRONT")
	end	
	if inst.fx ~= nil then
		inst.fx:Remove()
	end
	inst.fx = SpawnPrefab("voidclothhat_fx")
	inst.fx:SpawnFollowFxForOwner(owner)	
	
end

local function onunequiphat(inst, owner)
	owner.AnimState:Hide("HAT")
	owner.AnimState:Hide("HAIR_HAT")
	owner.AnimState:Show("HAIR_NOHAT")
	owner.AnimState:Show("HAIR")
	if owner:HasTag("player") then
		owner.AnimState:Show("HEAD")
		owner.AnimState:Hide("HEAD_HAIR")
		owner.AnimState:Show("HAIRFRONT")
	end	
	if inst.fx ~= nil then
		inst.fx:Remove()
		inst.fx = nil
	end	
end

local function voidclothhat_fn()
	local inst = CreateEntity()

	inst.entity:AddTransform()
	inst.entity:AddAnimState()

	MakeInventoryPhysics(inst)

	inst.AnimState:SetBank("voidclothhat")
	inst.AnimState:SetBuild("hat_voidcloth")
	inst.AnimState:PlayAnimation("anim")

    inst:AddTag("hat")
	inst:AddTag("shadow_item")
	inst:AddTag("cloth")

	inst:AddComponent("inspectable")

	inst:AddComponent("inventoryitem")

	inst:AddComponent("armor")
	inst.components.armor:InitCondition(1100, 0.8)
	
	inst:AddComponent("tradable")

	inst:AddComponent("equippable")
	inst.components.equippable.equipslot = EQUIPSLOTS.HEAD
	inst.components.equippable:SetOnEquip(onequiphat)
	inst.components.equippable:SetOnUnequip(onunequiphat)
	
    if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
        inst.components.equippable.dapperfn = voidcloth_calcdapperness
        inst:AddComponent("waterproofer")
        inst.components.waterproofer:SetEffectiveness(1)
	else
	    inst:AddComponent("dapperness")
        inst.components.dapperness.dapperfn = voidcloth_calcdapperness
		inst.components.dapperness.mitigates_rain = true	
	end	

	if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
	    inst:AddComponent("floatable")
		inst.components.floatable:SetOnHitWaterFn(OnHitWater)
		inst.components.floatable:SetOnHitLandFn(OnHitLand)
		inst.components.inventoryitem:SetOnPutInInventoryFn(OnHitLand)		
	end

    inst:AddComponent("shadowrepairable")
	inst.components.shadowrepairable:SetRepairMaterial("voidcloth")
	inst.components.shadowrepairable:SetOnRepaired(OnRepaired)

	return inst
end

local function GetSetBonusEquip(inst, owner)
	local hat = owner.components.inventory ~= nil and owner.components.inventory:GetEquippedItem(EQUIPSLOTS.HEAD) or nil
	return hat ~= nil and hat.prefab == "voidclothhat" and hat or nil
end

local function CalcDapperness(inst, owner)
    if owner:HasTag("charlie") then
        return 0
    end
	local other = GetSetBonusEquip(inst, owner)
	if other ~= nil then
		return TUNING.CRAZINESS_SMALL * 0.5
	end
	return TUNING.CRAZINESS_SMALL
end

local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_body", "armor_voidcloth", "swap_body")
	if inst.fx ~= nil then
        inst.fx:Remove()
    end
    inst.fx = SpawnPrefab("armor_voidcloth_fx")
    inst.fx:AttachToOwner(owner)
end

local function onunequip(inst, owner)
    owner.AnimState:ClearOverrideSymbol("swap_body")
    if inst.fx ~= nil then
        inst.fx:Remove()
        inst.fx = nil
    end
end

local function armor_voidcloth_fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()

    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("armor_voidcloth")
    inst.AnimState:SetBuild("armor_voidcloth")
    inst.AnimState:PlayAnimation("anim")
	
	inst:AddTag("shadow_item")
	inst:AddTag("cloth")
	
    inst:AddComponent("inspectable")
	
    inst:AddComponent("inventoryitem")	

	inst:AddComponent("armor")
	inst.components.armor:InitCondition(1100, 0.8)

	inst:AddComponent("equippable")
	inst.components.equippable.equipslot = EQUIPSLOTS.BODY
	inst.components.equippable:SetOnEquip(onequip)
	inst.components.equippable:SetOnUnequip(onunequip)
	
    if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
        inst.components.equippable.dapperfn = CalcDapperness
        inst:AddComponent("waterproofer")
        inst.components.waterproofer:SetEffectiveness(1)
	else
	    inst:AddComponent("dapperness")
        inst.components.dapperness.dapperfn = CalcDapperness
		inst.components.dapperness.mitigates_rain = true	
	end	

	if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
	    inst:AddComponent("floatable")
		inst.components.floatable:SetOnHitWaterFn(OnHitWater)
		inst.components.floatable:SetOnHitLandFn(OnHitLand)
		inst.components.inventoryitem:SetOnPutInInventoryFn(OnHitLand)		
	end

    inst:AddComponent("shadowrepairable")
	inst.components.shadowrepairable:SetRepairMaterial("voidcloth")
	inst.components.shadowrepairable:SetOnRepaired(OnRepaired)

    return inst	
end

local function SayRandomLine(inst, str_list, owner)
    if owner ~= nil --[[and owner:HasTag("player_shadow_aligned")]] then
	    if str_list ~= nil then
            inst.components.talker:Say(str_list[math.random(#str_list)])
        end
        if inst.talktask ~= nil then
            inst.talktask:Cancel()
            inst.talktask = nil
        end
        --local iswoodie = owner ~= nil and owner.prefab == "woodie"
        --local str_list = iswoodie and math.random() > 0.7 and STRINGS.VOIDCLOTH_SCYTHE_TALK.lucy or STRINGS.VOIDCLOTH_SCYTHE_TALK.overtime
        local str_list = STRINGS.VOIDCLOTH_SCYTHE_TALK.overtime

        inst.talktask = inst:DoTaskInTime(30, inst.SayRandomLine, str_list, owner)
    end
end

local function ToggleTalking(inst, turnon, owner)
    if inst.talktask ~= nil then
        inst.talktask:Cancel()
        inst.talktask = nil
    end

    if turnon and owner--[[and owner:HasTag("player_shadow_aligned")]] then   
        inst.talktask = inst:DoTaskInTime(3, inst.SayRandomLine, STRINGS.VOIDCLOTH_SCYTHE_TALK.overtime, owner)
    end
end

local function SetFxOwnerReaper(inst, owner)
	if owner ~= nil then
		--inst.fx.entity:SetParent(owner.entity)
		inst.fx.Follower:FollowSymbol(owner.GUID, "swap_object", 0, 0, 0, true, nil, 2)
		--inst.fx.components.highlightchild:SetOwner(owner)
		inst.fx:ToggleEquipped(true)
	else
		--inst.fx.entity:SetParent(inst.entity)
		--For floating
		--inst.fx.Follower:FollowSymbol(inst.GUID, "swap_object", nil, nil, nil, true, nil, 2)
		--inst.fx.components.highlightchild:SetOwner(inst)
		inst.fx:ToggleEquipped(false)
	end
end

local function onequip_reaper(inst, owner)
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
	owner.AnimState:OverrideSymbol("swap_object", "scythe_voidcloth", "swap_scythe")
	SetFxOwnerReaper(inst, owner)
	inst:ToggleTalking(true, owner)
end

local function onunequip_reaper(inst, owner)
    owner.AnimState:Hide("ARM_carry")
    owner.AnimState:Show("ARM_normal")
	SetFxOwnerReaper(inst, nil)
	inst:ToggleTalking(false, owner)
end

local function ReaperCalcDapperness(inst, owner)
    if owner:HasTag("charlie") then
        return 0
    end
	return -TUNING.DAPPERNESS_MED
end

local function ReaperOnAttack(inst, attacker, target)
	if target ~= nil 
	    and target:IsValid() 
	    and target.components.health ~= nil
	then
	    local real_damage = 18
		local other_hat = GetSetBonusEquip(inst, attacker)
		local other_armor = voidcloth_getsetbonusequip(inst, attacker)
		if other_hat ~= nil or other_armor ~= nil then
		    real_damage = 27
		end
		if other_hat ~= nil and other_armor ~= nil then
		    real_damage = 36
		end		
        target.components.health:SetVal(target.components.health.currenthealth - real_damage, inst.prefab)
	end
end

local function LaunchItem(inst, launcher, basespeed)
    if inst ~= nil and inst.Physics ~= nil and inst.Physics:IsActive() and launcher ~= nil then
        local x, y, z = inst.Transform:GetWorldPosition()
        local x1, y1, z1 = launcher.Transform:GetWorldPosition()
        local vx, vz = x - x1, z - z1
        local spd = math.sqrt(vx * vx + vz * vz)
        local angle =
            spd > 0 and
            math.atan2(vz / spd, vx / spd) + (math.random() * 20 - 10) * DEGREES or
            math.random() * math.pi * 2
        spd = (basespeed or 5) + math.random() * 2
        inst.Physics:Teleport(x, .1, z)
        inst.Physics:SetVel(math.cos(angle) * spd, 10, math.sin(angle) * spd)
        if inst.components.inventoryitem and inst.components.inventoryitem.OnStartFalling then
            inst.components.inventoryitem:OnStartFalling()
        end			
    end
end

local function HarvestPickable(inst, ent, doer)
    if ent.components.pickable.picksound ~= nil then
        doer.SoundEmitter:PlaySound(ent.components.pickable.picksound)
    end

    local world = GetWorld()
    ent.components.pickable:Pick(world)  --set the picker to world so it will not put items into player inventory
	
	local x1, y1, z1 = ent.Transform:GetWorldPosition()
	
	local num = ent.components.pickable.numtoharvest or 1
    local product = ent.components.pickable.product

    if product ~= nil then
        for i = 1, num do
            local loot = SpawnPrefab(product)
            loot.Transform:SetPosition(x1, 0, z1)
			if ent.ApplyInheritedMoisture ~= nil then 
				ent:ApplyInheritedMoisture(loot)
			end
            LaunchItem(loot, doer, 1.5)
        end	
    end
end

local function HarvestHackable(inst, ent, doer)

    local world = GetWorld()
	local numworks = ent.components.hackable.hacksleft
    ent.components.hackable:Hack(world, numworks)
	
end

local HARVEST_CANTTAGS = {"INLIMBO", "FX", "flower", "flower_rainforest", "seashell", "ancient_fountain_of_knowledge", "tubertree", "cannot_be_reaped"}
local function DoScythe(inst, target, doer)
    inst:SayRandomLine(STRINGS.VOIDCLOTH_SCYTHE_TALK.onharvest, doer)
    if target.components.pickable ~= nil or target.components.hackable ~= nil then
        local doer_pos = doer:GetPosition()
        local x, y, z = doer_pos:Get()
        local ents = TheSim:FindEntities(x, y, z, 4, nil, HARVEST_CANTTAGS)
        for _, ent in pairs(ents) do
		    if ent ~= nil and ent.prefab ~= nil and ent.prefab ~= "limpetrock" then
                if ent:IsValid() and ent.components.pickable ~= nil and ent.components.pickable.canbepicked then
                    inst:HarvestPickable(ent, doer)
			    elseif ent:IsValid() and ent.components.hackable ~= nil and ent.components.hackable.canbehacked then
			        inst:HarvestHackable(ent, doer)
                end
			end
        end
    end
	if inst.components.finiteuses ~= nil then
	    inst.components.finiteuses:Use()
	end		
end

local function RemoveReaperFX(inst)
    if inst.fx ~= nil then
        inst.fx:Remove()
    end
end

local function voidcloth_scythe_fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()

    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("scythe_voidcloth")
    inst.AnimState:SetBuild("scythe_voidcloth")
    inst.AnimState:PlayAnimation("idle", true)

    inst:AddTag("sharp")
	inst:AddTag("shadow_item")

	local frame = math.random() * inst.AnimState:GetCurrentAnimationLength()
	inst.AnimState:SetTime(frame)
	inst.fx = SpawnPrefab("voidcloth_scythe_fx")
	inst.fx.AnimState:SetTime(frame)
	SetFxOwnerReaper(inst, nil)

    inst:AddComponent("inspectable")
	
    inst:AddComponent("inventoryitem")	

    inst:AddComponent("talker")
    inst.components.talker.fontsize = 28
    inst.components.talker.colour = Vector3(143/255, 41/255, 41/255)
    inst.components.talker.offset = Vector3(0, 0, 0)
    inst.components.talker.symbol = "swap_object"

    inst:AddComponent("shadowreaper")

    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(200)
    inst.components.finiteuses:SetUses(200)
    inst.components.finiteuses:SetOnFinished(inst.Remove)

    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(38)
	inst.components.weapon:SetOnAttack(ReaperOnAttack)

	inst:AddComponent("equippable")
	inst.components.equippable:SetOnEquip(onequip_reaper)
	inst.components.equippable:SetOnUnequip(onunequip_reaper)
	
    if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
        inst.components.equippable.dapperfn = ReaperCalcDapperness
	else
	    inst:AddComponent("dapperness")
        inst.components.dapperness.dapperfn = ReaperCalcDapperness
	end	

	if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
	    inst:AddComponent("floatable")
		inst.components.floatable:SetOnHitWaterFn(OnHitWater)
		inst.components.floatable:SetOnHitLandFn(OnHitLand)
		inst.components.inventoryitem:SetOnPutInInventoryFn(OnHitLand)	

        inst:ListenForEvent("startrowing", function(inst, data) SetFxOwnerReaper(inst, nil) end, inst)  
        inst:ListenForEvent("stoprowing", function(inst, data) SetFxOwnerReaper(inst, GetPlayer()) end, inst)		
		
	end

    inst:AddComponent("shadowrepairable")
	inst.components.shadowrepairable:SetRepairMaterial("voidcloth")
	inst.components.shadowrepairable:SetOnRepaired(OnRepaired)

    inst.DoScythe = DoScythe
	inst.SayRandomLine = SayRandomLine
	inst.ToggleTalking = ToggleTalking
    inst.HarvestPickable = HarvestPickable
	inst.HarvestHackable = HarvestHackable
	inst.OnRemoveEntity = RemoveReaperFX

    return inst	
end

local function UmbrellaCalcDapperness(inst, owner)
    if owner:HasTag("charlie") then
        return 0
    end
	return -TUNING.DAPPERNESS_MED
end

local function OnEquipUmbrella(inst, owner)
	owner.AnimState:OverrideSymbol("swap_object", "umbrella_voidcloth", "swap_umbrella")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")

    owner.DynamicShadow:SetSize(2.2, 1.4)

	if inst._fx ~= nil then
		inst._fx:Remove()
	end
    inst._fx = SpawnPrefab("voidcloth_umbrella_fx")
	inst._fx:AttachToOwner(owner)

    inst.components.fueled:StartConsuming()
end

local function OnUnequipUmbrella(inst, owner)
    owner.AnimState:Hide("ARM_carry")
    owner.AnimState:Show("ARM_normal")

    owner.DynamicShadow:SetSize(1.3, 0.6)

    if inst._fx ~= nil then
        inst._fx:Remove()
        inst._fx = nil
    end

    inst.components.fueled:StopConsuming()
end

local function OnEquipToModelUmbrella(inst, owner, from_ground)
    if inst.components.fueled ~= nil then
        inst.components.fueled:StopConsuming()
    end
end

local function OnPerish(inst)
    local equippable = inst.components.equippable
    if equippable ~= nil and equippable:IsEquipped() then
        local owner = inst.components.inventoryitem ~= nil and inst.components.inventoryitem.owner or nil
        if owner ~= nil then
            local data =
            {
                prefab = inst.prefab,
                equipslot = equippable.equipslot,
            }
            inst:Remove()
            owner:PushEvent("umbrellaranout", data)
            return
        end
    end
    inst:Remove()
end

local function voidcloth_umbrella_fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()    

    MakeInventoryPhysics(inst)

	inst.AnimState:SetBank("umbrella_voidcloth")
    inst.AnimState:SetBuild("umbrella_voidcloth")
    inst.AnimState:PlayAnimation("idle")

    inst:AddTag("umbrella")
	inst:AddTag("shadow_item")
	inst:AddTag("no_sewing")

    inst.Transform:SetScale(1.3, 1.3, 1.3)

    --inst:AddComponent("tradable")
    inst:AddComponent("inspectable")
    inst:AddComponent("inventoryitem")
    inst:AddComponent("equippable")
	
    if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
        inst:AddComponent("waterproofer")
        inst.components.waterproofer:SetEffectiveness(TUNING.WATERPROOFNESS_ABSOLUTE)
	
        inst:AddComponent("insulator")
        inst.components.insulator:SetSummer()
        inst.components.insulator:SetInsulation(TUNING.INSULATION_LARGE)
		
		inst.components.equippable.dapperfn = UmbrellaCalcDapperness
    else
 	    inst:AddComponent("dapperness")
        inst.components.dapperness.dapperfn = UmbrellaCalcDapperness
		inst.components.dapperness.mitigates_rain = true
    end
	
    inst:AddComponent("fueled")
    inst.components.fueled.fueltype = "USAGE"
    inst.components.fueled:SetDepletedFn(OnPerish)
    inst.components.fueled:InitializeFuelLevel(TUNING.TOTAL_DAY_TIME*15)
    inst.components.fueled:SetUpdateFn(function()
        if inst.components.equippable ~= nil 
		    and inst.components.equippable:IsEquipped()
			and GetSeasonManager() 
			and GetSeasonManager():IsRaining()
		then
            inst.components.fueled.rate = -1
		else
		    inst.components.fueled.rate = 1
		end
    end)

    inst.components.equippable:SetOnEquip(OnEquipUmbrella)
    inst.components.equippable:SetOnUnequip(OnUnequipUmbrella)
	
    if inst.components.equippable.SetOnEquipToModel ~= nil then
	    inst.components.equippable:SetOnEquipToModel(OnEquipToModelUmbrella)
    end
	
    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(34)

	if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
	    inst:AddComponent("floatable")
		inst.components.floatable:SetOnHitWaterFn(OnHitWater)
		inst.components.floatable:SetOnHitLandFn(OnHitLand)
		inst.components.inventoryitem:SetOnPutInInventoryFn(OnHitLand)		

        inst:ListenForEvent("startrowing", function(inst, data)
            if inst._fx ~= nil then
                inst._fx:Remove()
                inst._fx = nil
            end
		end, inst)  
        inst:ListenForEvent("stoprowing", function(inst, data) 
		    if inst._fx ~= nil then
		        inst._fx:Remove()
	        end
            inst._fx = SpawnPrefab("voidcloth_umbrella_fx")
	        inst._fx:AttachToOwner(GetPlayer())
		end, inst)

	end

    inst:AddComponent("shadowrepairable")
	inst.components.shadowrepairable:SetRepairMaterial("voidcloth")
	inst.components.shadowrepairable:SetOnRepaired(OnRepaired)
	
    return inst
end


---------------------------------------------------------------------
--[[ Sadly the vanilla DS does not have new parameters for Follower:FollowSymbol
local FX_DEFS =
{
	{ anim = "swap_loop_1", frame_begin = 0, frame_end = 2 },
	--{ anim = "swap_loop_3", frame_begin = 2 },
	{ anim = "swap_loop_6", frame_begin = 5 },
	{ anim = "swap_loop_7", frame_begin = 6 },
	{ anim = "swap_loop_8", frame_begin = 7 },
}
]]

local FX_DEFS =
{
	{ anim = "swap_loop_1", frame_begin = 0, frame_end = 2 }, --swap_loop_1
}

local function CreateFxFollowFrame()
	local inst = CreateEntity()

	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddFollower()

	inst:AddTag("FX")
	inst:AddTag("NOCLICK")
    inst:AddTag("NOBLOCK")
	inst:AddTag("INTERIOR_LIMBO_IMMUNE")
	
	inst.AnimState:SetBank("scythe_voidcloth")
	inst.AnimState:SetBuild("scythe_voidcloth")
	
	inst.Transform:SetFourFaced() 
	
	inst.persists = false

	return inst
end

local function FxRemoveAll(inst)
	for i = 1, #inst.fx do
		inst.fx[i]:Remove()
		inst.fx[i] = nil
	end
end

local function FxOnEquipToggle(inst)
	local owner = inst.equiptoggle and GetPlayer() or nil
	if owner ~= nil then
		if inst.fx == nil then
			inst.fx = {}
		end
		local frame = inst.AnimState:GetCurrentAnimationLength()
		for i, v in ipairs(FX_DEFS) do
			local fx = inst.fx[i]
			if fx == nil then
				fx = CreateFxFollowFrame()
				fx.AnimState:PlayAnimation(v.anim, true)
				inst.fx[i] = fx
			end
			--fx.entity:SetParent(owner.entity)
			fx.Follower:FollowSymbol(owner.GUID, "swap_object", 0, 0, 0, true, nil, v.frame_begin, v.frame_end)
			--fx.AnimState:SetFrame(frame)
			fx.AnimState:SetTime(frame)
			
			fx:AddComponent("flippedupdater")  
			
			--fx.components.highlightchild:SetOwner(owner)
		end
		inst.OnRemoveEntity = FxRemoveAll
	elseif inst.OnRemoveEntity ~= nil then
		inst.OnRemoveEntity = nil
		FxRemoveAll(inst)
	end
end

local function FxToggleEquipped(inst, equipped)
	if equipped then
		inst.equiptoggle = true
		FxOnEquipToggle(inst)
		--inst:Show()
	    inst:Hide()
	else
	    inst.equiptoggle = false
		FxOnEquipToggle(inst)
	    inst:Hide()
	end
end

local function FollowSymbolScytheFxFn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddFollower()

    inst:AddTag("FX")
	inst:AddTag("NOCLICK")
    inst:AddTag("NOBLOCK")
	inst:AddTag("INTERIOR_LIMBO_IMMUNE")
	
	inst.equiptoggle = false
 
    inst.AnimState:SetBank("scythe_voidcloth")
    inst.AnimState:SetBuild("scythe_voidcloth")
    inst.AnimState:PlayAnimation("swap_loop_3", true) --frame 3 is used for floating

	inst.ToggleEquipped = FxToggleEquipped
	
    inst.persists = false

    return inst
end

local function FxAttachToOwner(inst, owner)
	--inst.entity:SetParent(owner.entity)
	inst.Follower:FollowSymbol(owner.GUID, "swap_object", 0, 0, 0, true, nil, 0, 2)
	--inst.components.highlightchild:SetOwner(owner)
end

local function FollowSymbolFxFn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddFollower()

    inst:AddTag("FX")
	inst:AddTag("NOCLICK")
    inst:AddTag("NOBLOCK")
	inst:AddTag("INTERIOR_LIMBO_IMMUNE")
	
	inst.AnimState:SetBank("umbrella_voidcloth")
    inst.AnimState:SetBuild("umbrella_voidcloth")
    inst.AnimState:PlayAnimation("swap_loop1", true)

	inst.AttachToOwner = FxAttachToOwner
    inst.persists = false

    return inst
end

local function voidclothhat_CreateFxFollowFrame(i)
	local inst = CreateEntity()

	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddFollower()

	inst:AddTag("FX")
	inst:AddTag("NOCLICK")
    inst:AddTag("NOBLOCK")
	inst:AddTag("INTERIOR_LIMBO_IMMUNE")
	
	inst.AnimState:SetBank("voidclothhat")
	inst.AnimState:SetBuild("hat_voidcloth")
	inst.anim = "idle3"
	inst.AnimState:PlayAnimation(inst.anim, true)
	inst.AnimState:SetSortOrder(1)

	inst.persists = false

	return inst
end

local function FollowFx_OnRemoveEntity(inst)
	for i, v in ipairs(inst.fx) do
		v:Remove()
	end
end

local function SpawnFollowFxForOwner(inst, owner, framebegin, frameend)
	inst.fx = {}
	local frame
	local framebegin = 1
	local frameend = 1  --3  Sadly the vanilla DS does not have new parameters for Follower:FollowSymbol
	for i = framebegin, frameend do
		local fx = voidclothhat_CreateFxFollowFrame(i)
		frame = frame or math.random() * inst.AnimState:GetCurrentAnimationLength()
	    --fx.entity:SetParent(owner.entity)
		fx.Follower:FollowSymbol(owner.GUID, "swap_hat", 0, 0, 0, true, nil, i - 1)
		--fx.AnimState:SetFrame(frame)
		fx.AnimState:SetTime(frame)
		--fx.components.highlightchild:SetOwner(owner)
		table.insert(inst.fx, fx)
	end
	inst.OnRemoveEntity = FollowFx_OnRemoveEntity
end

local function fx_fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddFollower()

    inst:AddTag("FX")
	inst:AddTag("NOCLICK")
    inst:AddTag("NOBLOCK")
	inst:AddTag("INTERIOR_LIMBO_IMMUNE")

	inst.SpawnFollowFxForOwner = SpawnFollowFxForOwner
    inst.persists = false

    return inst
end

local function CreateFxFollowFrameArmor(i)
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddFollower()

    inst:AddTag("FX")
	inst:AddTag("NOCLICK")
    inst:AddTag("NOBLOCK")
	inst:AddTag("INTERIOR_LIMBO_IMMUNE")
	
    inst.AnimState:SetBank("armor_voidcloth")
    inst.AnimState:SetBuild("armor_voidcloth")
    inst.AnimState:PlayAnimation("settle"..tostring(i))
    inst.AnimState:PushAnimation("idle"..tostring(i), false)
	inst.AnimState:SetSortOrder(1)

    inst.persists = false

    return inst
end

local function fx_OnRemoveEntity(inst)
    for i, v in ipairs(inst.fx) do
        v:Remove()
    end
end

local function fx_OnUpdate(inst)
    for i, v in ipairs(inst.fx) do
        v.AnimState:PlayAnimation("settle"..tostring(i))
        v.AnimState:PushAnimation("idle"..tostring(i), false)
    end
end

local function fx_SpawnFxForOwner(inst, owner)
    inst.owner = owner
    --inst.wasmoving = false
    inst.fx = {}
    --local frame
    for i = 1, 1 do  --9  Sadly the vanilla DS does not have new parameters for Follower:FollowSymbol
        local fx = CreateFxFollowFrameArmor(i)
        --fx.entity:SetParent(owner.entity)
        fx.Follower:FollowSymbol(owner.GUID, "swap_body", 0, 20, 0, true, nil, i - 1)
        --fx.components.highlightchild:SetOwner(owner)
        table.insert(inst.fx, fx)
    end
    --[[if owner:HasTag("locomotor") then
        inst:AddComponent("updatelooper")
        inst.components.updatelooper:AddOnUpdateFn(fx_OnUpdate)
    end]]
    inst:ListenForEvent("locomote", function() 
        local player = GetPlayer()
        if player and player.sg and player.sg:HasStateTag("moving") then
            fx_OnUpdate(inst)
        end
    end, GetPlayer())
    inst.OnRemoveEntity = fx_OnRemoveEntity
end

local function fxfn()
    local inst = CreateEntity()

    inst.entity:AddTransform()

    inst:AddTag("FX")
	inst:AddTag("NOCLICK")
    inst:AddTag("NOBLOCK")
	inst:AddTag("INTERIOR_LIMBO_IMMUNE")

    inst.AttachToOwner = fx_SpawnFxForOwner
    inst.persists = false

    return inst
end

return Prefab("voidclothhat", voidclothhat_fn, hat_voidcloth_assets, hat_voidcloth_prefabs),
    Prefab("armor_voidcloth", armor_voidcloth_fn, armor_voidcloth_assets, armor_voidcloth_prefabs),
	Prefab("voidcloth_scythe", voidcloth_scythe_fn, scythe_voidcloth_assets, scythe_voidcloth_prefabs),
	Prefab("voidcloth_umbrella", voidcloth_umbrella_fn, umbrella_voidcloth_assets, umbrella_voidcloth_prefabs),
	
	Prefab("voidcloth_scythe_fx", FollowSymbolScytheFxFn, scythe_voidcloth_assets),
	Prefab("voidcloth_umbrella_fx", FollowSymbolFxFn, umbrella_voidcloth_assets),
	Prefab("voidclothhat_fx", fx_fn, hat_voidcloth_assets),
	Prefab("armor_voidcloth_fx", fxfn, armor_voidcloth_assets)