require("prefabutil")

local assets = 
{
	Asset("ANIM", "anim/statue_small.zip"),
	Asset("ANIM", "anim/statue_small_harp_build.zip"),
	Asset("ANIM", "anim/statue_small_harp_vine_build.zip"),
	Asset("MINIMAP_IMAGE", "statue_small"),
}

local prefabs =
{
	"marble",
	"rose_inv",
	"small_puff",
}
--[[
SetSharedLootTable( 'statue_harp',
{
    {'marble',  1.0},
    {'marble',  1.0},
    {'marble',	0.3},
})
]]
local function OnWorked(inst, worker, workleft)
    local pt = Point(inst.Transform:GetWorldPosition())
    if workleft <= 0 then
		inst.SoundEmitter:PlaySound("dontstarve/wilson/rock_break")
	    inst.components.lootdropper:DropLoot(pt)
	    inst:Remove()
	else	            
	    if workleft < TUNING.MARBLEPILLAR_MINE*(1/3) then
	        inst.AnimState:PlayAnimation("low")
	    elseif workleft < TUNING.MARBLEPILLAR_MINE*(2/3) then
	        inst.AnimState:PlayAnimation("med")
	    else
	        inst.AnimState:PlayAnimation("full")
	    end
	end
end

local function OnWorkLoad(inst)
    OnWorked(inst, nil, inst.components.workable.workleft)
end

local function onpickedfn(inst, picker)
    inst.AnimState:ClearOverrideBuild("statue_small_harp_vine_build")
end

local function onregenfn(inst)
    inst.AnimState:AddOverrideBuild("statue_small_harp_vine_build")
end

local function OnLoad(inst, data)
    if inst.components.pickable ~= nil and inst.components.pickable.hasbeenpicked then
	    inst.AnimState:ClearOverrideBuild("statue_small_harp_vine_build")
	end
end

local function OnRemoveEntity(inst)
    if inst.components.pickable ~= nil and inst.components.pickable.canbepicked then
	    inst.components.lootdropper:SpawnLootPrefab("rose_inv")
	end
end

local function fn()
	local inst = CreateEntity()
	
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	inst.entity:AddMiniMapEntity()
	
	MakeObstaclePhysics(inst, 0.66)

	inst:AddComponent("lootdropper")
	--inst.components.lootdropper:SetChanceLootTable('statue_harp')

	inst.AnimState:SetBank("statue_small")
	inst.AnimState:SetBuild("statue_small")
	inst.AnimState:OverrideSymbol("swap_statue", "statue_small_harp_build", "swap_statue")
	inst.AnimState:PlayAnimation("full")

    inst.AnimState:AddOverrideBuild("statue_small_harp_vine_build")

	inst.MiniMapEntity:SetIcon("statue_small.png")

	inst:AddComponent("inspectable")
	inst:AddComponent("workable")
	inst.components.workable.savestate = true
	inst.components.workable:SetWorkAction(ACTIONS.MINE)
	inst.components.workable:SetWorkLeft(TUNING.MARBLEPILLAR_MINE)
	inst.components.workable:SetOnWorkCallback(OnWorked)
	inst.components.workable:SetOnLoadFn(OnWorkLoad)
	
	inst:AddComponent("pickable")
	inst.components.pickable:SetUp("rose_inv", TUNING.TOTAL_DAY_TIME*3)
	inst.components.pickable.picksound = "dontstarve/wilson/pickup_reeds"
    inst.components.pickable.onpickedfn = onpickedfn
    inst.components.pickable.onregenfn = onregenfn		

    inst.OnLoad = OnLoad
	inst.OnRemoveEntity = OnRemoveEntity
	
	return inst
end

return Prefab("statueharp_rose", fn, assets, prefabs),
    MakePlacer("statueharp_rose_placer", "statue_small", "statue_small", "full")  --Additional changes are in other places (modmain_additional.lua).
