--Sadly the anim causes some problems, so this prefab will not be added in near future.

require("prefabutil")

local assets =
{
	--Asset("ANIM", "anim/treasure_chest.zip"),
    Asset("ANIM", "anim/treasurechest_vintage.zip"),
	Asset("ANIM", "anim/ui_chest_3x3.zip"),	
}

local prefabs = 
{
    "rose_fx",
}

local function SpawnRoseFX(inst)
    SpawnPrefab("rose_fx").Transform:SetPosition(inst.Transform:GetWorldPosition())
end

local function OnWorkFinished(inst, worker)
    if inst.components.container ~= nil then
        inst.components.container:DropEverything()
    end	
    inst.components.lootdropper:DropLoot()
    local fx = SpawnPrefab("collapse_small")
    fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
    fx.SoundEmitter:PlaySound("dontstarve/common/destroy_wood")
    inst:Remove()
end

local function OnWorked(inst, worker)
    if inst.components.container ~= nil then
		inst.components.container:DropEverything()
		inst.components.container:Close()
    end
    inst.AnimState:PlayAnimation("hit")
    inst.AnimState:PushAnimation("closed", false)
end

local function onopen(inst)
    inst.AnimState:PlayAnimation("open")
	inst.SoundEmitter:PlaySound("dontstarve/wilson/chest_open")
	SpawnRoseFX(inst)
end 

local function onclose(inst) 
    inst.AnimState:PlayAnimation("close")
    inst.AnimState:PushAnimation("closed", false)
    inst.SoundEmitter:PlaySound("dontstarve/wilson/chest_close")
	SpawnRoseFX(inst)
end

local function onbuilt(inst)
    inst.AnimState:PlayAnimation("place")
    inst.AnimState:PushAnimation("closed", false)
    inst.SoundEmitter:PlaySound("dontstarve/common/chest_craft")
end

local function SanityAura(inst, observer)
    return observer ~= nil 
	    and observer:HasTag("flower_lover") 
		and TUNING.SANITYAURA_SMALL 
		or 0
end

local BLOCKER_EXCLUDE_TAGS = {"FX", "INLIMBO"}
local function IsPointNearBlocker(pt, range)
    for i, v in ipairs( TheSim:FindEntities(pt.x, 0, pt.z, range, nil, BLOCKER_EXCLUDE_TAGS) ) do
        if v:GetDistanceSqToPoint(pt) < range * range then
            return true
        end
    end
    return false
end

local function IsPointNearFlower(pt, range)
    for i, v in ipairs( TheSim:FindEntities(pt.x, 0, pt.z, range, nil, nil, {"flower", "flower_rainforest"}) ) do
        if v:GetDistanceSqToPoint(pt) < range * range then
            return true
        end
    end
    return false
end

local function IsPointNearWallOrStructure(pt, range)
    for i, v in ipairs( TheSim:FindEntities(pt.x, 0, pt.z, range, nil, nil, {"wall", "structure"}) ) do
        if v:GetDistanceSqToPoint(pt) < range * range then
            return true
        end
    end
    return false
end

local function SpawnFlowerNearby(inst)
    local world = GetWorld()
    local flower_to_spawn = "flower"
	if GetClock() and GetClock():GetMoonPhase() == "full" then
	    flower_to_spawn = "flower_evil"
	end
	if world ~= nil and world:HasTag("porkland") then
	    flower_to_spawn = "flower_rainforest"
	end	
	if math.random() < 0.01 then
	    flower_to_spawn = "flower_rose"
	end	
	if PrefabExists(flower_to_spawn) then
        local pt = inst:GetPosition()
	    local pos = FindWalkableOffset(pt, math.random()*2*math.pi, 12+math.random()*10, 30, true, false)
		if inst.GetIsOnLand ~= nil then
		    pos = FindGroundOffset(pt, math.random()*2*math.pi, 12+math.random()*10, 30, true, false)
		end
        if pos then	    
		    local spawnpt = pt + pos
			if IsPassableAtPoint(spawnpt.x, 0, spawnpt.z)
			    and ( inst.IsPosSurroundedByLand == nil or inst:IsPosSurroundedByLand(spawnpt.x, 0, spawnpt.z, 3) )
				and not IsPointNearBlocker(spawnpt, 1) 	
				and not IsPointNearFlower(spawnpt, 3)
			    and not IsPointNearWallOrStructure(spawnpt, 5) 	 					
			then
			    print("flower spawns from treasurechest_pastoral")
				local fx = SpawnPrefab("small_puff")
			    local flower = SpawnPrefab(flower_to_spawn)
		        flower.Transform:SetPosition(spawnpt.x, 0, spawnpt.z)
				fx.Transform:SetPosition(spawnpt.x, 0, spawnpt.z)
			end
		end	
	end
end

local function onsave(inst, data)
	if inst:HasTag("burnt") or inst:HasTag("fire") then
        data.burnt = true
    end
end

local function onload(inst, data)
	if data and data.burnt and inst.components.burnable then
        inst.components.burnable.onburnt(inst)
    end
end

local slotpos_3x3 = {}

for y = 2, 0, -1 do
	for x = 0, 2 do
		table.insert(slotpos_3x3, Vector3(80*x-80*2+80, 80*y-80*2+80, 0))
	end
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddMiniMapEntity()

    inst.MiniMapEntity:SetIcon("treasurechest_vintage.tex")

    inst.AnimState:SetBank("chest")
    inst.AnimState:SetBuild("treasurechest_vintage")
    inst.AnimState:PlayAnimation("closed")
	
    inst:AddTag("structure")
	inst:AddTag("pogproof")
	inst:AddTag("shadow_destroy_immune")
    inst:AddTag("suitable_for_flower")

    inst:AddComponent("inspectable")

    inst:AddComponent("workable")
    inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
    inst.components.workable:SetWorkLeft(2)
    inst.components.workable:SetOnFinishCallback(OnWorkFinished)
    inst.components.workable:SetOnWorkCallback(OnWorked)
	
    inst:AddComponent("lootdropper")

    inst:AddComponent("container")
    inst.components.container:SetNumSlots(#slotpos_3x3, true)
    inst.components.container.onopenfn = onopen
    inst.components.container.onclosefn = onclose	
    inst.components.container.widgetslotpos = slotpos_3x3
    inst.components.container.widgetanimbank = "ui_chest_3x3"
    inst.components.container.widgetanimbuild = "ui_chest_3x3"
    inst.components.container.widgetpos = Vector3(0, 200, 0)
    inst.components.container.side_align_tip = 160

	inst:AddComponent("sanityaura")
    inst.components.sanityaura.aurafn = SanityAura

    inst:ListenForEvent("onbuilt", onbuilt)
	
	inst.SpawnFlowerTask = inst:DoPeriodicTask(240, SpawnFlowerNearby)

	MakeSmallBurnable(inst, 60, nil, true)
	MakeSmallPropagator(inst)
	
	MakeSnowCovered(inst)

	inst.OnSave = onsave 
    inst.OnLoad = onload

    return inst		
end

return Prefab("treasurechest_pastoral", fn, assets, prefabs),
    MakePlacer("treasurechest_pastoral_placer", "chest", "treasurechest_vintage", "closed")