--Sadly the anim causes some problems, so this prefab will not be added in near future.

require("prefabutil")

local assets =
{
	--Asset("ANIM", "anim/treasure_chest.zip"),
    Asset("ANIM", "anim/treasurechest_cupid.zip"),
	Asset("ANIM", "anim/ui_chest_3x3.zip"),	
}

local fx_assets =
{
	Asset("ANIM", "anim/wathgrithr_spirit.zip"),
}

local prefabs = 
{
    "treasurechest_valentine_day_fx",
}

local fx_prefabs = 
{
    "treasurechest_valentine_day",
}

local function SpawnFX(inst, scale)
    local fx = SpawnPrefab("treasurechest_valentine_day_fx")
    fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
	fx.Transform:SetScale(scale, scale, scale)
end

local function OnWorkFinished(inst, worker)
    if worker ~= nil and worker:HasTag("charlie") then
        if inst.components.container ~= nil then
            inst.components.container:DropEverything()
        end	
        inst.components.lootdropper:DropLoot()
        local fx = SpawnPrefab("collapse_small")
        fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
        fx.SoundEmitter:PlaySound("dontstarve/common/destroy_wood")
        inst:Remove()
	end
end

local function OnWorked(inst, worker, workleft)
    if worker ~= nil and worker:HasTag("charlie") then
        if inst.components.container ~= nil then
		    inst.components.container:DropEverything()
		    inst.components.container:Close()
        end
        inst.AnimState:PlayAnimation("hit")
        inst.AnimState:PushAnimation("closed", false)
	else
	    inst.components.workable:SetWorkLeft(2)
	end
end

local function onopen(inst)
    inst.AnimState:PlayAnimation("open")
	inst.SoundEmitter:PlaySound("dontstarve/wilson/chest_open")
	SpawnFX(inst, 0.5)
end 

local function onclose(inst) 
    inst.AnimState:PlayAnimation("close")
    inst.AnimState:PushAnimation("closed", false)
    inst.SoundEmitter:PlaySound("dontstarve/wilson/chest_close")
	SpawnFX(inst, 0.5)
end

local function onbuilt(inst)
    inst.AnimState:PlayAnimation("place")
    inst.AnimState:PushAnimation("closed", false)
    inst.SoundEmitter:PlaySound("dontstarve/common/chest_craft")
	SpawnFX(inst, 0.5)
end

local function OnIgnite(inst)
    --Extinguish itself
	inst:DoTaskInTime(math.random(), function()
	    if inst.components.burnable ~= nil then
		    SpawnFX(inst, 0.5)
			inst.components.burnable:Extinguish()
		end
	end)
end

local slotpos_3x3 = {}

for y = 2, 0, -1 do
	for x = 0, 2 do
		table.insert(slotpos_3x3, Vector3(80*x-80*2+80, 80*y-80*2+80, 0))
	end
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddMiniMapEntity()

    inst.MiniMapEntity:SetIcon("treasurechest_cupid.tex")

    inst.AnimState:SetBank("chest")
    inst.AnimState:SetBuild("treasurechest_cupid")
    inst.AnimState:PlayAnimation("closed")
	
    inst:AddTag("structure")
	inst:AddTag("pogproof")
	inst:AddTag("shadow_destroy_immune")
    inst:AddTag("valentine_day_chest")

    inst:AddComponent("inspectable")

    inst:AddComponent("workable")
    inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
    inst.components.workable:SetWorkLeft(2)
    inst.components.workable:SetOnFinishCallback(OnWorkFinished)
    inst.components.workable:SetOnWorkCallback(OnWorked)
	
    inst:AddComponent("lootdropper")

    inst:AddComponent("container")
    inst.components.container:SetNumSlots(#slotpos_3x3, true)
    inst.components.container.onopenfn = onopen
    inst.components.container.onclosefn = onclose	
    inst.components.container.widgetslotpos = slotpos_3x3
    inst.components.container.widgetanimbank = "ui_chest_3x3"
    inst.components.container.widgetanimbuild = "ui_chest_3x3"
    inst.components.container.widgetpos = Vector3(0, 200, 0)
    inst.components.container.side_align_tip = 160

    inst:ListenForEvent("onbuilt", onbuilt)

	MakeSmallBurnable(inst, 60, nil, true)
	MakeSmallPropagator(inst)
	
	inst.components.burnable:SetOnIgniteFn(OnIgnite)
	
	MakeSnowCovered(inst)

    return inst		
end

local function fx_fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()

    inst.Transform:SetFourFaced()

    inst:AddTag("FX")
	inst:AddTag("NOCLICK")
	inst:AddTag("NOBLOCK")
	inst:AddTag("INTERIOR_LIMBO_IMMUNE")
	
    inst.persists = false

    inst.AnimState:SetBank("wathgrithr_spirit")
    inst.AnimState:SetBuild("wathgrithr_spirit")
    inst.AnimState:PlayAnimation("wathgrithr_spirit")

    inst:ListenForEvent("animover", inst.Remove)

    return inst
end

return Prefab("treasurechest_valentine_day", fn, assets, prefabs),
    MakePlacer("treasurechest_valentine_day_placer", "chest", "treasurechest_cupid", "closed"),
	Prefab("treasurechest_valentine_day_fx", fx_fn, fx_assets, fx_prefabs)