local assets =
{
	Asset("ANIM", "anim/voidcloth.zip"),
}

local kit_assets =
{
	Asset("ANIM", "anim/voidcloth_kit.zip"),
}

local function OnHitWater(inst)
	if inst.float_fx == nil then
		inst.float_fx = SpawnPrefab("float_fx_front")
		inst.float_fx.entity:SetParent(inst.entity)
		inst.float_fx.AnimState:PlayAnimation("idle_front_large", true)		
		inst.float_fx.Transform:SetScale(0.6, 0.6, 0.6)
	end
	if inst.float_fx2 == nil then
		inst.float_fx2 = SpawnPrefab("float_fx_back")
		inst.float_fx2.entity:SetParent(inst.entity)
		inst.float_fx2.AnimState:PlayAnimation("idle_back_large", true)
		inst.float_fx2.Transform:SetScale(0.6, 0.6, 0.6)
	end	
end

local function OnHitWaterKit(inst)
	if inst.float_fx == nil then
		inst.float_fx = SpawnPrefab("float_fx_front")
		inst.float_fx.entity:SetParent(inst.entity)
		inst.float_fx.AnimState:PlayAnimation("idle_front_small", true)		
		inst.float_fx.Transform:SetScale(1.4, 1, 1)
		inst.float_fx.Transform:SetPosition(0, 0.1, 0)
	end
	if inst.float_fx2 == nil then
		inst.float_fx2 = SpawnPrefab("float_fx_back")
		inst.float_fx2.entity:SetParent(inst.entity)
		inst.float_fx2.AnimState:PlayAnimation("idle_back_small", true)
		inst.float_fx2.Transform:SetScale(1.4, 1, 1)
		inst.float_fx2.Transform:SetPosition(0, 0.1, 0)
	end	
end

local function OnHitLand(inst)
	if inst.float_fx ~= nil then
		inst.float_fx:Remove()
		inst.float_fx = nil
	end
	if inst.float_fx2 ~= nil then
		inst.float_fx2:Remove()
		inst.float_fx2 = nil
	end	
end

local function fn()
	local inst = CreateEntity()

	inst.entity:AddTransform()
	inst.entity:AddAnimState()

	MakeInventoryPhysics(inst)

	inst.AnimState:SetBank("voidcloth")
	inst.AnimState:SetBuild("voidcloth")
	inst.AnimState:PlayAnimation("idle")
	
	inst:AddTag("fountain_altar_sacrifice")

	inst:AddComponent("inspectable")
	
	inst:AddComponent("inventoryitem")
	
	inst:AddComponent("stackable")
	inst.components.stackable.maxsize = TUNING.STACK_SIZE_MEDITEM

	if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
	    inst:AddComponent("floatable")
		inst.components.floatable:SetOnHitWaterFn(OnHitWater)
		inst.components.floatable:SetOnHitLandFn(OnHitLand)
		inst.components.inventoryitem:SetOnPutInInventoryFn(OnHitLand)
	end

	return inst
end

local function kit_fn()
	local inst = CreateEntity()

	inst.entity:AddTransform()
	inst.entity:AddAnimState()

	MakeInventoryPhysics(inst)

	inst.AnimState:SetBank("voidcloth_kit")
	inst.AnimState:SetBuild("voidcloth_kit")
	inst.AnimState:PlayAnimation("idle")

	inst:AddComponent("inspectable")
	
	inst:AddComponent("inventoryitem")
	
	inst:AddComponent("stackable")
	inst.components.stackable.maxsize = TUNING.STACK_SIZE_LARGEITEM

    inst:AddComponent("shadowrepairer")
	inst.components.shadowrepairer:SetRepairMaterial("voidcloth")

	if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
	    inst:AddComponent("floatable")
		inst.components.floatable:SetOnHitWaterFn(OnHitWaterKit)
		inst.components.floatable:SetOnHitLandFn(OnHitLand)
		inst.components.inventoryitem:SetOnPutInInventoryFn(OnHitLand)
	end

	return inst
end

return Prefab("voidcloth", fn, assets),
    Prefab("voidcloth_kit", kit_fn, kit_assets)
