local Screen = require "widgets/screen"
local Button = require "widgets/button"
local AnimButton = require "widgets/animbutton"
local ImageButton = require "widgets/imagebutton"
local Menu = require "widgets/menu"
local Text = require "widgets/text"
local Image = require "widgets/image"
local UIAnim = require "widgets/uianim"
local Widget = require "widgets/widget"
local PopupDialogScreen = require "screens/popupdialog"

function GetCharlieTaskRose()
    return TheSim:FindFirstEntityWithTag("charlie_rose_valentine_day")
end

local CharlieValentineDayScreen = Class(Screen, function(self)
    Screen._ctor(self, "CharlieValentineDayScreen")
	
    self.active = true

    self.black = self:AddChild(Image("images/global.xml", "square.tex"))
    self.black:SetVRegPoint(ANCHOR_MIDDLE)
    self.black:SetHRegPoint(ANCHOR_MIDDLE)
    self.black:SetVAnchor(ANCHOR_MIDDLE)
    self.black:SetHAnchor(ANCHOR_MIDDLE)
    self.black:SetScaleMode(SCALEMODE_FILLSCREEN)
	self.black:SetTint(0.5, 0.5, 0.5, 0.5)	

	self.proot = self:AddChild(Widget("ROOT"))
    self.proot:SetVAnchor(ANCHOR_MIDDLE)
    self.proot:SetHAnchor(ANCHOR_MIDDLE)
    self.proot:SetPosition(0, 0, 0)
    self.proot:SetScaleMode(SCALEMODE_PROPORTIONAL)
	
    self.bg = self.proot:AddChild(Image("images/globalpanels.xml", "panel_upsell.tex"))
    self.bg:SetVRegPoint(ANCHOR_MIDDLE)
    self.bg:SetHRegPoint(ANCHOR_MIDDLE)	
	self.bg:SetTint(1, 1, 1, 1)

    self.title = self.proot:AddChild(Text(TITLEFONT, 50))
    self.title:SetPosition(0, 285, 0)
    self.title:SetString(STRINGS.UI.CHARLIEVALENTINEDAY.TITLE)
	
    self.text = self.proot:AddChild(Text(BODYTEXTFONT, 30))
    self.text:SetVAlign(ANCHOR_TOP)
    self.text:SetPosition(0, 20, 0)
    self.text:SetString(STRINGS.UI.CHARLIEVALENTINEDAY.TEXT)
    self.text:EnableWordWrap(true)
    self.text:SetRegionSize(750, 400)	
	
	self.task_bubble = self.proot:AddChild(UIAnim())
	self.task_bubble:GetAnimState():SetBank("charlie_valentine_day_four_items")
	self.task_bubble:GetAnimState():SetBuild("charlie_valentine_day_four_items")
	self.task_bubble:GetAnimState():PlayAnimation("bubble")
	self.task_bubble:SetScale(0.5, 0.5, 0.5)
	self.task_bubble:SetPosition(-50, 110, 0)
	self.task_bubble:SetClickable(false)
	
	self.task_coffee = self.proot:AddChild(UIAnim())
	self.task_coffee:GetAnimState():SetBank("charlie_valentine_day_four_items")
	self.task_coffee:GetAnimState():SetBuild("charlie_valentine_day_four_items")
	self.task_coffee:GetAnimState():PlayAnimation("coffee")
	self.task_coffee:SetScale(0.5, 0.5, 0.5)
	self.task_coffee:SetPosition(50, 110, 0)
	self.task_coffee:SetClickable(false)
	
	self.task_envelope = self.proot:AddChild(UIAnim())
	self.task_envelope:GetAnimState():SetBank("charlie_valentine_day_four_items")
	self.task_envelope:GetAnimState():SetBuild("charlie_valentine_day_four_items")
	self.task_envelope:GetAnimState():PlayAnimation("envelope")
	self.task_envelope:SetScale(0.5, 0.5, 0.5)
	self.task_envelope:SetPosition(-50, -25, 0)
	self.task_envelope:SetClickable(false)
	
	self.task_gift = self.proot:AddChild(UIAnim())
	self.task_gift:GetAnimState():SetBank("charlie_valentine_day_four_items")
	self.task_gift:GetAnimState():SetBuild("charlie_valentine_day_four_items")
	self.task_gift:GetAnimState():PlayAnimation("gift")
	self.task_gift:SetScale(0.5, 0.5, 0.5)
	self.task_gift:SetPosition(50, -25, 0)
	self.task_gift:SetClickable(false)

	self.yesbuttoon1 = self.proot:AddChild(Image("images/charlieyesbuttoon.xml", "charlieyesbuttoon.tex"))
	self.yesbuttoon1:SetPosition(-50, 80, 0)  
	self.yesbuttoon1:SetScale(0.5, 0.5, 0.5)	
	
	self.yesbuttoon2 = self.proot:AddChild(Image("images/charlieyesbuttoon.xml", "charlieyesbuttoon.tex"))
	self.yesbuttoon2:SetPosition(45, 80, 0)  
	self.yesbuttoon2:SetScale(0.5, 0.5, 0.5)
	
	self.yesbuttoon3 = self.proot:AddChild(Image("images/charlieyesbuttoon.xml", "charlieyesbuttoon.tex"))
	self.yesbuttoon3:SetPosition(-50, -50, 0)  
	self.yesbuttoon3:SetScale(0.5, 0.5, 0.5)
	
	self.yesbuttoon4 = self.proot:AddChild(Image("images/charlieyesbuttoon.xml", "charlieyesbuttoon.tex"))
	self.yesbuttoon4:SetPosition(45, -50, 0)  
	self.yesbuttoon4:SetScale(0.5, 0.5, 0.5)
	
	self.nobuttoon1 = self.proot:AddChild(Image("images/charlienobuttoon.xml", "charlienobuttoon.tex"))
	self.nobuttoon1:SetPosition(-50, 80, 0)  
	self.nobuttoon1:SetScale(0.5, 0.5, 0.5)	
	
	self.nobuttoon2 = self.proot:AddChild(Image("images/charlienobuttoon.xml", "charlienobuttoon.tex"))
	self.nobuttoon2:SetPosition(45, 80, 0)  
	self.nobuttoon2:SetScale(0.5, 0.5, 0.5)
	
	self.nobuttoon3 = self.proot:AddChild(Image("images/charlienobuttoon.xml", "charlienobuttoon.tex"))
	self.nobuttoon3:SetPosition(-50, -50, 0)  
	self.nobuttoon3:SetScale(0.5, 0.5, 0.5)
	
	self.nobuttoon4 = self.proot:AddChild(Image("images/charlienobuttoon.xml", "charlienobuttoon.tex"))
	self.nobuttoon4:SetPosition(45, -50, 0)  
	self.nobuttoon4:SetScale(0.5, 0.5, 0.5)	
	
	if GetCharlieTaskRose() and GetCharlieTaskRose().bubbletaskfinished then
	    self.nobuttoon1:Hide()
	else
	    self.yesbuttoon1:Hide()
	end
	
	if GetCharlieTaskRose() and GetCharlieTaskRose().coffeetaskfinished then
	    self.nobuttoon2:Hide()
	else
	    self.yesbuttoon2:Hide()
	end
	
	if GetCharlieTaskRose() and GetCharlieTaskRose().envelopetaskfinished then
	    self.nobuttoon3:Hide()
	else
	    self.yesbuttoon3:Hide()
	end
	
	if GetCharlieTaskRose() and GetCharlieTaskRose().gifttaskfinished then
	    self.nobuttoon4:Hide()
	else
	    self.yesbuttoon4:Hide()
	end
	
	if GetCharlieTaskRose() 
	    and GetCharlieTaskRose().gifttaskfinished 
	    and GetCharlieTaskRose().coffeetaskfinished
		and GetCharlieTaskRose().envelopetaskfinished
		and GetCharlieTaskRose().gifttaskfinished
	then
        self.tasks_finished_text = self.proot:AddChild(Text(BODYTEXTFONT, 30))
        self.tasks_finished_text:SetVAlign(ANCHOR_TOP)
        self.tasks_finished_text:SetPosition(0, -275, 0)
        self.tasks_finished_text:SetString(STRINGS.UI.CHARLIEVALENTINEDAY.TASKS_FINISHED_TEXT)
        self.tasks_finished_text:EnableWordWrap(true)
        self.tasks_finished_text:SetRegionSize(750, 400)	
		
	    self.tasks_finsihed_wine = self.proot:AddChild(UIAnim())
	    self.tasks_finsihed_wine:GetAnimState():SetBank("charlie_wine")
	    self.tasks_finsihed_wine:GetAnimState():SetBuild("charlie_wine")
	    self.tasks_finsihed_wine:GetAnimState():PlayAnimation("idle")
	    self.tasks_finsihed_wine:SetPosition(-200, -220, 0)
		self.tasks_finsihed_wine:SetScale(0.5, 0.5, 0.5)
	    self.tasks_finsihed_wine:SetClickable(false)		

	    self.tasks_finsihed_heartcore = self.proot:AddChild(UIAnim())
	    self.tasks_finsihed_heartcore:GetAnimState():SetBank("charlie_heart_core")
	    self.tasks_finsihed_heartcore:GetAnimState():SetBuild("charlie_heart_core")
	    self.tasks_finsihed_heartcore:GetAnimState():PlayAnimation("idle3")
	    self.tasks_finsihed_heartcore:SetPosition(0, -220, 0)
		self.tasks_finsihed_heartcore:SetScale(0.5, 0.5, 0.5)
	    self.tasks_finsihed_heartcore:SetClickable(false)
		
	    self.tasks_finsihed_rosegroup = self.proot:AddChild(UIAnim())
	    self.tasks_finsihed_rosegroup:GetAnimState():SetBank("charlie_rose_group")
	    self.tasks_finsihed_rosegroup:GetAnimState():SetBuild("charlie_rose_group")
	    self.tasks_finsihed_rosegroup:GetAnimState():PlayAnimation("idle")
	    self.tasks_finsihed_rosegroup:SetPosition(240, -220, 0)
		self.tasks_finsihed_rosegroup:SetScale(0.5, 0.5, 0.5)
	    self.tasks_finsihed_rosegroup:SetClickable(false)
	end

	local button_w = 160
	
	local buttons = {}
	table.insert(buttons, {text = STRINGS.UI.CHARLIESKILLTREE.EXIT, cb = function() 
	    TheFrontEnd:PopScreen(self) 	        
	end})

	self.menu = self.proot:AddChild(Menu(buttons, button_w, true))
	self.menu:SetPosition(0, -300, 0)

	TheInputProxy:SetCursorVisible(true)
	self.default_focus = self.menu
	
end)

function CharlieValentineDayScreen:OnBecomeActive()
	CharlieValentineDayScreen._base.OnBecomeActive(self)
	TheFrontEnd:HideTopFade()
end

return CharlieValentineDayScreen

