
AddStategraphState("wilson", 
    State{ 
        name = "change_skin",
        tags = {"busy", "doing", "pausepredict", "nomorph", "nodangle"},
		onenter = function(inst, anim)
            if inst.sg.statemem.anim == nil then			
				inst.sg.statemem.anim = anim
			end
            inst.AnimState:OverrideSymbol("shadow_hands", "shadow_skinchangefx", "shadow_hands")
            inst.AnimState:OverrideSymbol("shadow_ball", "shadow_skinchangefx", "shadow_ball")
            inst.AnimState:OverrideSymbol("splode", "shadow_skinchangefx", "splode")  
            inst.AnimState:PlayAnimation("skin_change", false)			
		end,
        onexit = function(inst)
			inst.AnimState:OverrideSymbol("shadow_hands", "shadow_hands", "shadow_hands")
        end,
		timeline = {
			TimeEvent(1.5, function(inst)	
			if inst.prefab == "wolfgang" then 
				if inst.sg.statemem.anim == "wolfgang" then
				    if inst.build ~= nil then
				        inst.build = nil
				    end	
				else
				    inst.build = inst.sg.statemem.anim
				end
				if inst.strength == "mighty" then 
					inst.AnimState:SetBuild(inst.sg.statemem.anim.."_mighty")
					if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
					    inst.AnimState:OverrideSymbol("torso_pelvis", inst.sg.statemem.anim.."_mighty", "torso" ) 
					    inst.AnimState:OverrideSymbol("torso", inst.sg.statemem.anim.."_mighty", "torso_pelvis" )
					    inst.AnimState:OverrideSymbol("paddle", inst.prefab, "paddle")
					end
				elseif inst.strength == "wimpy" then
					inst.AnimState:SetBuild(inst.sg.statemem.anim.."_skinny")
					if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
					    inst.AnimState:OverrideSymbol("torso_pelvis", inst.sg.statemem.anim.."_skinny", "torso" ) 
					    inst.AnimState:OverrideSymbol("torso", inst.sg.statemem.anim.."_skinny", "torso_pelvis" ) 
					    inst.AnimState:OverrideSymbol("paddle", inst.prefab, "paddle")
					end
				else
					inst.AnimState:SetBuild(inst.sg.statemem.anim)
					if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
					    inst.AnimState:OverrideSymbol("torso_pelvis", inst.sg.statemem.anim, "torso" ) 
				    	inst.AnimState:OverrideSymbol("torso", inst.sg.statemem.anim, "torso_pelvis" ) 
				    	inst.AnimState:OverrideSymbol("paddle", inst.prefab, "paddle")
					end
				end	
			elseif not (inst.components.transformable ~= nil and inst.components.transformable.shadowform) then
				inst.AnimState:SetBuild(inst.sg.statemem.anim)
				inst.AnimState:OverrideSymbol("torso", inst.sg.statemem.anim, "torso" )	
				inst.AnimState:OverrideSymbol("torso_pelvis", inst.sg.statemem.anim, "torso_pelvis" )
				if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
					inst.AnimState:OverrideSymbol("paddle", inst.prefab, "paddle")
				end
			end
				if inst.components.dsskins ~= nil then
					inst.components.dsskins.skin = inst.sg.statemem.anim
				end
                if inst.sg.statemem.anim ~= nil then
                    inst.sg.statemem.anim = nil
                end	
			
			end),
		},
		events=
        {
			EventHandler("animqueueover", function(inst) 
			    inst.sg:GoToState("idle") 
			end),
        },
    }
)

AddStategraphState("wilsonboating", 
    State{ 
        name = "change_skin",
        tags = {"busy", "doing", "pausepredict", "nomorph", "nodangle"},
		onenter = function(inst, anim)
            if inst.sg.statemem.anim == nil then			
				inst.sg.statemem.anim = anim
			end
            inst.AnimState:OverrideSymbol("shadow_hands", "shadow_skinchangefx", "shadow_hands")
            inst.AnimState:OverrideSymbol("shadow_ball", "shadow_skinchangefx", "shadow_ball")
            inst.AnimState:OverrideSymbol("splode", "shadow_skinchangefx", "splode")  
            inst.AnimState:PlayAnimation("skin_change", false)
			local vehicle = inst.components.driver and inst.components.driver.vehicle or nil
            local downvec = TheCamera:GetDownVec()
            local facedown = -(math.atan2(downvec.z, downvec.x) * (180/math.pi))	
            if vehicle ~= nil then 
                inst.components.driver.combined = false
                vehicle.Transform:SetRotation(facedown)
			    vehicle:Show() 		
			end			
		end,
        onexit = function(inst)
			inst.AnimState:OverrideSymbol("shadow_hands", "shadow_hands", "shadow_hands")
        end,
		timeline = {
			TimeEvent(1.5, function(inst)	
			if inst.prefab == "wolfgang" then 
				if inst.sg.statemem.anim == "wolfgang" then
				    if inst.build ~= nil then
				        inst.build = nil
				    end	
				else
				    inst.build = inst.sg.statemem.anim
				end
				if inst.strength == "mighty" then 
					inst.AnimState:SetBuild(inst.sg.statemem.anim.."_mighty")
					if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
					    inst.AnimState:OverrideSymbol("torso_pelvis", inst.sg.statemem.anim.."_mighty", "torso" ) 
					    inst.AnimState:OverrideSymbol("torso", inst.sg.statemem.anim.."_mighty", "torso_pelvis" )
					    inst.AnimState:OverrideSymbol("paddle", inst.prefab, "paddle")
					end
				elseif inst.strength == "wimpy" then
					inst.AnimState:SetBuild(inst.sg.statemem.anim.."_skinny")
					if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
					    inst.AnimState:OverrideSymbol("torso_pelvis", inst.sg.statemem.anim.."_skinny", "torso" ) 
					    inst.AnimState:OverrideSymbol("torso", inst.sg.statemem.anim.."_skinny", "torso_pelvis" ) 
					    inst.AnimState:OverrideSymbol("paddle", inst.prefab, "paddle")
					end
				else
					inst.AnimState:SetBuild(inst.sg.statemem.anim)
					if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
					    inst.AnimState:OverrideSymbol("torso_pelvis", inst.sg.statemem.anim, "torso" ) 
				    	inst.AnimState:OverrideSymbol("torso", inst.sg.statemem.anim, "torso_pelvis" ) 
				    	inst.AnimState:OverrideSymbol("paddle", inst.prefab, "paddle")
					end
				end	
			elseif not (inst.components.transformable ~= nil and inst.components.transformable.shadowform) then
				inst.AnimState:SetBuild(inst.sg.statemem.anim)
				inst.AnimState:OverrideSymbol("torso", inst.sg.statemem.anim, "torso" )	
				inst.AnimState:OverrideSymbol("torso_pelvis", inst.sg.statemem.anim, "torso_pelvis" )
				if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
					inst.AnimState:OverrideSymbol("paddle", inst.prefab, "paddle")
				end
			end
				if inst.components.dsskins ~= nil then
					inst.components.dsskins.skin = inst.sg.statemem.anim
				end
                if inst.sg.statemem.anim ~= nil then
                    inst.sg.statemem.anim = nil
                end	
			
			end),
		},
		events=
        {
			EventHandler("animqueueover", function(inst) 
			    inst.sg:GoToState("idle") 
			    local vehicle = inst.components.driver and inst.components.driver.vehicle or nil
                if vehicle ~= nil then 
                    inst.components.driver.combined = true
			        vehicle:Hide() 		
			    end				
			end),
        },
    }
)