require("stategraphs/commonstates")

local events =
{
    CommonHandlers.OnLocomote(true, true),
    CommonHandlers.OnAttack(),
    CommonHandlers.OnDeath(),
}

local function return_to_idle(inst)
    inst.sg:GoToState("idle")
end

local states =
{
    State{
        name = "idle",
        tags = {"idle", "canrotate"},

        onenter = function(inst)
            inst.AnimState:PlayAnimation("idle")
        end,

        timeline=
        {

        },

        events =
        {
            EventHandler("animover", function(inst)
			    inst.sg:GoToState("idle")
			end),
        },
    },

    State{
        name = "death",
        tags = {"busy"},

        onenter = function(inst)
		    inst.components.locomotor:Stop()
			inst.SoundEmitter:PlaySound("dontstarve/common/fireOut")	
        end,

        timeline =
        {
            TimeEvent(15*FRAMES, function(inst)
                local pos = inst:GetPosition()
                inst.components.lootdropper:DropLoot(pos)
				local explode_small = SpawnPrefab("explode_small")
				local x, y, z = inst.Transform:GetWorldPosition()
		        explode_small.Transform:SetPosition(x, y + 0.25, z)
				explode_small.Transform:SetScale(2, 2, 2)
                SpawnPrefab("charlie_critter_dragon_mini").Transform:SetPosition(x, y, z)	
            end),
        },

        events =
        {
            EventHandler("animover", function(inst)
                inst.SoundEmitter:PlaySound("dontstarve/common/fireOut")
            end),
        }
    },

    State{
        name = "attack",
        tags = {"attack", "canrotate"},

        onenter = function(inst)
		    inst.components.locomotor:StopMoving()
            inst.components.combat:StartAttack()
			inst.SoundEmitter:PlaySound("dontstarve/wilson/fireball_explo")
        end,

        timeline =
        {
            TimeEvent(10*FRAMES, function(inst)
                inst.components.combat:DoAttack()
                inst.SoundEmitter:PlaySound("dontstarve/wilson/fireball_explo")				
            end),
        },

        events =
        {
            EventHandler("animover", return_to_idle),
        },
    },
}

CommonStates.AddSimpleRunStates(states, "idle")
CommonStates.AddSimpleWalkStates(states, "idle")

return StateGraph("charliedragon", states, events, "idle")
