local function PlaySound(inst, sound, id)
    --if inst.sounds[sound] ~= nil and (id == nil or not inst.SoundEmitter:PlayingSound(id)) then
    --    inst.SoundEmitter:PlaySound(inst.sounds[sound], id)
    --end
end

local function PlayAnimation(inst, anim, loop, update_while_paused)
   -- inst.AnimState:AnimateWhilePaused(update_while_paused)
    inst.AnimState:PlayAnimation(anim, loop)
end

local function PushAnimation(inst, anim, loop)
    inst.AnimState:PushAnimation(anim, loop)
end

local states =
{
    State{
        name = "idle",
        tags = { "idle" },

        onenter = function(inst)
            --Construction portals only, otherwise should just be both nil
            --if inst.sg.mem.targetconstructionphase ~= inst.sg.mem.constructionphase then
            --    inst.sg:GoToState("constructionphase"..tostring(inst.sg.mem.constructionphase + 1))
            --    return
            --end

            PlayAnimation(inst, "idle_loop")
            --PlaySound(inst, "blink")
            --PlaySound(inst, "jacob")
            --PlaySound(inst, "idle_loop", "portalidle")
        end,

        events =
        {
            EventHandler("animover", function(inst)
                --inst.sg:GoToState(math.random() < .3 and "funnyidle" or "idle")
				inst.sg:GoToState("idle")
            end),
        },

        timeline =
        {
            --TimeEvent(1 * FRAMES, function(inst) PlaySound(inst, "blink") end),
            --TimeEvent(9 * FRAMES, function(inst) PlaySound(inst, "vines") end),
            --TimeEvent(18 * FRAMES, function(inst) PlaySound(inst, "vines") end),
            --TimeEvent(30 * FRAMES, function(inst) PlaySound(inst, "jacob") end),
        },
    },

    State{
        name = "funnyidle",
        tags = { "idle", "canrotate" },

        onenter = function(inst)
            PlayAnimation(inst, "idle_eyescratch")
            --PlaySound(inst, "blink")
            --PlaySound(inst, "jacob")
        end,

        events =
        {
            EventHandler("animover", function(inst)
                inst.sg:GoToState("idle")
            end),
        },

        timeline =
        {
          --  TimeEvent(1 * FRAMES, function(inst) PlaySound(inst, "blink") end),
            --TimeEvent(9 * FRAMES, function(inst) PlaySound(inst, "idle") end),
            --TimeEvent(18 * FRAMES, function(inst) PlaySound(inst, "idle") end),
            --TimeEvent(13 * FRAMES, function(inst) PlaySound(inst, "scratch") end),
            --TimeEvent(27 * FRAMES, function(inst) PlaySound(inst, "scratch") end),
           -- TimeEvent(30 * FRAMES, function(inst) PlaySound(inst, "jacob") end),
            --TimeEvent(41 * FRAMES, function(inst) PlaySound(inst, "scratch") end),
            --TimeEvent(59 * FRAMES, function(inst) PlaySound(inst, "blink") end),
        },
    },

    State{
        name = "spawn_pre",
        tags = { "idle", "open" },
        onenter = function(inst, update_while_paused)
            --inst.sg.statemem.update_while_paused = update_while_paused
            PlayAnimation(inst, "pre_fx", nil, update_while_paused)
          --  inst.SoundEmitter:KillSound("portalidle")
           -- PlaySound(inst, "spawning_loop", "portalactivate")
           -- PlaySound(inst, "armswing")
           -- PlaySound(inst, "shake")
        end,

        events =
        {
            EventHandler("animover", function(inst)
               -- inst.sg.statemem.keepactivatesound = true
                inst.sg:GoToState("spawn_loop"--[[, inst.sg.statemem.update_while_paused]])
            end),
        },

        timeline =
        {
            TimeEvent(11 * FRAMES, function(inst) --[[PlaySound(inst, "blink")]] end),
        },

        onexit = function(inst)
            --if not inst.sg.statemem.keepactivatesound then
            --    inst.SoundEmitter:KillSound("portalactivate")
            --end
        end,
    },

    State{
        name = "spawn_loop",
        tags = { "busy", "open" },
        onenter = function(inst, update_while_paused)
           -- inst.sg.statemem.update_while_paused = update_while_paused
            PlayAnimation(inst, "fx", nil, update_while_paused)
           -- PlaySound(inst, "idle_loop", "portalidle")
        end,

        events =
        {
            EventHandler("animover", function(inst)
                inst.sg:GoToState("spawn_pst"--[[, inst.sg.statemem.update_while_paused]])
            end),
        },

        timeline =
        {
            TimeEvent(55 * FRAMES, function(inst) --[[PlaySound(inst, "open")]] end),
        },

        onexit = function(inst)
            --inst.SoundEmitter:KillSound("portalactivate")
        end,
    },

    State{
        name = "spawn_pst",
        tags = { "busy" },
        onenter = function(inst, update_while_paused)
            PlayAnimation(inst, "pst_fx", nil, update_while_paused)
        end,

        events =
        {
            EventHandler("animover", function(inst)
                --PlaySound(inst, "blink")
                inst.sg:GoToState("idle")
            end),
        },

        timeline =
        {
            TimeEvent(12 * FRAMES, function(inst)
                inst.sg:RemoveStateTag("busy")
            end),
            TimeEvent(22 * FRAMES, function(inst) --[[PlaySound(inst, "armswing")]] end),
        },
    },
	
}

return StateGraph("charlie_portal", states, {}, "idle")
